2014-07-22  Dana Burkart  <dburkart@apple.com>

        Merge r152704.

    2013-07-15  Kangil Han  <kangil.han@samsung.com>

            Introduce toHTMLIFrameElement
            https://bugs.webkit.org/show_bug.cgi?id=118672

            Reviewed by Ryosuke Niwa.

            To avoid direct use of static_cast, this patch introduces toHTMLIFrameElement for code cleanup.

            * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.cpp:
            (WebKit::InjectedBundleNodeHandle::htmlIFrameElementContentFrame):

2014-07-22  Dana Burkart  <dburkart@apple.com>

        Merge r169448

    2014-05-29  Alexey Proskuryakov  <ap@apple.com>

            [Mac] Always use plug-in sandbox with sandboxed clients
            https://bugs.webkit.org/show_bug.cgi?id=133358
            <rdar://problem/15637695>

            Reviewed by Anders Carlsson.

            * PluginProcess/mac/PluginProcessMac.mm: (WebKit::PluginProcess::initializeSandbox):
            Refuse to start if parent process is sandboxed, and plug-in process is not going to be.
            None of this should run in normal case, because there are also checks on UI process side.
            
            * Shared/Plugins/PluginModuleInfo.h:
            * Shared/Plugins/Netscape/mac/NetscapePluginModuleMac.mm:
            (WebKit::NetscapePluginModule::getPluginInfo):
            Added a member to PluginModuleInfo, telling whether the plug-in has a sandbox profile.

            * Shared/Plugins/Netscape/mac/PluginInformationMac.mm:
            (WebKit::getPlatformPluginModuleInformation): Use the new PluginModuleInfo member,
            we no longer need to check the file system here.

            * WebKit2.xcodeproj/project.pbxproj:
            * Shared/mac/SandboxUtilities.h: Added.
            * Shared/mac/SandboxUtilities.cpp: Added. (WebKit::processIsSandboxed):
            This code is simple, but include magic is not. Moved it to a separate file to
            avoid repeating.

            * UIProcess/API/C/mac/WKContextPrivateMac.mm: Removed an unused include.

            * UIProcess/Plugins/mac/PluginInfoStoreMac.mm:
            (WebKit::PluginInfoStore::shouldUsePlugin): Don't use unsandboxed plug-ins in
            sandboxed applications.

            * UIProcess/Plugins/mac/PluginProcessProxyMac.mm:
            (WebKit::PluginProcessProxy::platformGetLaunchOptions): Don't ever pass disable-sandbox
            from sandboxed processes.

            * Shared/EntryPointUtilities/mac/XPCService/XPCServiceEntryPoint.mm:
            (WebKit::XPCServiceInitializerDelegate::isClientSandboxed):
            Use the new shared code in SandboxUtilities.h.

2014-07-19  Lucas Forschler  <lforschler@apple.com>

        Merge r169757

    2014-06-10  Alexey Proskuryakov  <ap@apple.com>

            Fix crashes on some plug-in tests.
            https://bugs.webkit.org/show_bug.cgi?id=133691
            <rdar://problem/17255836>

            Reviewed by Anders Carlsson.

            * PluginProcess/PluginControllerProxy.cpp: (WebKit::PluginControllerProxy::initialize):
            Cannot use TemporaryChange here, because the object may go away before stack unwinds.

2014-04-30  Lucas Forschler  <lforschler@apple.com>

        Merge r166810

    2014-04-04  Alexey Proskuryakov  <ap@apple.com>

            Improve error checking in WebPageProxy::didReceiveEvent
            https://bugs.webkit.org/show_bug.cgi?id=131243
            <rdar://problem/16529207>

            Reviewed by Anders Carlsson.

            * UIProcess/WebPageProxy.cpp: (WebKit::WebPageProxy::didReceiveEvent):

2014-03-21  Matthew Hanson  <matthew_hanson@apple.com>

        Merge r166026.

    2014-03-20  Alexey Proskuryakov  <ap@apple.com>
    
            Generalize WebInspector check in maybeInitializeSandboxExtensionHandle().
            https://bugs.webkit.org/show_bug.cgi?id=130079
            <rdar://problem/16286683>
    
            Reviewed by Anders Carlsson.
    
            * UIProcess/WebPageProxy.cpp: (WebKit::WebPageProxy::maybeInitializeSandboxExtensionHandle):
            Perform an early return for all paths that don't need a sandbox extension due to
            access being assumed, not only for WebInspector pages.
    
            * UIProcess/WebProcessProxy.cpp:
            (WebKit::WebProcessProxy::hasAssumedReadAccessToURL):
            (WebKit::WebProcessProxy::checkURLReceivedFromWebProcess):
            * UIProcess/WebProcessProxy.h:
            Factored out m_localPathsWithAssumedReadAccess iteration to a public function.
    
2014-03-17  Matthew Hanson  <matthew_hanson@apple.com>

        Merge r165657.

    2014-03-14  Alexey Proskuryakov  <ap@apple.com>
    
            [Mac] Sync extended attribute related rules with AppSandbox profile
            https://bugs.webkit.org/show_bug.cgi?id=130263
            <rdar://problem/16318965>
    
            Reviewed by Sam Weinig.
    
            * NetworkProcess/mac/com.apple.WebKit.NetworkProcess.sb.in:
            * Resources/PlugInSandboxProfiles/com.apple.QuickTime Plugin.plugin.sb:
            * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:
            * Resources/PlugInSandboxProfiles/com.apple.ist.ds.appleconnect.webplugin.sb:
            * Resources/PlugInSandboxProfiles/com.macromedia.Flash Player.plugin.sb:
            * Resources/PlugInSandboxProfiles/com.microsoft.SilverlightPlugin.sb:
            * Resources/PlugInSandboxProfiles/com.oracle.java.JavaAppletPlugin.sb:
            * WebProcess/com.apple.WebProcess.sb.in:
    
2014-02-12  Matthew Hanson  <matthew_hanson@apple.com>

        Merge r162679.

    2014-01-23  Jon Honeycutt  <jhoneycutt@apple.com>

            Assertion failure in WebCore::PseudoElement::didRecalcStyle()
            <https://bugs.webkit.org/show_bug.cgi?id=126761>
            <rdar://problem/15793540>

            Reviewed by Andy Estes.

            * WebProcess/WebPage/ios/WebPageIOS.mm:
            (WebKit::WebPage::getPositionInformation):
            Check isRenderImage() rather than isImage() before casting to
            RenderImage.

2013-12-11  Lucas Forschler  <lforschler@apple.com>

        Merge r159173

    2013-11-12  Anders Carlsson  <andersca@apple.com>

            fast/canvas/webgl/draw-arrays-out-of-bounds.html is flaky on Mavericks WK2 testers, fails about 20% of the time
            https://bugs.webkit.org/show_bug.cgi?id=124223
            <rdar://problem/15333977>

            Reviewed by Tim Horton.

            It's wrong to use DataReferences in sync IPC replies; the underlying MessageDecoder will be freed after the call to
            sendSync returns and the DataReference will point to freed memory. Use a Vector<char> instead.

            * NetworkProcess/NetworkConnectionToWebProcess.messages.in:
            * NetworkProcess/SynchronousNetworkLoaderClient.cpp:
            (WebKit::SynchronousNetworkLoaderClient::didReceiveBuffer):
            (WebKit::SynchronousNetworkLoaderClient::sendDelayedReply):
            * NetworkProcess/SynchronousNetworkLoaderClient.h:
            * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
            (WebKit::WebPlatformStrategies::loadResourceSynchronously):

2013-10-21  Lucas Forschler  <lforschler@apple.com>

        Merge r154183

    2013-08-16  Brady Eidson  <beidson@apple.com>

            (NetworkProcess)  Sync XHRs should load using async ResourceHandles, not ResourceHandle::loadResourceSynchronously
            https://bugs.webkit.org/show_bug.cgi?id=119493

            Reviewed by Alexey Proskuryakov.

            This patch does the following:
              - Consolidates SchedulableLoader and NetworkResourceLoader into one class.
              - Removes SyncNetworkResourceLoader.
              - Adds a NetworkLoaderClient interface that customizes certain behaviors of the NetworkResourceLoader.
              - Implements a SynchronousNetworkLoaderClient and AsynchronousNetworkLoaderClient for the two different types of loads.

            The AsynchronousNetworkLoaderClient results in messaging back progress to the WebProcess as the load progresses.
            The SynchronousNetworkLoaderClient accumulates the response, data, and error to be communicated back to the WebProcess
            only when the load is complete.

            Update small swaths of code to reflect that NetworkResourceLoader is the One True Loader (tm):
            * NetworkProcess/HostRecord.cpp:
            (WebKit::HostRecord::scheduleResourceLoader):
            (WebKit::HostRecord::addLoaderInProgress):
            (WebKit::removeLoaderFromQueue):
            (WebKit::HostRecord::removeLoader):
            (WebKit::HostRecord::servePendingRequestsForQueue):
            (WebKit::HostRecord::limitsRequests):
            * NetworkProcess/HostRecord.h:

            * NetworkProcess/NetworkConnectionToWebProcess.cpp:
            (WebKit::NetworkConnectionToWebProcess::didClose):
            (WebKit::NetworkConnectionToWebProcess::performSynchronousLoad):
            (WebKit::NetworkConnectionToWebProcess::removeLoadIdentifier):
            * NetworkProcess/NetworkConnectionToWebProcess.h:

            * NetworkProcess/NetworkProcess.cpp:
            * NetworkProcess/NetworkResourceLoadScheduler.cpp:
            (WebKit::NetworkResourceLoadScheduler::scheduleLoader):
            (WebKit::NetworkResourceLoadScheduler::removeLoader):
            (WebKit::NetworkResourceLoadScheduler::receivedRedirect):
            (WebKit::NetworkResourceLoadScheduler::removeScheduledLoaders):
            (WebKit::NetworkResourceLoadScheduler::scheduleRemoveLoader):
            * NetworkProcess/NetworkResourceLoadScheduler.h:

            Combine ScheduleableLoader and NetworkResourceLoader into NetworkResourceLoader:
            * NetworkProcess/NetworkResourceLoader.cpp:
            (WebKit::NetworkResourceLoader::NetworkResourceLoader):
            (WebKit::NetworkResourceLoader::~NetworkResourceLoader):
            (WebKit::NetworkResourceLoader::isSynchronous):
            (WebKit::NetworkResourceLoader::start):
            (WebKit::NetworkResourceLoader::didReceiveResponseAsync):
            (WebKit::NetworkResourceLoader::didReceiveBuffer):
            (WebKit::NetworkResourceLoader::didFinishLoading):
            (WebKit::NetworkResourceLoader::didFail):
            (WebKit::NetworkResourceLoader::willSendRequestAsync):
            (WebKit::NetworkResourceLoader::continueWillSendRequest):
            (WebKit::NetworkResourceLoader::didSendData):
            (WebKit::NetworkResourceLoader::shouldUseCredentialStorage):
            (WebKit::NetworkResourceLoader::didReceiveAuthenticationChallenge):
            (WebKit::NetworkResourceLoader::consumeSandboxExtensions):
            (WebKit::NetworkResourceLoader::invalidateSandboxExtensions):
            (WebKit::NetworkResourceLoader::canAuthenticateAgainstProtectionSpaceAsync):
            * NetworkProcess/NetworkResourceLoader.h:
            (WebKit::NetworkResourceLoader::create):
            (WebKit::NetworkResourceLoader::connectionToWebProcess):
            (WebKit::NetworkResourceLoader::priority):
            (WebKit::NetworkResourceLoader::request):
            (WebKit::NetworkResourceLoader::isLoadingMainResource):
            (WebKit::NetworkResourceLoader::setHostRecord):
            (WebKit::NetworkResourceLoader::hostRecord):
            (WebKit::NetworkResourceLoader::sendAbortingOnFailure):

            Add an abstract NetworkLoaderClient to adapt a load to be either synchronous or asynchronous:
            * NetworkProcess/NetworkLoaderClient.h:
            (WebKit::NetworkLoaderClient::~NetworkLoaderClient):
            (WebKit::NetworkLoaderClient::isSynchronous):
            (WebKit::NetworkLoaderClient::NetworkLoaderClient):

            The asynchronous loader client, primarily to message progress back to the WebProcess as it happens:
            * NetworkProcess/AsynchronousNetworkLoaderClient.cpp: Added.
            (WebKit::AsynchronousNetworkLoaderClient::AsynchronousNetworkLoaderClient):
            (WebKit::AsynchronousNetworkLoaderClient::willSendRequest):
            (WebKit::AsynchronousNetworkLoaderClient::canAuthenticateAgainstProtectionSpace):
            (WebKit::AsynchronousNetworkLoaderClient::didReceiveResponse):
            (WebKit::AsynchronousNetworkLoaderClient::didReceiveBuffer):
            (WebKit::AsynchronousNetworkLoaderClient::didSendData):
            (WebKit::AsynchronousNetworkLoaderClient::didFinishLoading):
            (WebKit::AsynchronousNetworkLoaderClient::didFail):
            * NetworkProcess/AsynchronousNetworkLoaderClient.h:
            (WebKit::AsynchronousNetworkLoaderClient::create):

            The synchronous loader client, primarily to accumulate results of the load to send back to the WebProcess all at once:
            * NetworkProcess/SynchronousNetworkLoaderClient.cpp: Added.
            (WebKit::SynchronousNetworkLoaderClient::SynchronousNetworkLoaderClient):
            (WebKit::SynchronousNetworkLoaderClient::~SynchronousNetworkLoaderClient):
            (WebKit::SynchronousNetworkLoaderClient::willSendRequest):
            (WebKit::SynchronousNetworkLoaderClient::canAuthenticateAgainstProtectionSpace):
            (WebKit::SynchronousNetworkLoaderClient::didReceiveResponse):
            (WebKit::SynchronousNetworkLoaderClient::didReceiveBuffer):
            (WebKit::SynchronousNetworkLoaderClient::didFinishLoading):
            (WebKit::SynchronousNetworkLoaderClient::didFail):
            (WebKit::SynchronousNetworkLoaderClient::sendDelayedReply):
            * NetworkProcess/SynchronousNetworkLoaderClient.h: Added.
            (WebKit::SynchronousNetworkLoaderClient::create):

            * NetworkProcess/SchedulableLoader.cpp: Removed.
            * NetworkProcess/SchedulableLoader.h: Removed.
            * NetworkProcess/SyncNetworkResourceLoader.cpp: Removed.
            * NetworkProcess/SyncNetworkResourceLoader.h: Removed.

            * WebKit2.xcodeproj/project.pbxproj:

2013-10-21  Lucas Forschler  <lforschler@apple.com>

        Merge r154085

    2013-08-14  Dean Jackson  <dino@apple.com>

            <https://webkit.org/b/119827> Allow primary plug-in detection to run more than once if necessary

            Reviewed by Tim Horton.

            We occasionally see cases where the primary plug-in detection runs before the plugins have been added
            to the page, especially if they do so in response to a load event. Tweak the algorithm so that it can
            run an arbitrary number of times if it fails.

            While here, also have the detection run if there has ever been a plugin in the page as opposed to any
            current views. We may have snapshotted a plugin by now and deleted its view.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::WebPage): initialise new members.
            (WebKit::WebPage::addPluginView): Mark that we've seen a plugin.
            (WebKit::WebPage::resetPrimarySnapshottedPlugIn): Reset new members.
            (WebKit::WebPage::determinePrimarySnapshottedPlugIn): Exit early if we've never
            seen a plugin, rather than if we don't have any active views. Also, if we didn't find anything set
            a timer to run again (maximum of two attempts at the moment).
            * WebProcess/WebPage/WebPage.h: New members - m_numberOfPrimarySnapshotDetectionAttempts
            and m_hasSeenPlugin.

2013-10-21  Lucas Forschler  <lforschler@apple.com>

        Merge r154077

    2013-08-14  Dean Jackson  <dino@apple.com>

            <https://webkit.org/b/119820> Add pluginView-related logging to WebPage

            Reviewed by Tim Horton.

            Add some more diagnostic output to help track down bugs.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::addPluginView): More logging.
            (WebKit::WebPage::removePluginView): Ditto.

2013-10-21  Lucas Forschler  <lforschler@apple.com>

        Merge r153848

    2013-08-08  Dean Jackson  <dino@apple.com>

            Add logging to the primary plugin detection
            https://bugs.webkit.org/show_bug.cgi?id=119594

            Reviewed by Tim Horton.

            Add some simple logging to our primary plug-in detection.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::determinePrimarySnapshottedPlugIn):

2013-10-21  Lucas Forschler  <lforschler@apple.com>

        Merge r154067

    2013-08-14  Tim Horton  <timothy_horton@apple.com>

            REGRESSION (r153877): Plugin scanning slows creation of WebViews
            https://bugs.webkit.org/show_bug.cgi?id=119665
            <rdar://problem/14716549>

            Reviewed by Darin Adler.

            * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
            (WebKit::WebPlatformStrategies::refreshPlugins):
            Don't repopulate the plugin cache in refreshPlugins, just invalidate it.
            It will be repopulated the next time something tries to use it.

2013-10-21  Lucas Forschler  <lforschler@apple.com>

        Merge r153877

    2013-08-08  Tim Horton  <timothy_horton@apple.com>

            navigator.plugins has plugins in it when plugins are disabled
            https://bugs.webkit.org/show_bug.cgi?id=119607
            <rdar://problem/14678030>

            Reviewed by Anders Carlsson.

            * UIProcess/WebProcessProxy.cpp:
            (WebKit::WebProcessProxy::getPlugins):
            Return a list of all plugins, and a list of only application plugins.

            * UIProcess/WebProcessProxy.h:
            * UIProcess/WebProcessProxy.messages.in:
            * WebProcess/WebCoreSupport/WebPlatformStrategies.h:
            * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
            (WebKit::WebPlatformStrategies::getPluginInfo):
            Add applicationPlugin parameter to getPlugins, and storage for the returned list.

            (WebKit::WebPlatformStrategies::populatePluginCache):
            If plugins are disabled for the given page, give WebCore the list that
            only includes application plugins. Otherwise, give it the whole list
            as we are doing currently.

2013-09-04  Dean Jackson  <dino@apple.com>

        <rdar://problem/14910916> Disable CSS_SHAPES on safari-537-branch

        Reviewed by Beth Dakin.

        * Configurations/FeatureDefines.xcconfig:

2013-08-26  Lucas Forschler  <lforschler@apple.com>

        Merge r154528

    2013-08-23  Beth Dakin  <bdakin@apple.com>

            REGRESSION (r132545): Some PDFs generated by WebKit are blank when viewed in 
            Adobe Reader
            https://bugs.webkit.org/show_bug.cgi?id=120240
            -and corresponding-
            <rdar://problem/14634453>

            Reviewed by Anders Carlsson.

            Hook up new WebSystemInterface API to find out if the current context is the PDF 
            context. 

            * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
            (InitWebCoreSystemInterface):

2013-08-23  Lucas Forschler  <lforschler@apple.com>

        Merge r154473

    2013-08-22  Simon Cooper  <scooper@apple.com>

            Need to disable FakeSYSVSHM when sandboxing is not enabled
            https://bugs.webkit.org/show_bug.cgi?id=120182
            <rdar://problem/14814461>

            Reviewed by Alexey Proskuryakov.

            When not in a sandbox do not enable the FakeSYSVSHIM. This
            allows LocalConnection to work when Flash Player is run in
            "Unsafe Mode".

            * PluginProcess/mac/PluginProcessShim.mm:
            (WebKit::shim_disabled):

2013-08-23  Lucas Forschler  <lforschler@apple.com>

        Merge r154433

    2013-08-21  Tim Horton  <timothy_horton@apple.com>

            Another null-deref under WebDragClient::startDrag
            https://bugs.webkit.org/show_bug.cgi?id=120145
            <rdar://problem/14650652>

            Reviewed by Simon Fraser.

            convertImageToBitmap can legitimately return null, so don't dereference it.

            * WebProcess/WebCoreSupport/mac/WebDragClientMac.mm:
            (WebKit::WebDragClient::startDrag):

2013-08-20  Lucas Forschler  <lforschler@apple.com>

        Merge r154302

    2013-08-19  Beth Dakin  <bdakin@apple.com>

            <https://webkit.org/b/120027> AXObjectCache's 
            accessibilityEnhancedUserInterfaceEnabled should be initialized on process 
            creation

            Reviewed by Sam Weinig.

            Right now we only call AXObjectCache::setEnhancedAccessibility() when AppKit sends 
            us a notification indicating that the value has changed. We should not have to 
            rely on that to properly initialize this value. It should be done with the 
            WebProcessCreationParamters. 

            * Shared/WebProcessCreationParameters.cpp:
            (WebKit::WebProcessCreationParameters::encode):
            (WebKit::WebProcessCreationParameters::decode):
            * Shared/WebProcessCreationParameters.h:
            * UIProcess/mac/WebContextMac.mm:
            (WebKit::WebContext::platformInitializeWebProcess):
            * WebProcess/mac/WebProcessMac.mm:
            (WebKit::WebProcess::platformInitializeWebProcess):

2013-08-09  Lucas Forschler  <lforschler@apple.com>

        Merge r153907

    2013-08-09  Beth Dakin  <bdakin@apple.com>

            AX: Not able to use arrow keys to read text in a WK2 app
            https://bugs.webkit.org/show_bug.cgi?id=119605
            -and corresponding-
            <rdar://problem/14281275>

            Reviewed by Darin Adler.

            Make all of these scrolling functions actually return the WebCore bools that 
            indicate whether or not scrolling happened. 
            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::scroll):
            (WebKit::WebPage::logicalScroll):
            (WebKit::WebPage::scrollBy):
            * WebProcess/WebPage/WebPage.h:
            * WebProcess/WebPage/mac/WebPageMac.mm:
            (WebKit::WebPage::executeKeypressCommandsInternal):

            This function now gives accessibility a chance to handle the event too. And it 
            also actually tracks whether or not the event was handled by scrolling instead of 
            assuming that it was and universally returning true.
            (WebKit::WebPage::performNonEditingBehaviorForSelector):

2013-08-08  Lucas Forschler  <lforschler@apple.com>

        Merge r153856

    2013-08-08  Gavin Barraclough  <barraclough@apple.com>

            Disable suppression of plugin process for Java
            https://bugs.webkit.org/show_bug.cgi?id=119604

            Reviewed by Sam Weinig.

            Workaround, the Java plugin doesn't like this.

            * PluginProcess/mac/PluginProcessMac.mm:
            (WebKit::PluginProcess::platformInitializeProcess):
                - +1 active task count on the java plugin, to inhibit supression.

2013-08-07  Lucas Forschler  <lforschler@apple.com>

        Merge r153775

    2013-08-06  Stephanie Lewis  <slewis@apple.com>

            Update Order Files for Safari
            <rdar://problem/14517392>

            Unreviewed.

            * mac/WebKit2.order:

2013-08-07  Lucas Forschler  <lforschler@apple.com>

        Merge r153773

    2013-08-06  Jer Noble  <jer.noble@apple.com>

            Crash when entering fullscreen video playback from a WebView using WebKit2
            https://bugs.webkit.org/show_bug.cgi?id=119531

            Reviewed by Tim Horton.

            Initialize wkWindowSetScaledFrame and wkWindowSetAlpha when initializing WebCoreSystemInterface.

            * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
            (InitWebCoreSystemInterface):

2013-08-06  Lucas Forschler  <lforschler@apple.com>

        Merge r153753

    2013-08-06  Andreas Kling  <akling@apple.com>

            REGRESSION(r151403): Resizing is extremely laggy on many sites when plugins are disallowed.
            <http://webkit.org/b/119516>
            <rdar://problem/14648086>

            Reviewed by Simon Fraser.

            The web process relies on the WindowAndViewFramesChanged mechanism for caching a copy
            of the window rect for fast access from DOMWindow APIs.

            We retain part of the optimization introduced in r151403, namely not computing the
            viewFrameInWindowCoordinates and accessibilityPosition unless the web process needs them.

            * UIProcess/API/mac/WKView.mm:
            (-[WKView _updateWindowAndViewFrames]):

2013-08-05  Lucas Forschler  <lforschler@apple.com>

        Merge r153724

    2013-08-05  Anders Carlsson  <andersca@apple.com>

            Ignore the Apple Java placeholder plug-in
            https://bugs.webkit.org/show_bug.cgi?id=119494
            <rdar://problem/14610818>

            Reviewed by Beth Dakin.

            Never attempt to load the Java placeholder plug-in.

            * UIProcess/Plugins/mac/PluginInfoStoreMac.mm:
            (WebKit::PluginInfoStore::shouldUsePlugin):

2013-08-01  Lucas Forschler  <lforschler@apple.com>

        Merge r153499

    2013-07-30  Anders Carlsson  <andersca@apple.com>

            Speculative fix for crash due to string access on multiple threads
            https://bugs.webkit.org/show_bug.cgi?id=119279
            <rdar://problem/14267833>

            Reviewed by Darin Adler.

            We can't use String::isolatedCopy for passing the local storage directory to the storage thread since
            that returns a String that's copied and then destroyed after the call to bind returns, leaving a small window
            where the refcount can be accessed simultaneously from two threads.

            Work around this by passing a PassRefPtr<StringImpl> to bind instead; the act of copying the PassRefPtr will
            clear out the original and so when the original is destroyed the underlying StringImpl pointer will be null.

            * UIProcess/Storage/LocalStorageDatabaseTracker.cpp:
            (WebKit::LocalStorageDatabaseTracker::setLocalStorageDirectory):
            (WebKit::LocalStorageDatabaseTracker::setLocalStorageDirectoryInternal):
            * UIProcess/Storage/LocalStorageDatabaseTracker.h:

2013-08-01  Lucas Forschler  <lforschler@apple.com>

        Merge r153488

    2013-07-30  Anders Carlsson  <andersca@apple.com>

            Plug-in process crashes if plug-in is destroyed as a result of sending NPObjectMessageReceiver::Deallocate
            https://bugs.webkit.org/show_bug.cgi?id=119270
            <rdar://problem/13368226>

            Reviewed by Darin Adler.

            Normally we use the PluginDestructionProtector RAII object to prevent plug-ins from being destroyed while
            they're executing code. However, in the case of the NPObjectMessageReceiver::Deallocate message, we can't do this
            since we don't know the plug-in or connection. 

            Instead, add a counter to Connection that keeps track of whether sendSync is currently called and defer plug-in
            destruction if it is. (This approach is actually more robust and we should investigate getting rid of the destruction protector).

            * Platform/CoreIPC/Connection.cpp:
            (CoreIPC::Connection::Connection):
            (CoreIPC::Connection::sendSyncMessage):
            * Platform/CoreIPC/Connection.h:
            (CoreIPC::Connection::inSendSync):
            * PluginProcess/PluginControllerProxy.cpp:
            (WebKit::PluginControllerProxy::destroy):

2013-08-01  Lucas Forschler  <lforschler@apple.com>

        Merge r153482

    2013-07-30  Jeff Miller  <jeffm@apple.com>

            Page for WKPageLoaderClient processDidCrash callback always reports a process identifier of 0
            https://bugs.webkit.org/show_bug.cgi?id=119269
            <rdar://problem/14582393>

            Reviewed by Anders Carlsson.

            * UIProcess/WebPageProxy.cpp:
            (WebKit::WebPageProxy::processIdentifier):
            Return 0 if the page is closed instead of requiring isValid().

2013-07-31  Lucas Forschler  <lforschler@apple.com>

        Merge r153511

    2013-07-30  Tim Horton  <timothy_horton@apple.com>

            DHTML drag can result in a null-deref under WebDragClient::startDrag
            https://bugs.webkit.org/show_bug.cgi?id=119297
            <rdar://problem/14213012>

            Reviewed by Simon Fraser.

            * WebProcess/WebCoreSupport/mac/WebDragClientMac.mm:
            (WebKit::convertImageToBitmap):
            ShareableBitmap::createShareable can return null, but shouldn't dereference that.

2013-07-31  Lucas Forschler  <lforschler@apple.com>

        Merge r153487

    2013-07-30  Tim Horton  <timothy_horton@apple.com>

            Null deref under WebPage::scaledSnapshotWithOptions
            https://bugs.webkit.org/show_bug.cgi?id=119243
            <rdar://problem/14502050>

            Reviewed by Darin Adler.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::scaledSnapshotWithOptions):
            WebFrame::coreFrame() can be null (if the Frame is already torn down),
            so we should check it.

2013-07-30  Lucas Forschler  <lforschler@apple.com>

        Merge r153486

    2013-07-30  Tim Horton  <timothy_horton@apple.com>

            Null deref under PluginView::handlesPageScaleFactor()
            https://bugs.webkit.org/show_bug.cgi?id=119231
            <rdar://problem/14440207>

            Reviewed by Darin Adler.

            Null-check the PluginView in the caller as well.

            * WebProcess/WebPage/WebFrame.cpp:
            (WebKit::WebFrame::handlesPageScaleGesture):

2013-07-30  Lucas Forschler  <lforschler@apple.com>

        Merge r153449

    2013-07-29  Tim Horton  <timothy_horton@apple.com>

            Null deref under PluginView::handlesPageScaleFactor()
            https://bugs.webkit.org/show_bug.cgi?id=119231
            <rdar://problem/14440207>

            Reviewed by Simon Fraser.

            * WebProcess/Plugins/PluginView.cpp:
            (WebKit::PluginView::handlesPageScaleFactor):
            * WebProcess/Plugins/PluginView.h:
            Null-check m_plugin and check m_isInitialized.
            Make pageScaleFactor() and handlesPageScaleFactor const.

2013-07-29  Lucas Forschler  <lforschler@apple.com>

        Merge r153458

    2013-07-29  Tim Horton  <timothy_horton@apple.com>

            [wk2] Flush the WebProcess’ implicit transaction when using endDeferringViewInWindowChangesSync
            https://bugs.webkit.org/show_bug.cgi?id=119225
            <rdar://problem/14568841>

            Reviewed by Simon Fraser.

            Tell CoreAnimation to flush the implicit transaction before replying
            when using endDeferringViewInWindowChangesSync, as that method's contract
            is that the WebProcess is totally ready to be in-window when it returns.

            * UIProcess/API/mac/WKView.mm:
            (-[WKView endDeferringViewInWindowChanges]):
            Adopt viewInWindowStateDidChange.

            (-[WKView endDeferringViewInWindowChangesSync]):
            Adopt viewInWindowStateDidChange, asking it to send a reply only if we're going to wait for one.

            * UIProcess/WebPageProxy.cpp:
            (WebKit::WebPageProxy::viewInWindowStateDidChange):
            (WebKit::WebPageProxy::viewStateDidChange):
            Pull viewInWindowStateDidChange out of viewStateDidChange.
            Request a reply from SetIsInWindow if we're told to.

            * UIProcess/WebPageProxy.h: Add WantsReplyOrNot and viewInWindowStateDidChange.
            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::didUpdateInWindowStateTimerFired):
            Don't build this version on Mac, we'll have a WebPageMac version.

            (WebKit::WebPage::setIsInWindow):
            Only start the timer to send the didUpdateInWindowState reply if we're asked to.

            * WebProcess/WebPage/WebPage.h:
            * WebProcess/WebPage/WebPage.messages.in:
            Add an argument to the SetIsInWindow message for whether the WebProcess
            should inform the UIProcess when SetIsInWindow completes or not.

            * WebProcess/WebPage/mac/WebPageMac.mm:
            (WebKit::WebPage::didUpdateInWindowStateTimerFired):
            Tell CA to flush the implicit transaction before telling the UIProcess that
            we're finished moving in-window.

2013-07-29  Lucas Forschler  <lforschler@apple.com>

        Merge r153449

    2013-07-29  Tim Horton  <timothy_horton@apple.com>

            Null deref under PluginView::handlesPageScaleFactor()
            https://bugs.webkit.org/show_bug.cgi?id=119231
            <rdar://problem/14440207>

            Reviewed by Simon Fraser.

            * WebProcess/Plugins/PluginView.cpp:
            (WebKit::PluginView::handlesPageScaleFactor):
            * WebProcess/Plugins/PluginView.h:
            Null-check m_plugin and check m_isInitialized.
            Make pageScaleFactor() and handlesPageScaleFactor const.

2013-07-28  Lucas Forschler  <lforschler@apple.com>

        Merge r153404

    2013-07-27  Chris Fleizach  <cfleizach@apple.com>

            AX: VoiceOver not working with data detection page overlays
            https://bugs.webkit.org/show_bug.cgi?id=118680

            Reviewed by Sam Weinig.

            Expose API in BundlePageOverlay so that accessibility attributes can be retrieved through the overlay.
            This requires two methods in a new callback struct. One to copy the attribute names, and the other to 
            copy the attribute values. I've folded both parameterized and non-parameterized attribute names into one method
            with a boolean to determine which one should be used. The non-parameterized attributes are not used or passed to the
            overlay at this time as there are no clients with such a need.

            * WebProcess/InjectedBundle/API/c/WKBundlePageOverlay.cpp:
            (PageOverlayClientImpl::setAccessibilityClient):
            (PageOverlayClientImpl::PageOverlayClientImpl):
            (PageOverlayClientImpl::copyAccessibilityAttributeValue):
            (PageOverlayClientImpl::copyAccessibilityAttributeNames):
            (WKBundlePageOverlaySetAccessibilityClient):
            * WebProcess/InjectedBundle/API/c/WKBundlePageOverlay.h:
            * WebProcess/WebPage/PageOverlay.cpp:
            (WebKit::PageOverlay::copyAccessibilityAttributeValue):
            (WebKit::PageOverlay::copyAccessibilityAttributeNames):
            * WebProcess/WebPage/PageOverlay.h:
            (WebKit::PageOverlay::Client::copyAccessibilityAttributeValue):
            (WebKit::PageOverlay::Client::copyAccessibilityAttributeNames):
            (WebKit::PageOverlay::client):
            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::pageOverlayCopyAccessibilityAttributeValue):
            (WebKit::WebPage::pageOverlayCopyAccessibilityAttributesNames):
            * WebProcess/WebPage/WebPage.h:
            * WebProcess/WebPage/mac/WKAccessibilityWebPageObject.mm:
            (-[WKAccessibilityWebPageObject accessibilityParameterizedAttributeNames]):
            (-[WKAccessibilityWebPageObject _convertScreenPointToWindow:]):
            (-[WKAccessibilityWebPageObject accessibilityAttributeValue:forParameter:]):

2013-07-28  Lucas Forschler  <lforschler@apple.com>

        Merge r153402

    2013-07-27  Simon Fraser  <simon.fraser@apple.com>

            If entering fullscreen for a window fails, don't leave things in a bad state
            https://bugs.webkit.org/show_bug.cgi?id=119179

            Reviewed by Sam Weinig.

            On Lion, attempting to take a video fullscreen when the Safari window is already
            fullscreen can sometimes fail, and AppKit informs us via windowDidFailToEnterFullScreen:

            When this happens we have to undo the work done when entering fullscreen, to
            avoid leaving things in a bad state.

            * UIProcess/mac/WKFullScreenWindowController.mm:
            (-[WKFullScreenWindowController finishedEnterFullScreenAnimation:]):

2013-07-26  Lucas Forschler  <lforschler@apple.com>

        Merge r153378

    2013-07-26  Tim Horton  <timothy_horton@apple.com>

            Add a mode where autosizing fixes the FrameView height to at least the WKView height
            https://bugs.webkit.org/show_bug.cgi?id=119104
            <rdar://problem/14549021>

            Reviewed by Anders Carlsson.

            * Shared/WebPageCreationParameters.cpp:
            (WebKit::WebPageCreationParameters::encode):
            (WebKit::WebPageCreationParameters::decode):
            * Shared/WebPageCreationParameters.h:
            Add autoSizingShouldExpandToViewHeight parameter.

            * UIProcess/API/mac/WKView.mm:
            (-[WKView minimumWidthForAutoLayout]):
            (-[WKView setMinimumWidthForAutoLayout:]):
            Un-deprecate these as they're still useful if not sending a height.

            (-[WKView shouldExpandToViewHeightForAutoLayout]):
            (-[WKView setShouldExpandToViewHeightForAutoLayout:]):
            * UIProcess/API/mac/WKViewPrivate.h:
            New property, forward to WebPageProxy.

            * UIProcess/WebPageProxy.cpp:
            (WebKit::WebPageProxy::WebPageProxy):
            (WebKit::WebPageProxy::creationParameters):
            (WebKit::WebPageProxy::setAutoSizingShouldExpandToViewHeight):
            * UIProcess/WebPageProxy.h:
            (WebKit::WebPageProxy::autoSizingShouldExpandToViewHeight):
            New property, forward to WebPage.

            * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
            (WebKit::WebFrameLoaderClient::transitionToCommittedForNewPage):
            If enabled, update the FrameView's autoSizeFixedMinimumHeight.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::WebPage):
            (WebKit::WebPage::setAutoSizingShouldExpandToViewHeight):
            * WebProcess/WebPage/WebPage.h:
            (WebKit::WebPage::autoSizingShouldExpandToViewHeight):
            New property; if enabled, set FrameView's autoSizeFixedMinimumHeight,
            otherwise reset it to 0.

            * WebProcess/WebPage/WebPage.messages.in:
            * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
            (WebKit::TiledCoreAnimationDrawingArea::updateIntrinsicContentSizeTimerFired):
            (WebKit::TiledCoreAnimationDrawingArea::updateGeometry):
            Retrieve intrinsic content size explicitly from the FrameView, as
            it may not have used it as its final contentsSize if
            autoSizeFixedMinimumHeight is set.

            Set the WebPage's size in case the load is committed so that the
            WebFrameLoaderClient doesn't reset us to the wrong size.

            Update autoSizeFixedMinimumHeight if enabled when the view size changes.

2013-07-26  Lucas Forschler  <lforschler@apple.com>

        Merge r153107

    2013-07-24  Anders Carlsson  <andersca@apple.com>

            Crash when calling WKPageGetProcessIdentifier after aborted process launch
            https://bugs.webkit.org/show_bug.cgi?id=119069
            <rdar://problem/14494064>

            Reviewed by Andreas Kling.

            * UIProcess/WebPageProxy.cpp:
            (WebKit::WebPageProxy::processIdentifier):
            Check if the page is closed instead of checking whether we have a process - We'll always have a process.

            (WebKit::WebPageProxy::isValid):
            Make this const.

            * UIProcess/WebPageProxy.h:

2013-07-24  Lucas Forschler  <lforschler@apple.com>

        Merge r153096

    2013-07-24  Jessie Berlin  <jberlin@apple.com>

            Remove WKPageGetPlugInInformation - it is not used anymore
            https://bugs.webkit.org/show_bug.cgi?id=119047

            Reviewed by Alexey Proskuryakov.

            Revert r151172, which fixed a crash introduced in r151043, r151054, which fixed some naming
            and ref-churn issues introduced in r151043, and r151043, which added
            WKPageGetPlugInInformation.

            * UIProcess/API/C/mac/WKPagePrivateMac.cpp:
            (WKPageIsURLKnownHSTSHost):
            * UIProcess/API/C/mac/WKPagePrivateMac.h:
            * UIProcess/Plugins/PluginProcessManager.h:
            * UIProcess/Plugins/mac/PluginProcessManagerMac.mm:
            * UIProcess/WebPageProxy.cpp:
            (WebKit::WebPageProxy::close):
            * UIProcess/WebPageProxy.h:
            * UIProcess/WebPageProxy.messages.in:
            * UIProcess/mac/WebPageProxyMac.mm:
            * WebProcess/Plugins/Netscape/NetscapePlugin.h:
            * WebProcess/Plugins/PDF/SimplePDFPlugin.h:
            * WebProcess/Plugins/Plugin.h:
            * WebProcess/Plugins/PluginProxy.h:
            * WebProcess/Plugins/PluginView.h:
            * WebProcess/WebPage/WebPage.h:
            * WebProcess/WebPage/WebPage.messages.in:
            * WebProcess/WebPage/mac/WebPageMac.mm:

2013-07-24  Lucas Forschler  <lforschler@apple.com>

        Merge r153092

    2013-07-24  Jessie Berlin  <jberlin@apple.com>

            Remove WKPageGetPlugInInformation - it is not used anymore
            https://bugs.webkit.org/show_bug.cgi?id=119047

            Rubber-stamped by Alexey Proskuryakov.

            Revert r152328, which added a key used only in the callback info for
            WKPageGetPlugInInformation.

            * Shared/API/c/WKPluginInformation.cpp:
            * Shared/API/c/WKPluginInformation.h:
            * Shared/Plugins/Netscape/PluginInformation.cpp:
            * Shared/Plugins/Netscape/PluginInformation.h:
            * UIProcess/WebPageProxy.h:
            * UIProcess/WebPageProxy.messages.in:
            * UIProcess/mac/WebPageProxyMac.mm:
            (WebKit::WebPageProxy::containsPlugInCallback):
            * WebProcess/WebPage/mac/WebPageMac.mm:
            (WebKit::WebPage::containsPluginViewsWithPluginProcessToken):

2013-07-23  Lucas Forschler  <lforschler@apple.com>

        Merge r153070

    2013-07-23  Simon Cooper  <scooper@apple.com>

            10.7: Java applets do not work due to sandbox violation/exception
            https://bugs.webkit.org/show_bug.cgi?id=118920
            <rdar://problem/14471541&12910934&14223830&14260729&14267679>

            Reviewed by Alexey Proskuryakov.

            Introduce versioning into the common profile and use it to fix
            a number of issues with Java on 10.7 and 10.8. Allow writing the
            com.apple.java.util.prefs preference file. This change also
            introduces a "/Library/Application Support/Java/PublicFiles"
            area which Java can read without any restrictions. Files written
            to this location will need to be created and written to by
            a privileged process.

            * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:
            * Resources/PlugInSandboxProfiles/com.oracle.java.JavaAppletPlugin.sb:

2013-07-22  Lucas Forschler  <lforschler@apple.com>

        Merge r152984

    2013-07-22  Alexey Proskuryakov  <ap@apple.com>

            Frequent MESSAGE_CHECK failures in WebPageProxy::didReceiveEvent
            https://bugs.webkit.org/show_bug.cgi?id=118976
            <rdar://problem/14155030>

            Reviewed by Sam Weinig.

            * UIProcess/WebPageProxy.cpp: (WebKit::WebPageProxy::resetStateAfterProcessExited):
            Clear m_gestureEventQueue, just like we clear all other event queues here.

2013-07-22  Lucas Forschler  <lforschler@apple.com>

        Merge r152950

    2013-07-21  Anders Carlsson  <andersca@apple.com>

            Java Updater not launched on Lion and Mountain Lion
            https://bugs.webkit.org/show_bug.cgi?id=118953
            <rdar://problem/14496721>

            Reviewed by Sam Weinig.

            On Lion and Mountain Lion, -[NSURL isEqual:] will return NO for two file URLs if one of
            them has "localhost" specified, even if the paths are otherwise equal. Work around this by
            comparing the paths directly.

            * UIProcess/Plugins/mac/PluginProcessProxyMac.mm:
            (WebKit::isJavaUpdaterURL):

2013-07-22  Lucas Forschler  <lforschler@apple.com>

        Merge r152787

    2013-07-17  Simon Cooper  <scooper@apple.com>

            YouTube webcam capture (Flash Plug-in) in Safari can't see built-in camera
            https://bugs.webkit.org/show_bug.cgi?id=118787
            <rdar://problem/14418799>

            Reviewed by Alexey Proskuryakov.

            Add support for built-in cameras, including the original iSight.

            * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:
            * Resources/PlugInSandboxProfiles/com.macromedia.Flash Player.plugin.sb:

2013-07-22  Lucas Forschler  <lforschler@apple.com>

        Merge r152866

    2013-07-18  Tim Horton  <timothy_horton@apple.com>

            [wk2] Ensure that the plugin layer is removed completely when the PluginProcess crashes
            https://bugs.webkit.org/show_bug.cgi?id=118862

            Reviewed by Anders Carlsson.

            * WebProcess/Plugins/PluginView.cpp:
            (WebKit::PluginView::PluginView):
            Add m_pluginProcessHasCrashed.

            (WebKit::PluginView::platformLayer):
            Don't return the plugin's layer if it has crashed.

            (WebKit::PluginView::pluginProcessCrashed):
            Set m_pluginProcessHasCrashed.
            Cause a style recalc so that we rebuild the layer tree; our layer won't be included.

            * WebProcess/Plugins/PluginView.h:
            Add m_pluginProcessHasCrashed.

2013-07-22  Lucas Forschler  <lforschler@apple.com>

        Merge r152862

    2013-07-18  Alexey Proskuryakov  <ap@apple.com>

            <rdar://problem/13886443> Assertion failures in NetworkProcess in SandboxExtension::revoke when aborting SyncNetworkResourceLoader
            <rdar://problem/13826348> ASSERT(!m_useCount) fails in NetworkProcess at SandboxExtension::~SandboxExtension
            https://bugs.webkit.org/show_bug.cgi?id=118855

            Reviewed by Brady Eidson.

            * NetworkProcess/NetworkResourceLoader.cpp:
            (WebKit::NetworkResourceLoader::cleanup):
            (WebKit::NetworkResourceLoader::didFinishLoading):
            (WebKit::NetworkResourceLoader::didFail):
            Moved sandbox extension invalidation to cleanup() meaning that we won't fail to
            do this when aborting a loader that currently loading from network.

            * NetworkProcess/SchedulableLoader.cpp:
            (WebKit::SchedulableLoader::SchedulableLoader):
            (WebKit::SchedulableLoader::consumeSandboxExtensions):
            (WebKit::SchedulableLoader::invalidateSandboxExtensions):
            * NetworkProcess/SchedulableLoader.h:
            Keep track of whether sandbox extensions are consumed, we don't want to revoke
            extensions that were never consumed (as used to be the case with sync loaders,
            and would be with async ones after the above fix). Also, get rid of extensions
            immediately when invalidating, we won't need them again.

2013-07-22  Lucas Forschler  <lforschler@apple.com>

        Merge r152824

    2013-07-17  Tim Horton  <timothy_horton@apple.com>

            Update blocked/missing plug-in UI
            https://bugs.webkit.org/show_bug.cgi?id=118347
            <rdar://problem/14209318>

            Reviewed by Sam Weinig.

            * Platform/CoreIPC/HandleMessage.h:
            (CoreIPC::callMemberFunction):
            Add a 6 argument -> 4 reply message handler.
            (It seems that FindPlugin is getting a little out of hand.)

            * Shared/APIClientTraits.cpp:
            * Shared/APIClientTraits.h:
            * UIProcess/API/C/WKPage.h:
            * UIProcess/WebLoaderClient.cpp:
            (WebKit::WebLoaderClient::pluginLoadPolicy):
            * UIProcess/WebLoaderClient.h:
            Add an unavailability description out-argument to a new version of
            pluginLoadPolicy, so clients can override the text of the unavailable
            plugin indicator. Bump the WKPageLoaderClient version and update APIClientTraits.

            * UIProcess/WebPageProxy.cpp:
            (WebKit::WebPageProxy::findPlugin):
            * UIProcess/WebPageProxy.h:
            * UIProcess/WebPageProxy.messages.in:
            Plumb the unavailability description through to the WebProcess via
            the FindPlugin message.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::createPlugin):
            Acquire the unavailability description from the client
            (via FindPlugin) and hand it to the RenderEmbeddedObject.

2013-07-22  Lucas Forschler  <lforschler@apple.com>

        Rollout r152701

2013-07-19  Lucas Forschler  <lforschler@apple.com>

        Merge r152877

    2013-07-18  Simon Cooper  <scooper@apple.com>

            Flash Player: deny file-read-data /Library/Application Support/Macromedia/FlashAuthor.cfg
            https://bugs.webkit.org/show_bug.cgi?id=118874
            <rdar://problem/14271327>

            Reviewed by Alexey Proskuryakov.

            Silently deny access to FlashAuthor.cfg. This location contains
            files containing lists of paths that Flash Player will
            "allow" access to (without asking the user). Since the plugin
            sandbox won't permit the access to the listed paths it is better
            to silently block attempts to read this "whitelist".

            * Resources/PlugInSandboxProfiles/com.macromedia.Flash Player.plugin.sb:

2013-07-18  Lucas Forschler  <lforschler@apple.com>

        Merge r152805

    2013-07-17  Alexey Proskuryakov  <ap@apple.com>

            [Mac] Crashes in CFURLGetBytes under WebProcess::updateActivePages()
            https://bugs.webkit.org/show_bug.cgi?id=118814
            <rdar://problem/14173389>

            Reviewed by Brady Eidson.

            Speculative fix. It's unclear how we end up with an invalid URL when committing
            a load.

            * WebProcess/mac/WebProcessMac.mm: (WebKit::WebProcess::updateActivePages):
            Added a null check.

2013-07-17  Lucas Forschler  <lforschler@apple.com>

        Merge r152740

    2013-07-16  Alexey Proskuryakov  <ap@apple.com>

            REGRESSION (r150291): Chinese predictive input pop-up disappears on twitter.com
            https://bugs.webkit.org/show_bug.cgi?id=118739
            <rdar://problem/14300350>

            Reviewed by Daniel Bates.

            EditorState tracking on UI side is very fragile. This is a targeted fix just for
            this specific scenario.

            The issue was that we had a stale m_temporarilyClosedComposition flag, which was
            making UI process believe that a composition was closed from WebProcess side,
            and notify input method about that. It shouldn't have been a problem, because there
            is no composition at this point indeed, but this extra call is a problem for
            predictive input, which works in a somewhat unconventional way (<rdar://problem/14458297>).

            * UIProcess/mac/WebPageProxyMac.mm:
            (WebKit::WebPageProxy::insertText): Reset m_temporarilyClosedComposition flag when
            getting new EditorState in response to performing this action. There is certainly
            no composition after insertText, and all interested parties are on the same page
            already.

2013-07-16  Lucas Forschler  <lforschler@apple.com>

        Merge r152701

    2013-07-15  Tim Horton  <timothy_horton@apple.com>

            Update blocked/missing plug-in UI
            https://bugs.webkit.org/show_bug.cgi?id=118347
            <rdar://problem/14209318>

            Reviewed by Sam Weinig.
            Patch by Antoine Quint, Anders Carlsson, Sam Weinig, and myself.

            * Platform/CoreIPC/HandleMessage.h:
            (CoreIPC::callMemberFunction):
            Add a 6 argument -> 4 reply message handler.
            (It seems that FindPlugin is getting a little out of hand.)

            * Shared/APIClientTraits.cpp:
            * Shared/APIClientTraits.h:
            * UIProcess/API/C/WKPage.h:
            * UIProcess/WebLoaderClient.cpp:
            (WebKit::WebLoaderClient::pluginLoadPolicy):
            * UIProcess/WebLoaderClient.h:
            Add an unavailability description out-argument to a new version of
            pluginLoadPolicy, so clients can override the text of the unavailable
            plugin indicator. Bump the WKPageLoaderClient version and update APIClientTraits.

            * UIProcess/WebPageProxy.cpp:
            (WebKit::WebPageProxy::findPlugin):
            * UIProcess/WebPageProxy.h:
            * UIProcess/WebPageProxy.messages.in:
            Plumb the unavailability description through to the WebProcess via
            the FindPlugin message.

            * WebProcess/Plugins/PluginProcessConnection.cpp:
            (WebKit::PluginProcessConnection::didClose):
            Make a strongly referencing copy of the list of PluginProxies, so we can
            throw them away without the HashMap being mutated underneath us (see the comment).

            * WebProcess/Plugins/PluginView.cpp:
            (WebKit::PluginView::pluginProcessCrashed):
            Invalidate the plug-in's widget before setting the plugin unavailability reason,
            because doing so would cause the plug-in's renderer to be torn down, making
            invalidate() crash.

            * WebProcess/WebCoreSupport/WebChromeClient.cpp:
            (WebKit::WebChromeClient::shouldUnavailablePluginMessageIncludeButton):
            * WebProcess/WebCoreSupport/WebChromeClient.h:
            Rename from shouldUnavailablePluginMessageBeButton to
            shouldUnavailablePluginMessageIncludeButton for accuracy.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::createPlugin):
            Acquire the unavailability description from the client
            (via FindPlugin) and hand it to the RenderEmbeddedObject.
            (WebKit::WebPage::canPluginHandleResponse):
            Re-acquire the plugin's renderer, in case setPluginUnavailabilityReason destroyed it.

2013-07-16  Lucas Forschler  <lforschler@apple.com>

        Merge r152698

    2013-07-15  Simon Cooper  <scooper@apple.com>

            PluginProcess deny file-read-data /Library/Application Support/Macromedia/FlashPlayerTrust
            https://bugs.webkit.org/show_bug.cgi?id=118690
            <rdar://problem/14255963>

            Reviewed by Dean Jackson.

            Silently deny access to FlashPlayerTrust. This location contains
            files containing lists of paths that Flash Player will
            "allow" access to (without asking the user). Since the plugin
            sandbox won't permit the access to the listed paths it is better
            to silently block attempts to read these "whitelists". The
            "whitelists" are created by other Adobe "installer" like
            applications.

            * Resources/PlugInSandboxProfiles/com.macromedia.Flash Player.plugin.sb:

2013-07-15  Lucas Forschler  <lforschler@apple.com>

        Rollout r152686.  Previously merged.

2013-07-15  Lucas Forschler  <lforschler@apple.com>

        Merge r152382

    2013-07-03  Gordon Sheridan  <gordon_sheridan@apple.com>

            Implement mechanism to detect (partially) hidden blocked plugins.
            https://bugs.webkit.org/show_bug.cgi?id=117998

            Reviewed by Dean Jackson.

            * Shared/Plugins/Netscape/PluginInformation.h:
            * Shared/Plugins/Netscape/PluginInformation.cpp:
            (WebKit::plugInInformationReplacementObscuredKey):
            Add key for plugInInformation dictionaries.

            (WebKit::createPluginInformationDictionary):
            Add boolean parameter identifying whether the replacement for a blocked plugin is obscured, and add it to the dictionary.

            * Shared/API/c/WKPluginInformation.h:
            * Shared/API/c/WKPluginInformation.cpp:
            (WKPluginInformationReplacementObscuredKey):
            Provide the C API for the plugInInformationReplacementObscuredKey().

            * UIProcess/WebPageProxy.h:
            * UIProcess/WebPageProxy.cpp:
            (WebKit::WebPageProxy::didBlockInsecurePluginVersion):
            Add bool replacementObscured parameter to pass on argument to createPluginInformationDictionary().

            * UIProcess/WebPageProxy.messages.in:
            Add bool replacementObscured parameter to DidBlockInsecurePluginVersion() message.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::createPlugin):
            Invoke isReplacementObscured() method for blocked plugins.

2013-07-15  Lucas Forschler  <lforschler@apple.com>

        Merge r152642

    2013-07-14  Jon Lee  <jonlee@apple.com>

            Calling Notification.requestPermission() without a callback crashes
            https://bugs.webkit.org/show_bug.cgi?id=118654
            <rdar://problem/14293352>

            Reviewed by Alexey Proskuryakov.

            When requestPermission() is called, we short-circuit if we know the permission was already set.
            The callback handler gets invoked. But now that callbacks are optional, we need to check to make
            sure a callback was provided.

            * WebProcess/Notifications/NotificationPermissionRequestManager.cpp:
            (WebKit::NotificationPermissionRequestManager::startRequest): Check for the callback.

2013-07-15  Lucas Forschler  <lforschler@apple.com>

        Merge r152580

    2013-07-10  Roger Fong  <roger_fong@apple.com>

            Plugins that don't support snapshotting should not all autostart.
            https://bugs.webkit.org/show_bug.cgi?id=118572
            <rdar://problem/14324391>.

            Reviewed by Dean Jackson.

            * WebProcess/Plugins/PluginView.cpp:
            (WebKit::PluginView::shouldNotAddLayer): This method determines whether or not we should add the plugin's layer to the tree.
            It should not be added if the plugin is in it's snapshotted state but does not actually support snapshotting.
            (WebKit::PluginView::pluginSnapshotTimerFired): If the plugin does not support snapshotting go straight 
            to the the DisplayingSnapshot state.
            * WebProcess/Plugins/PluginView.h:

2013-07-15  Lucas Forschler  <lforschler@apple.com>

        Merge r152520

    2013-07-09  Jer Noble  <jer.noble@apple.com>

            Reviewed by Simon Fraser.

            Remember the scroll position and restore after exiting full-screen mode.
            https://bugs.webkit.org/show_bug.cgi?id=61956
            <rdar://problem/9544461>

            Call into the main FrameView to save the scroll position before swapping the
            WebView into the full-screen window, and restore the scroll position after 
            swapping the WebView back into the browser window.

            * UIProcess/mac/WKFullScreenWindowController.mm:
            (-[WKFullScreenWindowController finishedEnterFullScreenAnimation:]):
            (-[WKFullScreenWindowController beganExitFullScreenAnimation]):

            In WebKit2, this requires some communication between the WebProcess and the
            UIProcess, so add two new messages to WebFullScreenManager to be called by
            its proxy.

            * UIProcess/WebFullScreenManagerProxy.h:
            * UIProcess/WebFullScreenManagerProxy.cpp:
            (WebKit::WebFullScreenManagerProxy::saveScrollPosition):
            (WebKit::WebFullScreenManagerProxy::restoreScrollPosition):
            * WebProcess/FullScreen/WebFullScreenManager.h:
            * WebProcess/FullScreen/WebFullScreenManager.messages.in:
            * WebProcess/FullScreen/WebFullScreenManager.cpp:
            (WebKit::WebFullScreenManager::saveScrollPosition):
            (WebKit::WebFullScreenManager::restoreScrollPosition):

2013-07-15  Lucas Forschler  <lforschler@apple.com>

        Merge r152316

    2013-07-02  Ada Chan  <adachan@apple.com>

            Fix crash when PageBanner::detachFromPage() is called from WebPage::~WebPage().
            https://bugs.webkit.org/show_bug.cgi?id=118268

            Reviewed by Beth Dakin.

            * WebProcess/WebPage/mac/PageBannerMac.mm:
            (WebKit::PageBanner::detachFromPage): Add some null checks. m_webPage->corePage()
            can be null if this method is called after the web page is closed.

2013-07-15  Lucas Forschler  <lforschler@apple.com>

        Merge r152249

    2013-07-01  Ada Chan  <adachan@apple.com>

            Properly hide the header and footer banners if they are set to null.
            https://bugs.webkit.org/show_bug.cgi?id=118219

            Reviewed by Beth Dakin.

            Call Page::addFooterWithHeight(0) to remove the parent layer that hosts the banner when
            the footer banner is detached. Similarly for the header banner.

            * WebProcess/WebPage/mac/PageBannerMac.mm:
            (WebKit::PageBanner::detachFromPage):

2013-07-12  Lucas Forschler  <lforschler@apple.com>

        Merge r152571

    2013-07-11  Timothy Hatcher  <timothy@apple.com>

            Revert r152267 and soft link WebInspectorUI.framework again.

            https://bugs.webkit.org/show_bug.cgi?id=118544

            Reviewed by David Kilzer.

            * Configurations/WebKit2.xcconfig:
            * UIProcess/mac/WebInspectorProxyMac.mm:
            (WebKit::inspectorReallyUsesWebKitUserInterface):
            * WebKit2.xcodeproj/project.pbxproj:
            * WebProcess/WebPage/mac/WebInspectorMac.mm:
            (WebKit::inspectorReallyUsesWebKitUserInterface):

2013-07-10  Lucas Forschler  <lforschler@apple.com>

        Merge r152555

    2013-07-10  Mark Rowe  <mrowe@apple.com>

            <rdar://problem/14395759> PluginProcess sometimes logs an error about being unable to load WebKit2.framework.

            Reviewed by Alexey Proskuryakov.

            * UIProcess/Plugins/mac/PluginProcessProxyMac.mm:
            (WebKit::PluginProcessProxy::createPropertyListFile): Ensure that any environment variables
            specified in dynamic linker load commands are passed to the subprocess that we spawn to create
            the MIME type property list.

2013-07-10  Lucas Forschler  <lforschler@apple.com>

        Merge r152539

    2013-07-10  Brady Eidson  <beidson@apple.com>

            Some Java plugin instances can deadlock with the WebProcess on NPP_Destroy.
            <rdar://problem/14286390> and https://bugs.webkit.org/show_bug.cgi?id=118535

            Reviewed by Alexey Proskuryakov.

            * Shared/Plugins/NPObjectProxy.cpp:
            (WebKit::NPObjectProxy::~NPObjectProxy): ASSERT this is the main thread.
            (WebKit::NPObjectProxy::NP_Deallocate): If this isn't the main thread, call it again on the main thread.

2013-07-09  Lucas Forschler  <lforschler@apple.com>

        Merge r152425

    2013-07-05  Tim Horton  <timothy_horton@apple.com>

            [wk2] Add API to lock the scroll position at the top or bottom of the page
            https://bugs.webkit.org/show_bug.cgi?id=118429
            <rdar://problem/14120323>

            Reviewed by Anders Carlsson.

            * Shared/WebPageCreationParameters.cpp:
            (WebKit::WebPageCreationParameters::encode):
            (WebKit::WebPageCreationParameters::decode):
            * Shared/WebPageCreationParameters.h:
            Pass the current ScrollPinningBehavior across to the WebPage upon creation.

            * UIProcess/API/C/WKPage.cpp:
            (WKPageGetScrollPinningBehavior):
            (WKPageSetScrollPinningBehavior):
            * UIProcess/API/C/WKPagePrivate.h:
            SPI to get/set the WebPageProxy's current ScrollPinningBehavior.
            Convert between WK API type and WebCore enum.

            * UIProcess/WebPageProxy.cpp:
            (WebKit::WebPageProxy::WebPageProxy):
            (WebKit::WebPageProxy::creationParameters):
            Send ScrollPinningBehavior when creating a WebPage.

            (WebKit::WebPageProxy::setScrollPinningBehavior):
            Pass ScrollPinningBehavior changes across to the WebProcess (and save it
            in WebPageProxy so it can be sent back across if the WebProcess crashes).

            * UIProcess/WebPageProxy.h:
            (WebKit::WebPageProxy::scrollPinningBehavior):
            Getter/setter and storage for m_scrollPinningBehavior.

            * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
            (WebKit::WebFrameLoaderClient::transitionToCommittedForNewPage):
            Inform new FrameViews of the current ScrollPinningBehavior.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::WebPage):
            Set our ScrollPinningBehavior based on our creation parameters.

            (WebKit::WebPage::setScrollPinningBehavior):
            Inform the FrameView of ScrollPinningBehavior changes.

            * WebProcess/WebPage/WebPage.h:
            (WebKit::WebPage::scrollPinningBehavior): Added.
            (WebKit::WebPage::setScrollPinningBehavior): Added.
            Add storage for m_scrollPinningBehavior.

            * WebProcess/WebPage/WebPage.messages.in:
            Add SetScrollPinningBehavior message.

2013-07-09  Lucas Forschler  <lforschler@apple.com>

        Merge r152407

    2013-07-04  Anders Carlsson  <andersca@apple.com>

            Paint the page background if we haven't received our first update
            https://bugs.webkit.org/show_bug.cgi?id=118402
            <rdar://problem/13893308>

            Reviewed by Simon Fraser.

            Make sure that we always paint something when we haven't received our first update from the web process.

            * UIProcess/API/mac/WKView.mm:
            (-[WKView drawRect:]):
            * UIProcess/DrawingAreaProxyImpl.h:
            (WebKit::DrawingAreaProxyImpl::hasReceivedFirstUpdate):

2013-07-09  Lucas Forschler  <lforschler@apple.com>

        Merge r152403

    2013-07-04  Anders Carlsson  <andersca@apple.com>

            Crash when createPluginInternal ends up destroying the plug-in
            https://bugs.webkit.org/show_bug.cgi?id=118397
            <rdar://problem/14155051>

            Reviewed by Simon Fraser.

            Keep the WebProcessConnection object alive while calling createPluginInternal and handle
            the IPC connection going away.

            * PluginProcess/WebProcessConnection.cpp:
            (WebKit::WebProcessConnection::createPluginAsynchronously):

2013-07-09  Lucas Forschler  <lforschler@apple.com>

        Merge r152382

    2013-07-03  Gordon Sheridan  <gordon_sheridan@apple.com>

            Implement mechanism to detect (partially) hidden blocked plugins.
            https://bugs.webkit.org/show_bug.cgi?id=117998

            Reviewed by Dean Jackson.

            * Shared/Plugins/Netscape/PluginInformation.h:
            * Shared/Plugins/Netscape/PluginInformation.cpp:
            (WebKit::plugInInformationReplacementObscuredKey):
            Add key for plugInInformation dictionaries.

            (WebKit::createPluginInformationDictionary):
            Add boolean parameter identifying whether the replacement for a blocked plugin is obscured, and add it to the dictionary.

            * Shared/API/c/WKPluginInformation.h:
            * Shared/API/c/WKPluginInformation.cpp:
            (WKPluginInformationReplacementObscuredKey):
            Provide the C API for the plugInInformationReplacementObscuredKey().

            * UIProcess/WebPageProxy.h:
            * UIProcess/WebPageProxy.cpp:
            (WebKit::WebPageProxy::didBlockInsecurePluginVersion):
            Add bool replacementObscured parameter to pass on argument to createPluginInformationDictionary().

            * UIProcess/WebPageProxy.messages.in:
            Add bool replacementObscured parameter to DidBlockInsecurePluginVersion() message.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::createPlugin):
            Invoke isReplacementObscured() method for blocked plugins.

2013-07-08  Lucas Forschler  <lforschler@apple.com>

        Merge r152267

    2013-07-01  Timothy Hatcher  <timothy@apple.com>

            Link to WebInspectorUI.framework at build time instead of soft linking.

            https://bugs.webkit.org/show_bug.cgi?id=118261

            Reviewed by Joseph Pecoraro.

            * Configurations/WebKit2.xcconfig:
            * UIProcess/mac/WebInspectorProxyMac.mm:
            (WebKit::inspectorReallyUsesWebKitUserInterface):
            * WebKit2.xcodeproj/project.pbxproj:
            * WebProcess/WebPage/mac/WebInspectorMac.mm:
            (WebKit::inspectorReallyUsesWebKitUserInterface):

2013-07-03  Lucas Forschler  <lforschler@apple.com>

        Merge r152375

    2013-07-03  Alexey Proskuryakov  <ap@apple.com>

            <rdar://problem/14271105> Flash Player: deny ipc-posix-sem 59918130
            <rdar://problem/14349560> Flash Player: deny ipc-posix-sem MacromediaSemaphoreDig on many sites

            Reviewed by Sam Weinig.

            * Resources/PlugInSandboxProfiles/com.macromedia.Flash Player.plugin.sb:
            semaphore-owner doesn't appear to work the way we need it to, removing it (at least for now).

2013-07-03  Lucas Forschler  <lforschler@apple.com>

        Merge r152317

    2013-07-02  Alexey Proskuryakov  <ap@apple.com>

            security/block-test.html fails when NetworkProcess is enabled
            https://bugs.webkit.org/show_bug.cgi?id=118320
            <rdar://problem/14309423>

            Reviewed by Geoff Garen.

            * NetworkProcess/NetworkResourceLoader.cpp:
            (WebKit::NetworkResourceLoader::wasBlocked):
            (WebKit::NetworkResourceLoader::cannotShowURL):
            Implemented missing ResourceHandleClient functions.

2013-07-02  Lucas Forschler  <lforschler@apple.com>

        Merge r152328

    2013-07-02  Jessie Berlin  <jberlin@apple.com>

            The callback for WKPageGetPlugInInformation needs info about whether or not there are any
            non-playing instances of the plug-in on the page
            https://bugs.webkit.org/show_bug.cgi?id=118330

            Reviewed by Anders Carlsson.

            Add another key value pair to the dictionary passed to the callback.

            * Shared/API/c/WKPluginInformation.cpp:
            (WKPlugInInformationPageContainsNonPlayingInstanceOfPlugInKey):
            * Shared/API/c/WKPluginInformation.h:

            * Shared/Plugins/Netscape/PluginInformation.cpp:
            (WebKit::plugInInformationPageContainsNonPlayingInstanceOfPlugInKey):
            (WebKit::createPlugInInformationDictionary):
            Add the information about whether or not the page contains a non-playing instance of that
            plug-in to the plug-in information dictionary.
            * Shared/Plugins/Netscape/PluginInformation.h:

            * UIProcess/WebPageProxy.h:
            * UIProcess/WebPageProxy.messages.in:
            * UIProcess/mac/WebPageProxyMac.mm:
            (WebKit::WebPageProxy::containsPlugInCallback):
            Check if any of the MIME types of the plug-in instances that are present on the page but are
            not playing match the instance of plug-in being searched for.
            * WebProcess/WebPage/mac/WebPageMac.mm:
            (WebKit::addPlugInMimeTypesFromNodeListForNonPlayingPlugIns):
            Based roughly off of addPlugInsFromNodeListMatchingPlugInOrigin in
            HTMLPlugInImageElement.cpp.
            (WebKit::WebPage::containsPluginViewsWithPluginProcessToken):
            Based roughly off of HTMLPlugInImageElement::restartSimilarPlugIns.

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152273

    2013-07-01  Alexey Proskuryakov  <ap@apple.com>

            Clean up private browsing session tracking
            https://bugs.webkit.org/show_bug.cgi?id=118266
            <rdar://problem/13078036>

            Reviewed by Brady Eidson.

            Instead of counting API calls, we now watch actual WebPreferences objects.

            * UIProcess/API/C/WKPreferences.cpp: (WKPreferencesSetPrivateBrowsingEnabled):
            Removed code that used to notify WebContext. It's now done by WebPreferences.

            * UIProcess/WebContext.h:
            * UIProcess/WebContext.cpp:
            (WebKit::WebContext::ensureNetworkProcess): Instead of counting the number of times
            API was called, rely on WebPreferences tracking.
            (WebKit::WebContext::willStartUsingPrivateBrowsing): Ditto. This function is
            now only called when we detect a change in private browsing state.
            (WebKit::WebContext::willStopUsingPrivateBrowsing): Ditto.
            (WebKit::WebContext::createNewWebProcess): Tell the new process to create a private
            browsing session if needed.

            * UIProcess/WebPreferences.h:
            * UIProcess/WebPreferences.cpp:
            (WebKit::WebPreferences::addPageGroup): Count how many page groups use private
            browsing, and notify WebContext when a session is needed. Note that we don't notify
            WebContext about WebPreferences without any page groups, because it's likely
            that preferences will be updated by the client before groups are associated.
            (WebKit::WebPreferences::removePageGroup): Ditto.
            (WebKit::WebPreferences::updateBoolValueForKey): Perform special handling for
            private browsing mode changes.
            (WebKit::WebPreferences::updatePrivateBrowsingValue): Notify WebContext when
            it's time to create or destroy a private browsing session.
            (WebKit::WebPreferences::anyPageGroupsAreUsingPrivateBrowsing): A getter for
            WebContext to know when any page groups are in private browsing mode.

            * WebProcess/WebPage/WebPage.cpp: (WebKit::WebPage::updatePreferences):
            Don't create a private browsing session implicitly, UI process takes care of it.

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152266

    2013-07-01  Tim Horton  <timothy_horton@apple.com>

            [wk2] TiledCoreAnimationDrawingArea should support scrolling its exposed rect
            https://bugs.webkit.org/show_bug.cgi?id=118173
            <rdar://problem/14301166>

            Reviewed by Anders Carlsson.

            Offset the exposed rect passed from the WKView by the main frame's current scroll position
            before sending it to our TiledBackings, so that it is in the same coordinate space as their
            ordinary visibleRects.

            This has the side effect of making clips-to-exposed-rect testable (though useless) in Safari.

            * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.h:
            Add updateScrolledExposedRect() and m_scrolledExposedRect.

            * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
            (WebKit::TiledCoreAnimationDrawingArea::scroll):
            Call updateScrolledExposedRect when the main frame scrolls.

            (WebKit::TiledCoreAnimationDrawingArea::setExposedRect):
            Remove a FIXME about this change.
            Call updateScrolledExposedRect instead of passing down the unscrolled rect.

            (WebKit::TiledCoreAnimationDrawingArea::setClipsToExposedRect):
            Call updateScrolledExposedRect, because that method will short-circuit if
            setClipsToExposedRect is false, so we need to update here for correctness
            if we get a setExposedRect(), setClipsToExposedRect(true) pair.

            (WebKit::TiledCoreAnimationDrawingArea::updateScrolledExposedRect):
            Update m_scrolledExposedRect and propagate it to our TiledBackings.

            (WebKit::TiledCoreAnimationDrawingArea::flushLayers):
            (WebKit::TiledCoreAnimationDrawingArea::setRootCompositingLayer):
            (WebKit::TiledCoreAnimationDrawingArea::createPageOverlayLayer):
            (WebKit::TiledCoreAnimationDrawingArea::didCommitChangesForLayer):
            Use the scrolled exposed rect.

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152077

    2013-06-26  Simon Cooper  <scooper@apple.com>

            Sometimes the Flash Player plugin cannot make outgoing connections
            https://bugs.webkit.org/show_bug.cgi?id=118110
            <rdar://problem/14270933>

            Reviewed by Alexey Proskuryakov.

            Allow outgoing and incoming UDP data. Tidy up the QuickTime
            profile as it gets the UDP ability from the common profile.

            * Resources/PlugInSandboxProfiles/com.apple.QuickTime Plugin.plugin.sb:
            * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152230

    2013-07-01  Sam Weinig  <sam@webkit.org>

            WKPageLoadDataWithUserData neglects to set the base URL that is passed in
            <rdar://problem/14306784>
            https://bugs.webkit.org/show_bug.cgi?id=118256

            Reviewed by Anders Carlsson.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::loadData):
            Pass the baseURL, not blankURL(), and remove an unnecessary multiplication by sizeof(uint8_t) which is always 1.

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152187

    2013-06-28  Gavin Barraclough  <barraclough@apple.com>

            Stale occlusion state after moving page back into window
            https://bugs.webkit.org/show_bug.cgi?id=118202

            Reviewed by Anders Carlsson.

            We need to update the occlusion state when the page goes back into the window.

            * UIProcess/API/mac/WKView.mm:
            (-[WKView viewDidMoveToWindow]):
                - update occlusion state.

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152182

    2013-06-28  Anders Carlsson  <andersca@apple.com>

            Make the UI process run the Java Updater
            https://bugs.webkit.org/show_bug.cgi?id=118197
            <rdar://problem/14255677>

            Reviewed by Sam Weinig.

            Patch the relevant NSWorkspace method and pipe through the request to launch the Java updater to the UI process.

            * PluginProcess/PluginProcess.h:
            * PluginProcess/mac/PluginProcessMac.mm:
            (WebKit::replacedNSWorkspace_launchApplicationAtURL_options_configuration_error):
            (WebKit::initializeCocoaOverrides):
            (WebKit::PluginProcess::launchApplicationAtURL):
            * UIProcess/Plugins/PluginProcessProxy.h:
            * UIProcess/Plugins/PluginProcessProxy.messages.in:
            * UIProcess/Plugins/mac/PluginProcessProxyMac.mm:
            (WebKit::isJavaUpdaterURL):
            (WebKit::shouldLaunchApplicationAtURL):
            (WebKit::PluginProcessProxy::launchApplicationAtURL):

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152075

    2013-06-26  Simon Cooper  <scooper@apple.com>

            Flash Player: deny ipc-posix-sem 59918130
            https://bugs.webkit.org/show_bug.cgi?id=118107
            <rdar://problem/14271105>

            Reviewed by Alexey Proskuryakov.

            Allow same-sandbox scoped semaphores on Mavericks. Permit the
            named semaphore for older releases.

            * Resources/PlugInSandboxProfiles/com.macromedia.Flash Player.plugin.sb:

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152073

    2013-06-26  Simon Cooper  <scooper@apple.com>

            Silverlight deny ipc-posix-sem LC_Mutex playing Amazon Prime videos
            https://bugs.webkit.org/show_bug.cgi?id=118102
            <rdar://problem/14194077>

            Reviewed by Alexey Proskuryakov.

            Allow same-sandbox scoped semaphores on Mavericks. Permit the
            named semaphore for older releases.

            * Resources/PlugInSandboxProfiles/com.microsoft.SilverlightPlugin.sb:

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152072

    2013-06-26  Simon Cooper  <scooper@apple.com>

            Update ColorSync shared memory names in plug-in sandbox profile
            https://bugs.webkit.org/show_bug.cgi?id=118099

            Reviewed by Alexey Proskuryakov.

            Update the common profile to use the names used in Mavericks

            * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152063

    2013-06-26  Simon Cooper  <scooper@apple.com>

            QuickTime plug-in cannot update com.apple.quicktime.plugin.preferences.plist file
            https://bugs.webkit.org/show_bug.cgi?id=118098
            <rdar://problem/13888138>

            Reviewed by Alexey Proskuryakov.

            Allow the preference file to be written

            * Resources/PlugInSandboxProfiles/com.apple.QuickTime Plugin.plugin.sb:

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152234

    2013-06-27  Jer Noble  <jer.noble@apple.com>

            Audio in apps which embed WebViews is corrupted.
            https://bugs.webkit.org/show_bug.cgi?id=118163

            Reviewed by Maciej Stachowiak.

            Expose the WebCore lowPowerVideoAudioBufferSizeEnabled setting to WebKit2 clients.

            * Shared/WebPreferencesStore.h:
            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::updatePreferences):

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152190

    2013-06-28  Tim Horton  <timothy_horton@apple.com>

            [wk2] WKView shouldn't force scrolling off if shouldClipToVisibleRect is set
            https://bugs.webkit.org/show_bug.cgi?id=118174
            <rdar://problem/14301175>

            Reviewed by Anders Carlsson.

            * UIProcess/API/mac/WKView.mm:
            (-[WKView _updateViewExposedRect]):
            Pass whether or not clips-to-visibleRect is enabled down to the WebPageProxy.

            (-[WKView setMinimumSizeForAutoLayout:]):
            Disable scrolling when using autolayout instead of when using clips-to-visibleRect.

            (-[WKView setShouldClipToVisibleRect:]):
            Clipping to the WKView's visibleRect does not strictly require scrolling to be disabled,
            and in fact there are cases (RTL/TB pagination) where we *must* scroll, even when the view
            is big enough to fit the content (the case clip-to-visibleRect was added for).

            * UIProcess/WebPageProxy.cpp:
            (WebKit::WebPageProxy::WebPageProxy):
            * UIProcess/WebPageProxy.h:
            * UIProcess/mac/WebPageProxyMac.mm:
            (WebKit::WebPageProxy::viewExposedRectChanged):
            (WebKit::WebPageProxy::exposedRectChangedTimerFired):
            Keep track of and forward to the drawing area whether or not clips-to-visibleRect is enabled.

            * WebProcess/WebPage/DrawingArea.h:
            (WebKit::DrawingArea::setClipsToExposedRect): Added.
            (WebKit::DrawingArea::didChangeScrollOffsetForAnyFrame): Added a missing space.

            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::viewExposedRectChanged):
            * WebProcess/WebPage/WebPage.h:
            * WebProcess/WebPage/WebPage.messages.in:
            Forward clips-to-visibleRect enabled state to the drawing area.

            * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.h:
            Add storage for m_clipsToExposedRect.

            * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
            (WebKit::TiledCoreAnimationDrawingArea::TiledCoreAnimationDrawingArea):
            (WebKit::TiledCoreAnimationDrawingArea::flushLayers):
            (WebKit::TiledCoreAnimationDrawingArea::setClipsToExposedRect):
            (WebKit::TiledCoreAnimationDrawingArea::updateMainFrameClipsToExposedRect):
            (WebKit::TiledCoreAnimationDrawingArea::createPageOverlayLayer):
            (WebKit::TiledCoreAnimationDrawingArea::didCommitChangesForLayer):
            Check m_clipsToExposedRect instead of the main-frame's isScrollable() to determine
            whether we should tell our TiledBackings to clip to the exposed rect we provide.

            We don't need to listen to mainFrameScrollabilityChanged anymore.

2013-07-01  Lucas Forschler  <lforschler@apple.com>

        Merge r152177

    2013-06-28  Tim Horton  <timothy_horton@apple.com>

            WARN_UNUSED_RESULT can't be used in API headers, but WKBundlePageExtendIncrementalRenderingSuppression tries to
            https://bugs.webkit.org/show_bug.cgi?id=118196
            <rdar://problem/14303613>

            Reviewed by Anders Carlsson.

            * WebProcess/InjectedBundle/API/c/WKBundlePagePrivate.h:

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151952

    2013-06-24  Simon Cooper  <scooper@apple.com>

            Silverlight triggers sandbox violations: deny network-bind 0.0.0.0:0
            https://bugs.webkit.org/show_bug.cgi?id=117966
            <rdar://problem/13927918>

            Reviewed by Sam Weinig.

            Allow assigning (via bind) an ephemeral port before connecting

            * Resources/PlugInSandboxProfiles/com.apple.QuickTime Plugin.plugin.sb:
            * Resources/PlugInSandboxProfiles/com.macromedia.Flash Player.plugin.sb:
            * Resources/PlugInSandboxProfiles/com.microsoft.SilverlightPlugin.sb:
            * Resources/PlugInSandboxProfiles/com.oracle.java.JavaAppletPlugin.sb:

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151950

    2013-06-24  Simon Cooper  <scooper@apple.com>

            PluginProcess deny file-read-data /Network/Library under addVolumeTracker
            https://bugs.webkit.org/show_bug.cgi?id=117965
            <rdar://problem/14121247>

            Reviewed by Alexey Proskuryakov.

            Silently deny reading /Network/Applications and 
            /Network/Library.

            * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151948

    2013-06-24  Simon Cooper  <scooper@apple.com>

            deny file-read-data /Library/CoreMediaIO/Plug-Ins/DAL
            https://bugs.webkit.org/show_bug.cgi?id=117964
            <rdar://problem/14036864>

            Reviewed by Alexey Proskuryakov.

            Permit reading of the /Library/CoreMediaIO/Plug-Ins/DAL
            subdirectory.

            * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151944

    2013-06-24  Simon Cooper  <scooper@apple.com>

            Repeating sandbox violations when playing Amazon Prime videos with Flash
            https://bugs.webkit.org/show_bug.cgi?id=117953
            <rdar://problem/14193693>

            Reviewed by Alexey Proskuryakov.

            Add some missing "standard" files for network service lookups

            * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151943

    2013-06-24  Simon Cooper  <scooper@apple.com>

            Plug-in sandbox violations attempting to access com.apple.CoreGraphics.plist
            https://bugs.webkit.org/show_bug.cgi?id=117963
            <rdar://problem/14084234>

            Reviewed by Alexey Proskuryakov.

            Permit the reading of the com.apple.CoreGraphics preference file

            * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151941

    2013-06-24  Simon Cooper  <scooper@apple.com>

            com.oracle.javadeployment.plist is not correctly specified in the JavaApplet plugin profile
            https://bugs.webkit.org/show_bug.cgi?id=117961
            <rdar://problem/14223823>

            Reviewed by Alexey Proskuryakov.

            Remove the trailing extraneous .plist from the preference file rule

            * Resources/PlugInSandboxProfiles/com.oracle.java.JavaAppletPlugin.sb:

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151940

    2013-06-24  Simon Cooper  <scooper@apple.com>

            PluginProcess sandbox violations on com.apple.networkConnect.plist when resetting Safari
            https://bugs.webkit.org/show_bug.cgi?id=117958
            <rdar://problem/13938149>

            Reviewed by Alexey Proskuryakov.

            Allow reading the com.apple.networkConnect plist.

            * Resources/PlugInSandboxProfiles/com.apple.ist.ds.appleconnect.webplugin.sb:

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151939

    2013-06-24  Simon Cooper  <scooper@apple.com>

            Java sandbox violation ipc-posix-shm-read-data /tmp/com.apple.csseed.67
            https://bugs.webkit.org/show_bug.cgi?id=117954
            <rdar://problem/14166577>

            Reviewed by Alexey Proskuryakov.

            Permit read access to this shared memory segment

            * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151938

    2013-06-24  Simon Cooper  <scooper@apple.com>

            Plugin Sandbox violation in /Library/Audio/Sounds/Banks
            https://bugs.webkit.org/show_bug.cgi?id=117957
            <rdar://problem/14163582>

            Reviewed by Alexey Proskuryakov.

            Permit read access to subdirectories under /Library/Audio/Sounds

            * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151927

    2013-06-24  Anders Carlsson  <andersca@apple.com>

            REGRESSION (r147591): can't type in Adobe Connect
            https://bugs.webkit.org/show_bug.cgi?id=117947
            <rdar://problem/14223539>

            Reviewed by Andreas Kling.

            With the change in r147591, it is now possible for a plug-in element to be focused before the plug-in
            starts. Handle this by focusing the plug-in right after it's started if necessary.

            * WebProcess/Plugins/PluginView.cpp:
            (WebKit::PluginView::didInitializePlugin):

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151877

    2013-06-22  Simon Fraser  <simon.fraser@apple.com>

            screen.availWidth always returns width of primary display
            https://bugs.webkit.org/show_bug.cgi?id=117863

            Reviewed by Geoffrey Garen.

            In WebKit2, Widgets have no platformWidget, so trying to get to the
            NSScreen via the platform widget's window never succeeded, and we always
            fell back on getting info for the main display.

            However, we were already pushing the WKView's displayID down to the
            WebProcess for the requestAnimationFrame infrastructure, so use that.

            The WebProcess would not receive a displayID for a WKView until the window
            was activated; fix by calling -doWindowDidChangeScreen when the view
            moves to a window, rather than doing it from -_windowDidBecomeKey:.

            * UIProcess/API/mac/WKView.mm:
            (-[WKView viewDidMoveToWindow]):
            (-[WKView _windowDidBecomeKey:]):

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151881

    2013-06-22  Dean Jackson  <dino@apple.com>

            Slightly reduce width threshold on detection of primary snapshotted Plug-In
            https://bugs.webkit.org/show_bug.cgi?id=117914
            <rdar://problem/14136687>

            Reviewed by Simon Fraser.

            We've noticed some content that should be detected as the primary snapshotted plug-in,
            but is just a bit smaller than our 450x300 minimum threshold. Reduce the width to 400.

            * WebProcess/WebPage/WebPage.cpp: Change primarySnapshottedPlugInMinimumWidth from 450 to 400.

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151832

    2013-06-21  Christophe Dumez  <ch.dumez@sisa.samsung.com>

            REGRESSION (r150663): Using webkitAudioContext in Inspector makes it undefined everywhere
            https://bugs.webkit.org/show_bug.cgi?id=117825

            Reviewed by Kentaro Hara.

            Use Settings to enable Web Audio instead of RuntimeEnabledFeatures.

            * WebProcess/InjectedBundle/InjectedBundle.cpp:
            (WebKit::InjectedBundle::overrideBoolPreferenceForTestRunner):
            * WebProcess/WebPage/WebPage.cpp:
            (WebKit::WebPage::updatePreferences):

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151795

    2013-06-20  Brady Eidson  <beidson@apple.com>

            WebProcess hangs loading eff.org (Waiting forever on a sync XHR, NetworkProcess unable to service it).
            <rdar://problem/14112329> and https://bugs.webkit.org/show_bug.cgi?id=117842

            Reviewed by Alexey Proskuryakov.

            * NetworkProcess/HostRecord.cpp:
            (WebKit::removeLoaderFromQueue): Utility to clear a Loader out of a LoaderQueue.
            (WebKit::HostRecord::removeLoader): Use removeLoaderFromQueue, and also try to clear the loader from m_syncLoadersPending.
            (WebKit::HostRecord::servePendingRequestsForQueue): Small refactoring/cleanup.
            (WebKit::HostRecord::limitsRequests): Change so that if the number of loaders in flight is exactly equal to the limit, then
              allow serving a synchronous loader to go exactly one beyond the limit.
            * NetworkProcess/HostRecord.h:

            Make the static maxRequestsInFlightPerHost a member of the NetworkResourceLoadScheduler, instead:
            * NetworkProcess/NetworkResourceLoadScheduler.cpp:
            (WebKit::NetworkResourceLoadScheduler::NetworkResourceLoadScheduler):
            (WebKit::NetworkResourceLoadScheduler::hostForURL):
            * NetworkProcess/NetworkResourceLoadScheduler.h:

            * NetworkProcess/mac/NetworkResourceLoadSchedulerMac.mm:
            (WebKit::NetworkResourceLoadScheduler::platformInitializeMaximumHTTPConnectionCountPerHost): Tell CFNetwork to allow
              7 connections per host instead of 6, but tell the scheduler that 6 is still the normal limit.

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151767

    2013-06-19  Sam Weinig  <sam@webkit.org>

            Expose plug-ins CFBundleShortVersionString in the WKPluginInformation dictionary
            https://bugs.webkit.org/show_bug.cgi?id=117816

            Reviewed by Geoffrey Garen.

            - Adds a new key for the WKPluginInformation dictionary: WKPluginInformationBundleShortVersionKey().

            * Shared/API/c/WKPluginInformation.cpp:
            (WKPluginInformationBundleShortVersionKey):
            * Shared/API/c/WKPluginInformation.h:
            * Shared/Plugins/Netscape/PluginInformation.cpp:
            (WebKit::pluginInformationBundleShortVersionKey):
            * Shared/Plugins/Netscape/PluginInformation.h:
            * Shared/Plugins/Netscape/mac/NetscapePluginModuleMac.mm:
            (WebKit::NetscapePluginModule::getPluginInfo):
            * Shared/Plugins/Netscape/mac/PluginInformationMac.mm:
            (WebKit::getPlatformPluginModuleInformation):
            * Shared/Plugins/PluginModuleInfo.h:

2013-06-26  Lucas Forschler  <lforschler@apple.com>

        Merge r151748

    2013-06-19  Anders Carlsson  <andersca@apple.com>

            REGRESSION: Cannot open Silverlight preferences via context menu
            https://bugs.webkit.org/show_bug.cgi?id=117806
            <rdar://problem/14166644>

            Reviewed by Beth Dakin.

            Hook the LSOpenCFURLRef function and make the UI process open the URL if it's the URL for the
            Silverlight Preferences application. This is what we do for the Flash updater.

            * PluginProcess/PluginProcess.h:
            * PluginProcess/mac/PluginProcessMac.mm:
            (WebKit::openCFURLRef):
            (WebKit::initializeShim):
            (WebKit::PluginProcess::openURL):
            * PluginProcess/mac/PluginProcessShim.h:
            * PluginProcess/mac/PluginProcessShim.mm:
            (WebKit::shimLSOpenCFURLRef):
            * UIProcess/Plugins/PluginProcessProxy.h:
            * UIProcess/Plugins/PluginProcessProxy.messages.in:
            * UIProcess/Plugins/mac/PluginProcessProxyMac.mm:
            (WebKit::isSilverlightPreferencesURL):
            (WebKit::shouldOpenURL):
            (WebKit::PluginProcessProxy::openURL):

2013-06-25  Lucas Forschler  <lforschler@apple.com>

        Merge r151929

    2013-06-24  Ruth Fong  <ruth_fong@apple.com>

            Expose the mediaHasAudio() function in WK2
            https://bugs.webkit.org/show_bug.cgi?id=117946
            <rdar://problem/14250527>

            Reviewed by Beth Dakin.

            Exposes the WebCore::HTMLMediaElement::mediaHasAudio() function
            in WK2.

            * WebProcess/InjectedBundle/API/c/WKBundleHitTestResult.cpp:
            (WKBundleHitTestResultMediaHasAudio): Added.
            * WebProcess/InjectedBundle/API/c/WKBundleHitTestResult.h:
            * WebProcess/InjectedBundle/InjectedBundleHitTestResult.cpp:
            (WebKit::InjectedBundleHitTestResult::mediaHasAudio): Added.
            * WebProcess/InjectedBundle/InjectedBundleHitTestResult.h:

2013-06-25  Lucas Forschler  <lforschler@apple.com>

        Merge r151760

    2013-06-19  Ruth Fong  <ruth_fong@apple.com>

            <rdar://problem/14197983> Rename functions from Bug 117667 and add safeguards for !ENABLE(VIDEO) platforms (117765)
            https://bugs.webkit.org/show_bug.cgi?id=117765

            Patch by Ruth Fong <ruth_fong@apple.com>.
            Reviewed by Brady Eidson.

            * WebProcess/InjectedBundle/API/c/WKBundleHitTestResult.cpp:
            (WKBundleHitTestResultGetMediaType): Updated to use mediaType().

            * WebProcess/InjectedBundle/InjectedBundleHitTestResult.cpp:
            (WebKit::InjectedBundleHitTestResult::mediaType): Updated.
            Renamed getMediaType() to mediaType() and now handles !ENABLE(VIDEO) platforms.

            * WebProcess/InjectedBundle/InjectedBundleHitTestResult.h:

2013-06-18  Roger Fong  <roger_fong@apple.com>

        Disable some feature flags.
        <rdar://problem/14171207>.

        Rubberstamped by Jon Lee.

        * Configurations/FeatureDefines.xcconfig:

2013-06-18  Roger Fong  <roger_fong@apple.com>

        Unreviewed. Fix a typo that may be causing some test failures.

        * WebProcess/WebCoreSupport/mac/WebFrameNetworkingContext.mm:
        (WebKit::WebFrameNetworkingContext::scheduledRunLoopPairs):

2013-06-18  Anders Carlsson  <andersca@apple.com>

        Make it possible to set a minimum height for auto-layout
        https://bugs.webkit.org/show_bug.cgi?id=117758
        <rdar://problem/12849080>

        Reviewed by Tim Horton.

        Change a bunch of minimumLayoutWidth declarations to minimumLayoutSize and add a new minimumLayoutSize property.
        If minimumLayoutSize.height is greater than zero, use it to set the minimum layout size on the frame view.

        * Shared/WebPageCreationParameters.cpp:
        (WebKit::WebPageCreationParameters::encode):
        (WebKit::WebPageCreationParameters::decode):
        * Shared/WebPageCreationParameters.h:
        * UIProcess/API/mac/WKView.mm:
        (-[WKView _setIntrinsicContentSize:]):
        (-[WKView minimumLayoutWidth]):
        (-[WKView setMinimumLayoutWidth:]):
        (-[WKView minimumWidthForAutoLayout]):
        (-[WKView setMinimumWidthForAutoLayout:]):
        (-[WKView minimumSizeForAutoLayout]):
        (-[WKView setMinimumSizeForAutoLayout:]):
        * UIProcess/API/mac/WKViewPrivate.h:
        * UIProcess/DrawingAreaProxy.h:
        (WebKit::DrawingAreaProxy::minimumLayoutSizeDidChange):
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::WebPageProxy):
        (WebKit::WebPageProxy::creationParameters):
        (WebKit::WebPageProxy::setMinimumLayoutSize):
        * UIProcess/WebPageProxy.h:
        (WebKit::WebPageProxy::minimumLayoutSize):
        * UIProcess/mac/TiledCoreAnimationDrawingAreaProxy.h:
        * UIProcess/mac/TiledCoreAnimationDrawingAreaProxy.mm:
        (WebKit::TiledCoreAnimationDrawingAreaProxy::TiledCoreAnimationDrawingAreaProxy):
        (WebKit::TiledCoreAnimationDrawingAreaProxy::minimumLayoutSizeDidChange):
        (WebKit::TiledCoreAnimationDrawingAreaProxy::didUpdateGeometry):
        (WebKit::TiledCoreAnimationDrawingAreaProxy::intrinsicContentSizeDidChange):
        (WebKit::TiledCoreAnimationDrawingAreaProxy::sendUpdateGeometry):
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::transitionToCommittedForNewPage):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::WebPage):
        (WebKit::WebPage::setMinimumLayoutSize):
        * WebProcess/WebPage/WebPage.h:
        (WebKit::WebPage::minimumLayoutSize):
        * WebProcess/WebPage/WebPage.messages.in:
        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::mainFrameContentSizeChanged):
        (WebKit::TiledCoreAnimationDrawingArea::updateGeometry):

2013-06-18  Simon Cooper  <scooper@apple.com>

        sandbox violation when Flash runs for the first time
        https://bugs.webkit.org/show_bug.cgi?id=117753
        <rdar://problem/14165466>

        Reviewed by Alexey Proskuryakov.

        Allow flash to try and change the ownership of directories it has just created.

        * Resources/PlugInSandboxProfiles/com.macromedia.Flash Player.plugin.sb:

2013-06-18  Ruth Fong  <ruth_fong@apple.com>

        Expose a getMediaType method in WebKit
        https://bugs.webkit.org/show_bug.cgi?id=117667

        Reviewed by Brady Eidson.

        * GNUmakefile.list.am:
        * Target.pri:
        Updated to include the added header file InjectedBundleHitTestResultMediaType.h
        
        * UIProcess/API/C/WKAPICast.h:
        (WebKit::toBundleHitTestResultMediaType):
        (WebKit::toAPI):
        Added methods to convert between BundleHitTestResultMediaType
        and WKBundleHitTestResultMediaType.

        * WebKit2.xcodeproj/project.pbxproj: Updated to include
        InjectedBundleHitTestResultMediaType.h in the WebKit2 project.

        * WebProcess/InjectedBundle/API/c/WKBundleHitTestResult.cpp:
        (WKBundleHitTestResultGetMediaType): Exposes the method getMediaType and
        hooks into InjectedBundleHitTestResult::getMediaType.

        * WebProcess/InjectedBundle/API/c/WKBundleHitTestResult.h:

        * WebProcess/InjectedBundle/InjectedBundleHitTestResult.cpp:
        (WebKit::InjectedBundleHitTestResult::getMediaType): Added to return 
        what type, if any, a media element is.

        * WebProcess/InjectedBundle/InjectedBundleHitTestResult.h:

        * WebProcess/InjectedBundle/InjectedBundleHitTestResultMediaType.h: Added
        to contain new BundleHitTestResultMediaType enums.

2013-06-18  Roger Fong  <roger_fong@apple.com>

        Re-implement WebFrameNetworkingContext.
        <rdar://problem/13174821>.

        Reviewed by Alexey Proskuryakov.

        * WebProcess/WebCoreSupport/mac/WebFrameNetworkingContext.h: Added.
        (WebKit::WebFrameNetworkingContext::create):
        (WebKit::WebFrameNetworkingContext::WebFrameNetworkingContext):
        * WebProcess/WebCoreSupport/mac/WebFrameNetworkingContext.mm: Added.
        (WebKit::WebFrameNetworkingContext::setPrivateBrowsingStorageSessionIdentifierBase):
        (WebKit::WebFrameNetworkingContext::ensurePrivateBrowsingSession):
        (WebKit::WebFrameNetworkingContext::destroyPrivateBrowsingSession):
        (WebKit::WebFrameNetworkingContext::setCookieAcceptPolicyForAllContexts):
        (WebKit::WebFrameNetworkingContext::needsSiteSpecificQuirks):
        (WebKit::WebFrameNetworkingContext::localFileContentSniffingEnabled):
        (WebKit::WebFrameNetworkingContext::scheduledRunLoopPairs):
        (WebKit::WebFrameNetworkingContext::sourceApplicationAuditData):
        (WebKit::WebFrameNetworkingContext::blockedError):
        (WebKit::WebFrameNetworkingContext::storageSession):

2013-06-18  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13174821> Remove files with an incorrect license.

        Rubber-stamped by Maciej Stachowiak.

        This will break the build, stay tuned for a fix coming soon.

        * WebProcess/WebCoreSupport/mac/WebFrameNetworkingContext.h: Removed.
        * WebProcess/WebCoreSupport/mac/WebFrameNetworkingContext.mm: Removed.

2013-06-17  Santosh Mahto  <santosh.ma@samsung.com>

        Extra whitespace in blank line in PlatformPopupMenuData.cpp
        https://bugs.webkit.org/show_bug.cgi?id=117627

        Reviewed by Brent Fulgham.

        * Shared/PlatformPopupMenuData.cpp:
        (WebKit::PlatformPopupMenuData::decode):
        Removing extra space

2013-06-17  Beth Dakin  <bdakin@apple.com>

        PageBanners appear over HTML5 video when media element is in full screen mode
        https://bugs.webkit.org/show_bug.cgi?id=117721
        -and corresponding-
        <rdar://problem/13686998>

        Reviewed by Sam Weinig.

        When an element enters fullscreen, hide the banners. Show them again when the 
        element exits fullscreen.
        * WebProcess/FullScreen/WebFullScreenManager.cpp:
        (WebKit::WebFullScreenManager::willEnterFullScreen):
        (WebKit::WebFullScreenManager::willExitFullScreen):

        Handle hiding and showing by removing or re-creating a parent layer for m_layer.
        * WebProcess/WebPage/PageBanner.cpp:
        (WebKit::PageBanner::hide):
        (WebKit::PageBanner::showIfHidden):
        * WebProcess/WebPage/PageBanner.h:
        * WebProcess/WebPage/mac/PageBannerMac.mm:
        (WebKit::PageBanner::PageBanner):
        (WebKit::PageBanner::hide):
        (WebKit::PageBanner::showIfHidden):
        (WebKit::PageBanner::mouseEvent):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::hidePageBanners):
        (WebKit::WebPage::showPageBanners):
        * WebProcess/WebPage/WebPage.h:

2013-06-17  Ruth Fong  <ruth_fong@apple.com>

        REGRESSION: Important controls are missing from <video> element UI, when compared to QuickTime
        https://bugs.webkit.org/show_bug.cgi?id=20599

        Add a "Download Video"/"Download Audio" context menu item to download media
        elements.

        Reviewed by Beth Dakin.

        * Shared/API/c/WKContextMenuItemTypes.h: Updated to include
        an enum type for the "Download Video/Audio" context menu item.

        * Shared/API/c/WKSharedAPICast.h: Updated to associate
        the enums in WebKit and WebCore that handle the "Download Video/Audio"
        context menu item.

        * UIProcess/API/efl/ewk_context_menu.cpp:
        * UIProcess/API/efl/ewk_context_menu_item.cpp:
        * UIProcess/API/efl/ewk_context_menu_item.h:
        Updated to include new EWK enum type for "Download Video/Audio" context menu item.

        * UIProcess/WebPageProxy.cpp: Updated to 
        handle the "Download Video/Audio" context menu item mouse click
        and download the media item in the UI process.

2013-06-17  Ralph Thomas  <ralpht@gmail.com>

        [CoordinatedGraphics][CSS Shaders] Use forwarding header for TextureMapperPlatformCompiledProgram.h
        https://bugs.webkit.org/show_bug.cgi?id=117712

        Reviewed by Noam Rosenthal.

        * Shared/CoordinatedGraphics/WebCustomFilterProgramProxy.h:

2013-06-17  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/13145014> Allow CoreIPC messages to transmit importance boosts

        Transmitting the importance boost from the UI process to the web process is particularly
        important when disabling process suppression on a web process, as it will minimize the
        delays that can occur before the message instructing process suppression to be disabled
        is processed by the web process.

        We keep the importance boost alive for the duration of the CoreIPC message handler. We
        achieve this by having an ImportanceAssertion object that owns the assertion, and whose
        lifetime is tied to that of the MessageDecoder.

        Reviewed by Anders Carlsson.

        * Platform/CoreIPC/MessageDecoder.cpp:
        (CoreIPC::MessageDecoder::setImportanceAssertion): Associate an importance assertion
        with this message.
        * Platform/CoreIPC/MessageDecoder.h:
        * Platform/CoreIPC/mac/ConnectionMac.cpp:
        (CoreIPC::Connection::open): Mark our receive port as allowing importance boosts to be received.
        (CoreIPC::Connection::receiveSourceEventHandler):
        * Platform/CoreIPC/mac/ImportanceAssertion.h:
        (CoreIPC::ImportanceAssertion::create):
        (CoreIPC::ImportanceAssertion::~ImportanceAssertion): Release the assertion.
        (CoreIPC::ImportanceAssertion::ImportanceAssertion): Take an assertion if a boost was present in
        the Mach message.

2013-06-17  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/14051357> Web processes sometimes remain in a suppressed
        state after their window is unoccluded.

        The code in WKView that responds to occlusion notifications was incorrectly
        treating the window's occlusion state as being an enum rather than the set of
        flags that it is.

        Reviewed by Oliver Hunt.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView _windowDidChangeOcclusionState:]): Test only the visibility state.
        (-[WKView setWindowOcclusionDetectionEnabled:]): Ditto.

2013-06-17  Michael Brüning  <michael.bruning@digia.com>

        [Qt] Remove Qt specific QTKIT flagged code.
        https://bugs.webkit.org/show_bug.cgi?id=117635

        Reviewed by Simon Hausmann.

        Due to disabling QTKIT for Qt in r151546, the
        code the flags that are not taken into account
        anymore and the code that has been rendered
        unreachable by this are removed.

        * Target.pri:
        * UIProcess/qt/WebContextQt.cpp:
        (WebKit::WebContext::platformInitializeWebProcess):
        * WebProcess/WebCoreSupport/qt/WebSystemInterface.h: Removed.
        * WebProcess/WebCoreSupport/qt/WebSystemInterface.mm: Removed.
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::updatePreferences):
        * WebProcess/qt/WebProcessMainQt.cpp:
        (WebKit::WebProcessMainQt):

2013-06-17  Grzegorz Czajkowski  <g.czajkowski@samsung.com>

        Unreviewed, rolling out r151632.
        http://trac.webkit.org/changeset/151632
        https://bugs.webkit.org/show_bug.cgi?id=117585

        Debug build error ASSERT(WTF_USE_GRAMMAR_CHECKING) for non MAC
        platforms

        * Shared/API/c/WKSharedAPICast.h:
        (WebKit::toAPI):
        (WebKit::toImpl):
        * UIProcess/API/efl/ewk_context_menu_item.cpp:
        (getEwkActionFromWKTag):
        * UIProcess/API/efl/tests/test_ewk2_text_checker.cpp:
        (onContextMenuShow):
        (TEST_F):
        * UIProcess/API/gtk/WebKitContextMenuActions.cpp:
        (webkitContextMenuActionGetActionTag):
        (webkitContextMenuActionGetForContextMenuItem):
        (webkitContextMenuActionGetLabel):
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::contextMenuItemSelected):

2013-06-14  Grzegorz Czajkowski  <g.czajkowski@samsung.com>

        Context menu grammar checking items are available when GRAMMAR_CHECKING macro is off
        https://bugs.webkit.org/show_bug.cgi?id=117585

        Reviewed by Anders Carlsson.

        Add GRAMMAR_CHECKING guard to the context menu grammar items.

        * Shared/API/c/WKSharedAPICast.h:
        (WebKit::toAPI):
        (WebKit::toImpl):
        * UIProcess/API/efl/ewk_context_menu_item.cpp:
        (getEwkActionFromWKTag):
        * UIProcess/API/efl/tests/test_ewk2_text_checker.cpp:
        (checkSpellingItemsAvailability):
        Change callback name, to be consistent with a newly added.

        (checkSpellingAndGrammarSubmenuAvailability):
        (checkGrammarWithSpellingItemAvailability):
        Add two unit tests for EFL to check whether context menu grammar items are
        available only when GRAMMAR_CHECKING macro is enabled.

        * UIProcess/API/gtk/WebKitContextMenuActions.cpp:
        (webkitContextMenuActionGetActionTag):
        (webkitContextMenuActionGetForContextMenuItem):
        (webkitContextMenuActionGetLabel):
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::contextMenuItemSelected):

2013-06-14  Dean Jackson  <dino@apple.com>

        Crash in supportsSnapshotting
        https://bugs.webkit.org/show_bug.cgi?id=117670
        <rdar://problem/14059711>

        Reviewed by Darin Adler.

        Speculative fix for deferencing a null RefPtr in supportsSnapshotting.
        It seems like it was possible to get in a state where the plugin machinery
        would fire up and attempt to get a screenshot before there was an active
        connection to the plugin process (usually under periods of high load, such
        as opening a lot of tabs at once). In this case we're now returning false
        from supportsSnapshotting, which will trigger the plugin to restart, but
        that's better than requesting a snapshot on something that doesn't yet exist.

        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::supportsSnapshotting): Guard for an empty connection object.

2013-06-14  Enrica Casucci  <enrica@apple.com>

        WKPageFindStringMatches ignores the kWKFindOptionsBackwards option.
        https://bugs.webkit.org/show_bug.cgi?id=117647
        <rdar://problem/13881024>

        Reviewed by Darin Adler.
        
        The API returns the matched ranges in the DOM order regardless of the
        find direction, but the index of the first match after the user selection
        should take the find direction into account.

        Extended existing test in TestWebKitAPI.

        * Shared/API/c/WKFindOptions.h: Added enum for the case where there are
        no matches after the user selection in the direction of the find.

2013-06-14  Andres Gomez  <agomez@igalia.com>

        [GTK] Compilation problems - hb.h not found
        https://bugs.webkit.org/show_bug.cgi?id=117636

        Unreviewed GTK+ build fix.

        * GNUmakefile.am: Added freetype cflags for WebKit2 GTK+ Platform
        library.

2013-06-13  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [EFL][WK2] Wrong context menu and popup menu positions when scroll is applied
        https://bugs.webkit.org/show_bug.cgi?id=116610

        Reviewed by Noam Rosenthal.

        WebKit2 EFL uses fixed layout - because of this ScrollView::contentsToWindow, does
        not take scroll into account, as it is meant to be handled by UI application.
        When popup and context menu are created, after calling contentsToWindow their position
        are not adjusted to page scroll.
        Added two functions to EwkView and WKView, converting contents position to user viewport
        coordinates, to adjust popup and context menu positions.

        * UIProcess/API/C/CoordinatedGraphics/WKView.cpp:
        (WKViewContentsToUserViewport):
        * UIProcess/API/C/CoordinatedGraphics/WKView.h:
        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::showContextMenu):
        (EwkView::requestPopupMenu):
        * UIProcess/CoordinatedGraphics/WebView.cpp:
        (WebKit::WebView::contentsToUserViewport):
        * UIProcess/CoordinatedGraphics/WebView.h:

2013-06-12  Anders Carlsson  <andersca@apple.com>

        Remove the notion of inactive plug-ins
        https://bugs.webkit.org/show_bug.cgi?id=117570
        <rdar://problem/13484213>

        Reviewed by Tim Horton.

        Remove code that deals with inactive plug-ins. We still keep around the kWKPluginLoadPolicyInactive API enum for now.

        * Shared/Plugins/PluginModuleInfo.h:
        * UIProcess/API/C/WKAPICast.h:
        (WebKit::toWKPluginLoadPolicy):
        (WebKit::toPluginModuleLoadPolicy):
        * UIProcess/Plugins/PluginInfoStore.cpp:
        * UIProcess/Plugins/PluginInfoStore.h:
        * UIProcess/Plugins/mac/PluginInfoStoreMac.mm:
        (WebKit::PluginInfoStore::shouldUsePlugin):
        (WebKit::PluginInfoStore::defaultLoadPolicyForPlugin):
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::findPlugin):
        (WebKit::WebPageProxy::unavailablePluginButtonClicked):
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::shouldUnavailablePluginMessageBeButton):
        (WebKit::WebChromeClient::unavailablePluginButtonClicked):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::createPlugin):

2013-06-12  Hugo Parente Lima  <hugo.lima@openbossa.org>

        [GTK] Explicit include glib.h to avoid compilation errors if libsoup isn't used.
        https://bugs.webkit.org/show_bug.cgi?id=117564

        Reviewed by Martin Robinson.

        * UIProcess/Launcher/gtk/ProcessLauncherGtk.cpp:

2013-06-12  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Move more build targets for source code that's free of layer violations into libPlatform
        https://bugs.webkit.org/show_bug.cgi?id=115936

        Reviewed by Martin Robinson.

        * GNUmakefile.am: Add GStreamer dependency's CFLAGS to the list of libPlatformGtk2 CPPFLAGS.

2013-06-12  Ruth Fong  <ruth_fong@apple.com>

        "Open Video in New Window" doesn't make sense in fullscreen
        https://bugs.webkit.org/show_bug.cgi?id=117556

        Reviewed by Beth Dakin.

        Adds method mediaIsInFullscreen() that checks if a media element is in
        fullscreen mode, which is needed to decide when to display the
        "Open Video in New Window" context menu item.

        * WebProcess/InjectedBundle/API/c/WKBundleHitTestResult.cpp:
        (WKBundleHitTestResultMediaIsInFullscreen): Added.
        Hooks into new InjectedBundleHitTestResult::mediaIsInFullscreen() method.
        * WebProcess/InjectedBundle/API/c/WKBundleHitTestResult.h:
        * WebProcess/InjectedBundle/InjectedBundleHitTestResult.cpp:
        (WebKit::InjectedBundleHitTestResult::mediaIsInFullscreen): Added.
        Checks if media element is in fullscreen.
        * WebProcess/InjectedBundle/InjectedBundleHitTestResult.h:

2013-06-12  Ruth Fong  <ruth_fong@apple.com>

        Allow for toggling fullscreen on <video> elements
        https://bugs.webkit.org/show_bug.cgi?id=117220

        Reviewed by Dean Jackson.

        * Shared/API/c/WKContextMenuItemTypes.h:
        * Shared/API/c/WKSharedAPICast.h:
        Added variables to support the toggle-ability of the fullscreen
        video context menu item.

2013-06-12  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Invalidate the ProcessLauncher when the process is terminated before it has finished launching
        https://bugs.webkit.org/show_bug.cgi?id=117412

        Reviewed by Anders Carlsson.

        * UIProcess/Launcher/gtk/ProcessLauncherGtk.cpp:
        (WebKit::ProcessLauncher::terminateProcess): If process is still
        launching just invalidate the launcher. Reset the process
        identifier after killing the process.

2013-06-12  Jae Hyun Park  <jae.park@company100.net>

        [Coordinated Graphics] Remove unused headers in CoordinatedLayerTreeHostProxy
        https://bugs.webkit.org/show_bug.cgi?id=117539

        Reviewed by Noam Rosenthal.

        * UIProcess/CoordinatedGraphics/CoordinatedLayerTreeHostProxy.cpp:
        * UIProcess/CoordinatedGraphics/CoordinatedLayerTreeHostProxy.h:

2013-06-12  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Remove the WebCoreLayer(Gtk2).a archives before regenerating them
        https://bugs.webkit.org/show_bug.cgi?id=116723

        Reviewed by Carlos Garcia Campos.

        * GNUmakefile.am: When generating the WebCoreLayerGtk2.a archive from all the dependency archives, remove the
        current archive (if any). Updating an existent archive in an incremental build is not bulletproof and can lead
        to corrupt archives and subsequent build failures. On the other hand, the archive generation is not expensive
        and produces a working archive without problems even on incremental builds.

2013-06-12  Zan Dobersek  <zdobersek@igalia.com>

        Unreviewed GTK build fix.

        * GNUmakefile.list.am: Adding missing build targets to the plugin process after r151480.

2013-06-11  Gavin Barraclough  <barraclough@apple.com>

        Add NSSupportsAppNap keys to WebProcess, PluginProcess
        https://bugs.webkit.org/show_bug.cgi?id=117528

        Reviewed by Mark Rowe.

        * PluginProcess/EntryPoint/mac/LegacyProcess/Info.plist:
        * PluginProcess/EntryPoint/mac/XPCService/PluginService.32-64.Info.plist:
        * PluginProcess/EntryPoint/mac/XPCService/PluginService.Development/Info.plist:
        * WebProcess/EntryPoint/mac/LegacyProcess/Info.plist:
        * WebProcess/EntryPoint/mac/XPCService/WebContentService.Development/Info.plist:
        * WebProcess/EntryPoint/mac/XPCService/WebContentService/Info.plist:
            - add NSSupportsAppNap key.

2013-06-11  Oliver Hunt  <oliver@apple.com>

        Make sure we aren't throttling plugin timers during initialisation and destruction
        https://bugs.webkit.org/show_bug.cgi?id=117522

        Reviewed by Darin Adler.

        Add a new ActivityAssertion RAII class to handle allowing/disallowing
        timer throttling.  Then make use of it during plugin initialisation
        and destruction, as well as any synchronous messages (on the basis
        that if another process is waiting for the plugin we shouldn't be
        throttling timers).

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * PluginProcess/WebProcessConnection.cpp:
        (WebKit::WebProcessConnection::didReceiveSyncMessage):
        (WebKit::WebProcessConnection::destroyPlugin):
        (WebKit::WebProcessConnection::createPlugin):
        * Shared/ActivityAssertion.cpp: Added.
        (WebKit::ActivityAssertion::ActivityAssertion):
        (WebKit::ActivityAssertion::~ActivityAssertion):
        * Shared/ActivityAssertion.h: Added.
        * Target.pri:
        * WebKit2.xcodeproj/project.pbxproj:

2013-06-06  Timothy Hatcher  <timothy@apple.com>

        Update the framework bundle identifier for the Web Inspector.

        Reviewed by Mark Rowe.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::inspectorReallyUsesWebKitUserInterface):
        (WebKit::WebInspectorProxy::inspectorPageURL):
        (WebKit::WebInspectorProxy::inspectorBaseURL):
        * WebProcess/WebPage/mac/WebInspectorMac.mm:
        (WebKit::inspectorReallyUsesWebKitUserInterface):
        (WebKit::WebInspector::localizedStringsURL):

2013-06-11  Jer Noble  <jer.noble@apple.com>

        Do not filter cookies requested through the CookieStorageShim.
        https://bugs.webkit.org/show_bug.cgi?id=117511
        <rdar://problem/13603433>

        Reviewed by Beth Dakin.

        Since the shim function is called when the underlying media engine is
        creating an HTTPRequest, use CookieRequestHeaderFieldValue (which does
        not filter out HTTP-only cookies) rather than CookiesForDOM (which does).

        * Shared/mac/CookieStorageShim.cpp:
        (WebKit::webKitCookieStorageCopyRequestHeaderFieldsForURL):

2013-06-11  Seokju Kwon  <seokju.kwon@gmail.com>

        Remove leftover wxWebkit code
        https://bugs.webkit.org/show_bug.cgi?id=117471

        Reviewed by Andreas Kling.

        * Scripts/generate-forwarding-headers.pl:

2013-06-11  Changhyup Jwa  <ch.jwa@samsung.com>

        [EFL][WK2] Add fallback for EWK2UnitTestBase if opengl is not available.
        https://bugs.webkit.org/show_bug.cgi?id=117504

        Reviewed by Christophe Dumez.

        There're many fails on efl webkit2 unit test if opengl is not available.
        So, add fallback to non-opengl evas engine.

        * UIProcess/API/efl/tests/UnitTestUtils/EWK2UnitTestBase.cpp:
        (EWK2UnitTest::EWK2UnitTestBase::SetUp):

2013-06-11  Csaba Osztrogonác  <ossy@webkit.org>

        Make WTR use its own temporary directory for application cache
        https://bugs.webkit.org/show_bug.cgi?id=117143

        Reviewed by Alexey Proskuryakov.

        * UIProcess/API/C/WKContext.cpp:
        (WKContextSetApplicationCacheDirectory):
        * UIProcess/API/C/WKContextPrivate.h:
        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::applicationCacheDirectory):
        * UIProcess/WebContext.h:
        (WebKit::WebContext::setApplicationCacheDirectory):
        * UIProcess/efl/WebContextEfl.cpp:
        (WebKit::WebContext::platformDefaultApplicationCacheDirectory):
        * UIProcess/gtk/WebContextGtk.cpp:
        (WebKit::WebContext::platformDefaultApplicationCacheDirectory):
        * UIProcess/mac/WebContextMac.mm:
        (WebKit::WebContext::platformDefaultApplicationCacheDirectory):
        * UIProcess/qt/WebContextQt.cpp:
        (WebKit::WebContext::platformDefaultApplicationCacheDirectory):

2013-06-11  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [EFL][WK2] Fix test_ewk2_context_menu
        https://bugs.webkit.org/show_bug.cgi?id=116601

        Reviewed by Gyuyoung Kim.

        test_ewk2_context_menu is always passing, it does not test any context menu feature
        as it ends before context menu is called.
        One single test was divided into two tests: testing WebKit2 created context menu and
        testing menus and items created by application.

        * UIProcess/API/efl/tests/UnitTestUtils/EWK2UnitTestBase.cpp:
        (EWK2UnitTest::EWK2UnitTestBase::waitUntilTrue): added function introducing internal loop until boolean value is changed to true
        * UIProcess/API/efl/tests/UnitTestUtils/EWK2UnitTestBase.h:
        * UIProcess/API/efl/tests/test_ewk2_context_menu.cpp:
        (customItemSelected):
        (showContextMenu):
        (showContextMenuForRemoveAndAppend):
        (showContextMenuForSubmenu):
        (hideContextMenu):
        (TEST_F):

2013-06-11  Ryuan Choi  <ryuan.choi@samsung.com>

        [EFL][WK2] Add ewk_view_navigate API
        https://bugs.webkit.org/show_bug.cgi?id=117467

        Reviewed by Christophe Dumez.

        The applications will use this API to navigate history more than one step.

        * UIProcess/API/efl/ewk_back_forward_list_item_private.h:
        (EwkBackForwardListItem::wkItem): Return WKBackForwardListItemRef for page to navigate.
        * UIProcess/API/efl/ewk_view.cpp:
        (ewk_view_navigate_to): Added new API.
        * UIProcess/API/efl/ewk_view.h:
        * UIProcess/API/efl/tests/test_ewk2_view.cpp:
        (TEST_F): Added more test case for navigation.

2013-06-10  Jae Hyun Park  <jae.park@company100.net>

        [CoordinatedGraphics] Typos in custom shader support
        https://bugs.webkit.org/show_bug.cgi?id=117413

        Reviewed by Noam Rosenthal.

        Wrong keyframe is passed when assigning filterValue.

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::prepareCustomFilterProxiesIfNeeded):

2013-06-10  Seokju Kwon  <seokju.kwon@gmail.com>

        [Qt][GTK] Build fix after r151403
        https://bugs.webkit.org/show_bug.cgi?id=117452

        Reviewed by Csaba Osztrogonác.

        * UIProcess/API/gtk/PageClientImpl.cpp:
        (WebKit::PageClientImpl::preferencesDidChange):
        * UIProcess/API/gtk/PageClientImpl.h:
        * UIProcess/API/qt/raw/qrawwebview_p_p.h:
        (QRawWebViewPrivate::preferencesDidChange):
        * UIProcess/qt/QtPageClient.h:
        (WebKit::QtPageClient::preferencesDidChange):

2013-06-10  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r151411.
        http://trac.webkit.org/changeset/151411
        https://bugs.webkit.org/show_bug.cgi?id=117453

        because it is duplicated with Bug 117441 (Requested by
        gyuyoung_ on #webkit).

        * UIProcess/efl/WebViewEfl.cpp:
        * UIProcess/efl/WebViewEfl.h:

2013-06-10  Jaehun Lim  <ljaehun.lim@samsung.com>

        Fix build error and warning
        https://bugs.webkit.org/show_bug.cgi?id=117441

        Reviewed by Anders Carlsson.

        * UIProcess/CoordinatedGraphics/WebView.cpp:
        (WebKit::WebView::preferencesDidChange): Added.
        (WebKit::WebView::createPopupMenuProxy): Remove 'page'.
        * UIProcess/CoordinatedGraphics/WebView.h:

2013-06-10  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        Unreviewed, EFL Build fix after r151403.

        Added preferencesDidChange to WebViewEfl.

        * UIProcess/efl/WebViewEfl.cpp:
        (WebKit::WebViewEfl::preferencesDidChange):
        * UIProcess/efl/WebViewEfl.h:

2013-06-10  Anders Carlsson  <andersca@apple.com>

        Crash in StorageAreaMap::applyChange when clearing local storage in another web process
        https://bugs.webkit.org/show_bug.cgi?id=117440
        <rdar://problem/13961548>

        Reviewed by Tim Horton.

        Add an early return so we won't try to look up a null key in the m_pendingValueChanges map.
        Also, fix an assertion - it's fine for m_storageMap to be null in applyChange.

        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::StorageAreaMap::applyChange):

2013-06-10  Sergio Correia  <sergio.correia@openbossa.org>

        [WK2][CoordinatedGraphics] Add default case to switches to fix strict build
        https://bugs.webkit.org/show_bug.cgi?id=117416

        Reviewed by Noam Rosenthal.

        This patch fixes a strict build by asserting on the default case of two
        switch statements where gcc was previously complaining of unhandled cases.

        * Shared/CoordinatedGraphics/CoordinatedGraphicsArgumentCoders.cpp:
        (CoreIPC::::encode):
        (CoreIPC::::decode):

2013-06-10  Anders Carlsson  <andersca@apple.com>

        -[WKView _updateWindowAndViewFrames] should avoid updating the view frame in window coordinates if we don't have plugins
        https://bugs.webkit.org/show_bug.cgi?id=117420
        <rdar://problem/14073034>

        Reviewed by Tim Horton.

        If plug-ins are disabled there's no need for the web process to know about the view frame in window coordinates so only
        send it when plug-ins are enabled. In addition, if accessibility is disabled we don't need to send a message at all.

        * UIProcess/API/mac/PageClientImpl.h:
        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::preferencesDidChange):
        Call through to -[WKView _preferencesDidChange].

        * UIProcess/API/mac/WKView.mm:
        (-[WKView _updateWindowAndViewFrames]):
        Don't compute viewFrameInWindowCoordinates or accessibilityPosition unless they're required. If neither are required,
        don't even send a message to the web process.

        (-[WKView _preferencesDidChange]):
        Update _needsViewFrameInWindowCoordinates and call -[WKView _updateWindowAndViewFrames] if needed.

        (-[WKView initWithFrame:contextRef:pageGroupRef:relatedToPage:]):
        Set _needsViewFrameInWindowCoordinates based on whether plug-ins are enabled or not.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::preferencesDidChange):
        Call the page client.

2013-06-10  Bear Travis  <betravis@adobe.com>

        [CSS Shapes][CSS Exclusions] Split CSS Exclusions and CSS Shapes code
        https://bugs.webkit.org/show_bug.cgi?id=117162

        Reviewed by Alexandru Chiculita.

        Adding the WebCore/rendering/shapes directory to the include list.

        * CMakeLists.txt:

2013-06-10  Iago Toral Quiroga  <itoral@igalia.com>

        Use Cairo implementation of the WidgetBackingStore instead of X11 when running on Wayland
        https://bugs.webkit.org/show_bug.cgi?id=116717

        Reviewed by Martin Robinson.

        Decide which implementation of WidgetBackingStore to use (X11 or Cairo)
        depending on whether we are running on X11 or not. Select Cairo
        implementation when not running in X11.

        * UIProcess/cairo/BackingStoreCairo.cpp:
        (WebKit):
        (WebKit::createBackingStoreForGTK):
        (WebKit::BackingStore::incorporateUpdate):

2013-06-09  Jae Hyun Park  <jae.park@company100.net>

        [CoordinatedGraphics] Typo in argument decoder for CoordinatedGraphicsState
        https://bugs.webkit.org/show_bug.cgi?id=117384

        Reviewed by Noam Rosenthal.

        For CSS Shaders, it must decode state.customFiltersToRemove instead of
        state.updateAtlasesToRemove.

        * Shared/CoordinatedGraphics/CoordinatedGraphicsArgumentCoders.cpp:
        (CoreIPC::::decode):

2013-06-08  Jae Hyun Park  <jae.park@company100.net>

        [Coordinated Graphics] Pass the ownership of GraphicsSurface explicitly
        https://bugs.webkit.org/show_bug.cgi?id=117379

        Reviewed by Noam Rosenthal.

        When creating WebCoordinatedSurface with GraphicsSurface, it is clearer
        to pass the ownership of the created GraphicsSurface explicitly.

        * Shared/CoordinatedGraphics/WebCoordinatedSurface.cpp:
        (WebKit::WebCoordinatedSurface::create):

2013-06-07  Anders Carlsson  <andersca@apple.com>

        Coalesce multiple calls to WebPageProxy::windowAndViewFramesChanged
        https://bugs.webkit.org/show_bug.cgi?id=117364
        <rdar://problem/14042099>

        Reviewed by Geoffrey Garen.

        -[WKView _updateWindowAndViewFrames] can be called many times per run loop iteration so coalesce calls
        to WebPageProxy::windowAndViewFrames using dispatch_async.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView _updateWindowAndViewFrames]):

2013-06-07  Thomas Deniau  <deniau@apple.com>

        Reproducible crash with triple-finger-tap "define word" gesture on a Netflix video
        https://bugs.webkit.org/show_bug.cgi?id=117020

        Reviewed by Ryosuke Niwa.

        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::performDictionaryLookupAtLocation):
        Don't invoke the Dictionary lookup when we failed to extract the range of the token
        surrounding the tapped position.

2013-06-07  Enrique Ocana Gonzalez  <eocanha@igalia.com>

        [GTK] Weird behaviour and no clues to the user when the shared memory file can't be opened
        https://bugs.webkit.org/show_bug.cgi?id=117063

        Reviewed by Anders Carlsson.

        Log error message when the shared memory file can't be opened in
        Unix platform using a release build

        * Platform/unix/SharedMemoryUnix.cpp:
        (WebKit::SharedMemory::create):

2013-06-07  Grzegorz Czajkowski  <g.czajkowski@samsung.com>

        [EFL][WK2] Context menu spellchecking items are not available when "Check Spelling While Typing" is off
        https://bugs.webkit.org/show_bug.cgi?id=117190

        Reviewed by Christophe Dumez.

        Context menu items (suggestions, learn and ignore word) are not available
        due to missing dictionary. To get the suggestions for the misspelled word,
        the dictionary has to be loaded first.

        WebKit loads the default dictionary when check spelling while typing is being enabled.
        However, context menu spellchecking items should be present even if this setting is off.

        * UIProcess/API/efl/ewk_context.cpp:
        (EwkContext::EwkContext):
        Load the user's default dictionary to ensure context menu spellchecking items.
        The dictionary is loaded asynchronously so it shouldn't delay application.

        * UIProcess/API/efl/ewk_text_checker.h:
        Update doc. Spelling suggestions, learn and ignore word should be available
        independently of checking spelling while typing setting.

        * UIProcess/API/efl/tests/test_ewk2_text_checker.cpp:
        (onContextMenuShow):
        (TEST_F):
        Add two unit tests to check whether the default dictionary is loaded and
        whether the context menu spelling items are available.

        * UIProcess/efl/TextCheckerEfl.cpp:
        (WebKit::TextChecker::setContinuousSpellCheckingEnabled):
        (WebKit::TextChecker::continuousSpellCheckingEnabledStateChanged):
        Not set the default dictionary while enabling the setting, it's already loaded.

2013-06-07  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [EFL][WK2] Implement customContextMenuItemSelected
        https://bugs.webkit.org/show_bug.cgi?id=117298

        Reviewed by Christophe Dumez.

        When custom context menu item is selected using ewk API, the feedback is not
        sent back to application, as customContextMenuItemSelected was unimplemented in
        contextMenuClientEfl.

        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::customContextMenuItemSelected):
        * UIProcess/API/efl/EwkView.h:
        * UIProcess/API/efl/ewk_view.h: added custom_item_selected callback.
        * UIProcess/efl/ContextMenuClientEfl.cpp:
        (customContextMenuItemSelected):
        (ContextMenuClientEfl::ContextMenuClientEfl):

2013-06-06  Oliver Hunt  <oliver@apple.com>

        Completely initialize ChildProcess state on launch
        https://bugs.webkit.org/show_bug.cgi?id=117328

        Reviewed by Sam Weinig.

        Use setProcessSuppressionEnabledInternal to avoid setProcessSuppressionEnabled
        "optimizing" our initialization away.

        * Shared/mac/ChildProcessMac.mm:
        (WebKit::ChildProcess::platformInitialize):

2013-06-06  Rafael Brandao  <rafael.lobo@openbossa.org>

        [Gtk] Connection is leaking when WebProcess is terminated
        https://bugs.webkit.org/show_bug.cgi?id=117293

        Reviewed by Martin Robinson.

        Connection is leaking because WorkQueue::SocketEventSource inherits from
        WorkQueue::EventSource but when it is destroyed, the actual destructor running
        is the one from base class; however, subclass contains a function binded from
        Connection (m_closeFunction) and we need to do this extra cleanup, otherwise
        WorkQueue will keep Connection alive. A better explanation of this fix is provided
        on http://stackoverflow.com/questions/461203/when-to-use-virtual-destructors

        A quick way to see the leak is to change WK2 test "ReloadPageAfterCrash" to terminate
        WebProcess N times and add a printf on Connection destructor.

        * Platform/gtk/WorkQueueGtk.cpp:
        (WorkQueue::EventSource::~EventSource): Adds a virtual destructor to enable
        the subclass to do its own cleanup.

2013-06-06  Jae Hyun Park  <jae.park@company100.net>

        Coordinated Graphics : Refactor CoordinatedSurface to manage the lifecycle of GraphicsContext
        https://bugs.webkit.org/show_bug.cgi?id=108899

        Reviewed by Noam Rosenthal.

        This is a preparation patch for Threaded Coordinated Graphics.

        This patch changes CoordinatedSurface to be responsible for the
        lifecycle of GraphicsContext used in Coordinated Graphics System.
        CoordinatedImageBacking and UpdateAtlas do not ask for the ownership
        of GraphicsContext anymore. Instead, those classes use client pattern to
        ask the CoordiantedSurface to paint to the GraphicsContext.

        This refactoring is needed to implement CoordinatedSurface for Threaded
        Coordinated Graphics.

        * Shared/CoordinatedGraphics/WebCoordinatedSurface.cpp:
        (WebKit::WebCoordinatedSurface::paintToSurface):
        * Shared/CoordinatedGraphics/WebCoordinatedSurface.h:
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::paintToSurface):
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.h:

2013-06-05  Kangil Han  <kangil.han@samsung.com>

        [EFL][WK2] Fix test_ewk2_view unit test timed out issue
        https://bugs.webkit.org/show_bug.cgi?id=117251

        Reviewed by Christophe Dumez.

        'ewk_view_contents_size_changed' unit test case has been timed out since r150802 because
        same size is filtered by WebView class. So create one different test html string that has
        different size to continue unit tests.

        * UIProcess/API/efl/tests/test_ewk2_view.cpp:
        (onContentsSizeChangedPortrait):
        (onContentsSizeChangedLandscape):
        (TEST_F):

2013-06-05  Bear Travis  <betravis@adobe.com>

        [CSS Exclusions][CSS Shapes] Split CSS Exclusions & Shapes compile & runtime flags
        https://bugs.webkit.org/show_bug.cgi?id=117172

        Reviewed by Alexandru Chiculita.

        Adding the CSS_SHAPES compile flag.

        * Configurations/FeatureDefines.xcconfig:

2013-06-05  Anders Carlsson  <andersca@apple.com>

        Crash if an IPC connection is invalidated before it's completely set up
        https://bugs.webkit.org/show_bug.cgi?id=117274
        <rdar://problem/13319035>

        Reviewed by Andreas Kling.

        Resume our dispatch sources on the connection queue so we won't get invalidation callbacks before
        all sources have been set up.

        * Platform/CoreIPC/mac/ConnectionMac.cpp:
        (CoreIPC::Connection::open):
        (CoreIPC::Connection::sendOutgoingMessage):
        (CoreIPC::Connection::initializeDeadNameSource):
        (CoreIPC::Connection::receiveSourceEventHandler):

2013-06-05  Tim Horton  <timothy_horton@apple.com>

        [wk2] WebProcess' page-in-window count can be wrong
        https://bugs.webkit.org/show_bug.cgi?id=117106
        <rdar://problem/14040991>

        Reviewed by Anders Carlsson.

        If we're using a single WebProcess and a window is closed, we were
        not decrementing the page-in-window count (because we apparently don't
        setIsInWindow(false) a WebPage in a closing window before tearing it down).

        Turn the page-in-window count into a HashSet of pageIDs instead.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::WebPage):
        (WebKit::WebPage::setIsInWindow):
        Send the pageID instead (this change is just so that I don't need to
        fetch the WebPage in WebProcess::removeWebPage).

        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::WebProcess):
        Remove m_inWindowPageCount.

        (WebKit::WebProcess::removeWebPage):
        Ensure that WebPages being torn-down are removed from the in-window WebPage set.

        (WebKit::WebProcess::pageDidEnterWindow):
        (WebKit::WebProcess::pageWillLeaveWindow):
        Use our new HashSet instead of a count.

        (WebKit::WebProcess::nonVisibleProcessCleanupTimerFired):
        Make sure that we don't have any visible pages before doing cleanup.

        * WebProcess/WebProcess.h:
        Remove m_inWindowPageCount.
        Add m_inWindowPageSet.
        Make pageDidEnterWindow/pageWillLeaveWindow take pageID instead of WebPage.

2013-06-05  Tim Horton  <timothy_horton@apple.com>

        REGRESSION (r148713): Crash under waitForDidUpdateInWindowState
        https://bugs.webkit.org/show_bug.cgi?id=117268
        <rdar://problem/13822353>

        Reviewed by Anders Carlsson.

        Check if the WebProcess is valid before waiting for a message from it.
        Reset the bool that tells us that we have an outstanding didUpdateInWindowState message if the WebProcess quits.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::waitForDidUpdateInWindowState):
        (WebKit::WebPageProxy::resetStateAfterProcessExited):

2013-06-05  Gwang Yoon Hwang  <ryumiel@company100.net>

        [Coordinated Graphics] Prevent a recursive painting in CoordinatedGraphicsLayer
        https://bugs.webkit.org/show_bug.cgi?id=117222

        Reviewed by Noam Rosenthal.

        CoordinatedGraphicsLayer::flushCompositingState() will cross frame
        boundaries if the GraphicsLayers are connected. In this case,
        updateContentBuffers will invoke a painting of a sub-frame that causes
        flushCompositingState recursively.

        To prevent this behavior this patch extracts updateContentBuffers from
        flushCompositingState, and places it in
        updateContentBuffersIncludeSublayers, which traverses the tree
        separately from flushing the state for painting.

        No new tests, covered by existing tests.

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::flushPendingLayerChanges):

2013-06-05  Gwang Yoon Hwang  <ryumiel@company100.net>

        [Coordinated Graphics] Rename client classes for CoordinatedImageBacking and UpdateAtlas.
        https://bugs.webkit.org/show_bug.cgi?id=111948

        Reviewed by Noam Rosenthal.

        This patch renames CoordinatedImageBacking::Coordinator to
        CoordinatedImageBacking::Client, and UpdateAtlasClient to
        UpdateAtlas::Client for naming consistency and clarification.

        No new tests, covered by existing tests.

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.h:

2013-06-05  Gwang Yoon Hwang  <ryumiel@company100.net>

        [Coordinated Graphics] Unify messages related object's lifecycles into CoordinatedGraphicsState.
        https://bugs.webkit.org/show_bug.cgi?id=111919

        Reviewed by Noam Rosenthal.

        CoordinatedLayerTreeHostProxy has several methods, which simply passes
        these calls to CoordinatedGraphicsScene.

        This patch removes methods in CoordinatedLayerTreeHostProxy just for
        message chaining. Instead of that, messages for creation/deletion of objects
        (Layers, CustomFilters, UpdateAtlas, and ImageBacking) are unified into
        CommitCoordinatedGraphicsState.

        And this patch also removes codes for WebCoordinatedSurface in
        CoordinatedLayerTreeHost, except for a factory method.
        CoordinatedGraphicsArgumentCoders [en|de]codes CoordinatedSurface itself
        using WebCoordinatedSurface.

        No new tests, covered by existing tests.

        * Shared/CoordinatedGraphics/CoordinatedGraphicsArgumentCoders.cpp:
        (CoreIPC::encodeCoordinatedSurface):
        (CoreIPC::decodeCoordinatedSurface):
        (CoreIPC::::encode):
        (CoreIPC::::decode):
        * UIProcess/CoordinatedGraphics/CoordinatedLayerTreeHostProxy.cpp:
        * UIProcess/CoordinatedGraphics/CoordinatedLayerTreeHostProxy.h:
        * UIProcess/CoordinatedGraphics/CoordinatedLayerTreeHostProxy.messages.in:
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::flushPendingLayerChanges):
        (WebKit::CoordinatedLayerTreeHost::clearPendingStateChanges):
        (WebKit::CoordinatedLayerTreeHost::checkCustomFilterProgramProxies):
        (WebKit::CoordinatedLayerTreeHost::removeCustomFilterProgramProxy):
        (WebKit::CoordinatedLayerTreeHost::detachLayer):
        (WebKit::CoordinatedLayerTreeHost::createImageBacking):
        (WebKit::CoordinatedLayerTreeHost::updateImageBacking):
        (WebKit::CoordinatedLayerTreeHost::clearImageBackingContents):
        (WebKit::CoordinatedLayerTreeHost::removeImageBacking):
        (WebKit::CoordinatedLayerTreeHost::createGraphicsLayer):
        (WebKit::CoordinatedLayerTreeHost::createUpdateAtlas):
        (WebKit::CoordinatedLayerTreeHost::removeUpdateAtlas):
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.h:

2013-06-04  Simon Cooper  <scooper@apple.com>

        Tighten plugin sandbox profiles against symlink attacks
        https://bugs.webkit.org/show_bug.cgi?id=117219
        <rdar://problem/13044569>

        Reviewed by Sam Weinig.

        This inserts deny rules for creating symbolic links. The rules are
        inserted at the end of sandbox profile compilation by overriding the
        finalizer.  The initial value of %finalize must be the last function
        called.

        * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:

2013-06-04  Chris Fleizach  <cfleizach@apple.com>

        AX: WK2: accessibility position is calculated every time window frame is updated
        https://bugs.webkit.org/show_bug.cgi?id=117201

        Reviewed by Tim Horton.

        Only calculate the AX position if AX has already been enabled when updating the
        WKView's window and frame.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView _updateWindowAndViewFrames]):
        (-[WKView _accessibilityRegisterUIProcessTokens]):
            Don't call accessibilityAttributeValue: here because it could enable accessibility prematurely.
        (-[WKView enableAccessibilityIfNecessary]):
            After enabling AX for the first time, also update the frame so that the AX position is correct.
        (-[WKView accessibilityFocusedUIElement]):
        (-[WKView accessibilityHitTest:]):
        (-[WKView accessibilityAttributeValue:]):
            Tell the AXObjectCache that AX is now enabled.

2013-06-04  Mark Rowe  <mrowe@apple.com>

        REGRESSION (r151043): Frequent crashes inside WebPageProxy::getPlugInInformation
        <http://webkit.org/b/117180>

        Reviewed by Brady Eidson.

        * UIProcess/mac/WebPageProxyMac.mm:
        (WebKit::WebPageProxy::getPlugInInformation): Return early when plugInProcessProxy is null
        since there's nothing we can do.

2013-06-04  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [EFl][WK2] Sub menu items should be of EWK_SUBMENU_TYPE and not checkable
        https://bugs.webkit.org/show_bug.cgi?id=116959

        Reviewed by Gyuyoung Kim.

        Currently using ewk API it is possible to create a sub menu item which is not an EWK_SUBMENU_TYPE
        or set checkable flag for it, while it is not possible for items created by WebKit. 
        This patch changes ewk context menu API to match WebKit2 behaviour, by creating sub menus with
        proper type and checkable flags.

        * UIProcess/API/efl/ewk_context_menu_item.cpp:
        (ewk_context_menu_item_new_with_submenu):
        * UIProcess/API/efl/ewk_context_menu_item.h:
        * UIProcess/API/efl/tests/test_ewk2_context_menu.cpp:
        (showContextMenu):

2013-06-04  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [EFL][WK2] Custom context menu items cannot be selected
        https://bugs.webkit.org/show_bug.cgi?id=116830

        Reviewed by Gyuyoung Kim.

        Custom item added using ewk_context_menu_item_append had no
        pointer to parent menu, and custom submenu added using with the
        the same function had no pointer to EwkView. Both issues
        prevented items to be selected.

        * UIProcess/API/efl/ewk_context_menu.cpp:
        (EwkContextMenu::appendItem):
        (EwkContextMenu::contextMenuItemSelected):
        (ewk_context_menu_item_append):
        (ewk_context_menu_item_select):
        * UIProcess/API/efl/ewk_context_menu_private.h:
        (EwkContextMenu):
        (EwkContextMenu::setEwkView):

2013-06-03  Simon Cooper  <scooper@apple.com>

        Unable to play videos in Safari using QuickTime plug-in until I've played those videos in Chrome first
        https://bugs.webkit.org/show_bug.cgi?id=117174
        <rdar://problem/13711687>

        Reviewed by Alexey Proskuryakov.

        Pull in fixes that allow https connections within the plugin
        environment.

        * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:

2013-06-03  Marcelo Lira  <marcelo.lira@openbossa.org>

        [WK2] REGRESSION(r150798): scrolling coordinator is not being enabled when WebPage is set to use fixed layout
        https://bugs.webkit.org/show_bug.cgi?id=117163

        Reviewed by Darin Adler.

        Moved call to WebPage::settings()->setScrollingCoordinatorEnabled()
        from CoordinatedLayerTreeHost constructor to WebPage::setUseFixedLayout().
        The scrolling coordinator must be enabled or disabled following the
        WebPage's use of fixed layout.

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::CoordinatedLayerTreeHost):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::setUseFixedLayout):

2013-06-03  Anders Carlsson  <andersca@apple.com>

        Send mouse events to the banner for as long as the mouse button is down
        https://bugs.webkit.org/show_bug.cgi?id=117161
        <rdar://problem/13821220>

        Reviewed by Beth Dakin.

        Keep track of whether the mouse was pressed in a banner and keep sending mouse events to it,
        even if they are outside the banner's bounds for as long as the mouse is down.

        * WebProcess/WebPage/PageBanner.h:
        * WebProcess/WebPage/mac/PageBannerMac.mm:
        (WebKit::PageBanner::PageBanner):
        (WebKit::PageBanner::mouseEvent):

2013-06-03  Sergio Correia  <sergio.correia@openbossa.org>

        [EFL][WK2] Process launcher uses system() for wrapping the WebProcess when using WEB_PROCESS_CMD_PREFIX
        https://bugs.webkit.org/show_bug.cgi?id=105156

        Reviewed by Christophe Dumez.

        When using WEB_PROCESS_CMD_PREFIX - which allows us for instance to analyze
        WebProcess under tools like valgrind or gdb -, the ProcessLauncher would
        spawn the new process using system(), which would, among other things, keep
        an extra UIProcess waiting and executing the shell.

        This patch handles the normal case and the case where we have something to
        prefix WebProcess (i.e., by using WEB_PROCESS_CMD_PREFIX in a debug build)
        the same way, through a call to execvp().

        To achieve this a function was introduced to create an array with the given
        arguments to the full command to be executed, to be used by execvp(). We use
        a Vector<OwnArrayPtr<char>>, so that we can take advantage of the destructor
        of OwnArrayPtr to handle the memory deallocation when it goes out of scope.

        * UIProcess/Launcher/efl/ProcessLauncherEfl.cpp:
        (WebKit::createArgsArray):  This function creates the array to be used by
        execvp(), out of the Strings given as arguments.
        (WebKit::ProcessLauncher::launchProcess): Rework the logic to accomodate
        both the cases with and without WEB_PROCESS_CMD_PREFIX. The execl() call
        was replaced with an execvp() call, since now we should deal with having
        a variable number of arguments (WEB_PROCESS_CMD_PREFIX) as well.

2013-06-02  Arunprasad Rajkumar  <arurajku@cisco.com>

        [Qt] Move Qt port off legacy clipboard
        https://bugs.webkit.org/show_bug.cgi?id=116416

        Reviewed by Darin Adler.

        * WebProcess/WebCoreSupport/qt/WebDragClientQt.cpp:
        (WebKit::WebDragClient::startDrag):

2013-06-02  Sergio Correia  <sergio.correia@openbossa.org>

        [WK2][CoordinatedGraphics]: Use a properly initialized WebPage when creating a PageClient
        https://bugs.webkit.org/show_bug.cgi?id=117116

        Reviewed by Tim Horton.

        Valgrind reported a "conditional jump or move depends on uninitialised value"
        at WebPageProxy constructor, when checking the m_isVisible variable inside
        the ENABLE(PAGE_VISIBILITY_API) guard.

        The issue was tracked down to the WebView constructor, which was creating a
        WebKit::PageClient* making use of `this' before having initialized all of its
        attributes.

        The solution was to move the initialization of the `page' member to inside the
        constructor itself - out of the initialization list -, where we can guarantee
        all the relevant stuff has already been properly initialized.

        Here's the relevant valgrind trace for reference:

        Conditional jump or move depends on uninitialised value(s)
            at 0x65A35A4: WebKit::WebPageProxy::WebPageProxy(WebKit::PageClient*,
                          WTF::PassRefPtr<WebKit::WebProcessProxy>,
                          WebKit::WebPageGroup*, unsigned long) (WebPageProxy.cpp:322)
            by 0x65A2BA2: WebKit::WebPageProxy::create(WebKit::PageClient*,
                          WTF::PassRefPtr<WebKit::WebProcessProxy>,
                          WebKit::WebPageGroup*, unsigned long) (WebPageProxy.cpp:233)
            by 0x65E94BB: WebKit::WebProcessProxy::createWebPage(WebKit::PageClient*,
                          WebKit::WebContext*, WebKit::WebPageGroup*)
                          (WebProcessProxy.cpp:172)
            by 0x6570957: WebKit::WebContext::createWebPage(WebKit::PageClient*,
                          WebKit::WebPageGroup*, WebKit::WebPageProxy*)
                          (WebContext.cpp:735)
            by 0x67673E3: WebKit::WebView::WebView(WebKit::WebContext*,
                          WebKit::WebPageGroup*) (WebView.cpp:52)
            by 0x6775F18: WebKit::WebViewEfl::WebViewEfl(WebKit::WebContext*,
                          WebKit::WebPageGroup*) (WebViewEfl.cpp:54)
            by 0x6775EB4: WebKit::WebView::create(WebKit::WebContext*,
                          WebKit::WebPageGroup*) (WebViewEfl.cpp:49)
            by 0x673E13D: WKViewCreate (WKView.cpp:33)
            by 0x6763ECE: EWKViewCreate (ewk_view.cpp:92)

        * UIProcess/CoordinatedGraphics/WebView.cpp:
        (WebKit::WebView::WebView):

2013-05-31  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        [EFL][WK2] Add a null checking condition to in hide() of EwkContextMenu
        https://bugs.webkit.org/show_bug.cgi?id=117014

        Reviewed by Christophe Dumez.

        m_viewImpl is able to be null. So, we need to protect this function against such case.

        * UIProcess/API/efl/ewk_context_menu.cpp:
        (EwkContextMenu::hide):
        (ewk_context_menu_hide):
        * UIProcess/API/efl/ewk_context_menu_private.h:
        (EwkContextMenu):

2013-05-31  Oliver Hunt  <oliver@apple.com>

        Fix bug in active page tracking that lead to plugins hanging during destruction
        https://bugs.webkit.org/show_bug.cgi?id=117099

        Reviewed by Anders Carlsson.

        NPRuntimeObjectMap no longer keeps its own reference to the
        throttler, and no longer reports activity during destruction.

        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.cpp:
        (WebKit::NPRuntimeObjectMap::NPRuntimeObjectMap):
        (WebKit::NPRuntimeObjectMap::evaluate):
        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.h:
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::PluginView):

2013-05-31  Tim Horton  <timothy_horton@apple.com>

        [wk2] All intrinsic content size changes should go through the 0-delay timer
        https://bugs.webkit.org/show_bug.cgi?id=117058
        <rdar://problem/13935042>

        Reviewed by Anders Carlsson.

        In r146913, I added a 0-delay timer so that we'd coalesce intrinsic
        content size changes. However, didUpdateGeometry was still immediately
        invalidating the intrinsic content size without coalescing.

        Move that update to the WebProcess to share the timer.

        * UIProcess/DrawingAreaProxy.h:
        (WebKit::DrawingAreaProxy::didUpdateGeometry):
        * UIProcess/DrawingAreaProxy.messages.in:
        * UIProcess/mac/TiledCoreAnimationDrawingAreaProxy.h:
        * UIProcess/mac/TiledCoreAnimationDrawingAreaProxy.mm:
        (WebKit::TiledCoreAnimationDrawingAreaProxy::didUpdateGeometry):
        Remove the newIntrinsicContentSize argument, and don't invalidate intrinsic
        content size inside didUpdateGeometry.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::updateGeometry):
        Start the intrinsic content size update timer when we finish updateGeometry.

2013-05-31  Alexey Proskuryakov  <ap@apple.com>

        Sandbox violations when trying to access fonts in non-standard locations
        https://bugs.webkit.org/show_bug.cgi?id=117097
        <rdar://problem/9264746>

        Reviewed by Anders Carlsson.

        The issue was that lack of a main xib was resulting in font machinery being
        initialized too early, before we entered sandbox.

        * Resources/WebContentProcess.xib: Added.
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/EntryPoint/mac/LegacyProcess/Info.plist:
        * WebProcess/EntryPoint/mac/XPCService/WebContentService.Development/Info.plist:
        * WebProcess/EntryPoint/mac/XPCService/WebContentService/Info.plist:

2013-05-31  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/14036464> Sandbox violation when using Web SpeechSynthesis

        Reviewed by Anders Carlsson

        * WebProcess/com.apple.WebProcess.sb.in: Allow com.apple.speech.synthesis.console.

2013-05-31  Jessie Berlin  <jberlin@apple.com>

        Need the ability to get the information for a plug-in with a particular process id that may
        be running on a page
        https://bugs.webkit.org/show_bug.cgi?id=117090

        Rubber-stamped by Anders Carlsson.

        Follow-up to r151043 incorprating some feedback I got from Darin after I had already
        committed the patch.

        * UIProcess/API/C/mac/WKPagePrivateMac.cpp:
        (callGetPlugInInformationBlockAndDispose):
        Renamed to be less wordy.
        (WKPageGetPlugInInformation):
        Ditto.
        * UIProcess/API/C/mac/WKPagePrivateMac.h:
        Ditto.

        * UIProcess/Plugins/PluginProcessManager.h:
        * UIProcess/Plugins/mac/PluginProcessManagerMac.mm:
        (WebKit::PluginProcessManager::findPlugInProcessByID):
        Renamed to not use "Cocoa method style" in non-Cocoa functions.
        (WebKit::PluginProcessManager::findPlugInProcessByToken):
        Ditto.

        * UIProcess/WebPageProxy.h:
        * UIProcess/mac/WebPageProxyMac.mm:
        (WebKit::WebPageProxy::getPlugInInformation):
        Reduce ref count churn and fix a variable name.
        Updated for the change to findPlugInProcessByID.
        (WebKit::WebPageProxy::containsPlugInCallback):
        Updated for the change to findPlugInProcessByToken.

        * WebProcess/Plugins/PDF/SimplePDFPlugin.h:
        Move the override of a virtual function to the private section.

2013-05-31  Jessie Berlin  <jberlin@apple.com>

        Need the ability to get the information for a plug-in with a particular process id that may
        be running on a page
        https://bugs.webkit.org/show_bug.cgi?id=117090

        Reviewed by Anders Carlsson.

        * UIProcess/API/C/mac/WKPagePrivateMac.cpp:
        (callGetInformationForPlugInWithProcessIDBlockAndDispose):
        Get the block from the context, invoke it with the result, and dispose of it.
        (WKPageGetInformationForPlugInWithProcessID):
        Ask the WebPageProxy and provide it with a dictionary callback that uses the
        above function to invoke the passed in block.
        * UIProcess/API/C/mac/WKPagePrivateMac.h:
        Add WKPageGetInformationForPlugInWithProcessID and a typedef for the callback block.

        * UIProcess/Plugins/PluginProcessManager.h:
        Add ways to get the PluginProcessProxy associated with a process id or process token.
        * UIProcess/Plugins/mac/PluginProcessManagerMac.mm:
        (WebKit::PluginProcessManager::plugInProcessWithProcessID):
        Return the first PluginProcessProxy with the passed in process ID.
        (WebKit::PluginProcessManager::plugInProcessWithToken):
        Return the first PluginProcessProxy with the passed in process token.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::close):
        Invalidate any outstanding requests for plug-in information.
        * UIProcess/WebPageProxy.h:
        Keep track of the callbacks for the requests for plug-in information.
        * UIProcess/WebPageProxy.messages.in:
        * UIProcess/mac/WebPageProxyMac.mm:
        (WebKit::WebPageProxy::getInformationForPlugInWithProcessID):
        If there are no known plug-ins with the provided process ID, invoke the callback with a null
        dictionary of plug-in information.
        Otherwise, keep track of the callback and send a message to the web process asking for the
        information.
        (WebKit::WebPageProxy::containsPlugInCallback):
        If the page did not contain the plug-in, invoke the callback with a null dictionary of
        plug-in information.
        Invoke the callback with a dictionary containing the PlugInModuleInfo.

        * WebProcess/Plugins/Netscape/NetscapePlugin.h:
        Return 0 for the plugInProcessToken.
        * WebProcess/Plugins/PDF/SimplePDFPlugin.h:
        Ditto.
        * WebProcess/Plugins/Plugin.h:
        Add a pure virtual method for plugInProcessToken so it can be accessed from from the Plugin
        on the PluginView.
        * WebProcess/Plugins/PluginProxy.h:
        Return the actual plug-in process token.

        * WebProcess/Plugins/PluginView.h:
        (WebKit::PluginView::plugIn):
        Make it possible to get at the plug-in process token through the Plugin.

        * WebProcess/WebPage/WebPageMac.mm:
        (WebKit::WebPage::containsPluginViewsWithPluginProcessToken):
        If there is an instance of the plug-in with that token, send a confirmation to the ui
        process.
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/WebPage.messages.in:

2013-05-31  Alexey Proskuryakov  <ap@apple.com>

        REGRESSION (r141445): MPEG-4 videos do not play on certain hardware configurations
        https://bugs.webkit.org/show_bug.cgi?id=117089
        <rdar://problem/13839717>

        Reviewed by Mark Rowe.

        * Configurations/WebContentProcess.xcconfig: Statically link to a framework that
        uses an XPC service to work around a libxpc limitation on Lion.

2013-05-31  Dean Jackson  <dino@apple.com>

        Don't create an accelerated compositing layer unless we have to for snapshotting plug-ins
        https://bugs.webkit.org/show_bug.cgi?id=117076
        <rdar://problem/14030364>

        Reviewed by Beth Dakin and Anders Carlsson.

        If a plug-in can support software snapshotting, then don't create an
        accelerated compositing layer for it while in snapshot mode. This is a
        better user experience -- otherwise the page/plug-in looks like it broke.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::isAcceleratedCompositingEnabled): If we are in snapshotting mode
        and we are a Flash plugin (the only one that supports software snapshots at the moment)
        then do not create an accelerated compositing layer.

2013-05-30  Tim Horton  <timothy_horton@apple.com>

        It's easy to hit ASSERT_NOT_REACHED in WKDOMNodeClass
        https://bugs.webkit.org/show_bug.cgi?id=117051

        Reviewed by Anders Carlsson.

        Re-add the ASSERT_NOT_REACHED, and return [WKDOMNode class] in the case
        where we don't have a specific subclass.

        * WebProcess/InjectedBundle/API/mac/WKDOMInternals.mm:
        (WebKit::WKDOMNodeClass):

2013-05-31  Stephanie Lewis  <slewis@apple.com>

        Update low memory handler to use new memory pressure notifications on new OS versions.
        <rdar://problem/14027095>

        Reviewed by Mark Rowe.

        * WebProcess/WebCoreSupport/mac/WebSystemInterface.mm:
        (InitWebCoreSystemInterface):

2013-05-30  Tim Horton  <timothy_horton@apple.com>

        Remove ASSERT_NOT_REACHED from WKDOMNodeClass
        https://bugs.webkit.org/show_bug.cgi?id=117051

        Reviewed by Anders Carlsson.

        It's easy to fail this assertion in seemingly-legitimate cases.

        * WebProcess/InjectedBundle/API/mac/WKDOMInternals.mm:
        (WebKit::WKDOMNodeClass):

2013-05-29  Jeffrey Pfau  <jpfau@apple.com>

        [Mac] Enable cache partitioning and the public suffix list on 10.8
        <rdar://problem/13679019>

        Rubber-stamped by David Kilzer.

        * Configurations/FeatureDefines.xcconfig:

2013-05-30  Andreas Kling  <akling@apple.com>

        Fix double hash lookup in WebPage::determinePrimarySnapshottedPlugIn() loop.
        <http://webkit.org/b/117032>

        Reviewed by Anders Carlsson.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::determinePrimarySnapshottedPlugIn):

2013-05-29  Tim Horton  <timothy_horton@apple.com>

        Expose incrementalRenderingSuppressionTimeout via WK2
        https://bugs.webkit.org/show_bug.cgi?id=117015
        <rdar://problem/13992853>

        Reviewed by Darin Adler.

        * Shared/WebPreferencesStore.h:
        * UIProcess/API/C/WKPreferencesPrivate.h:
        Add IncrementalRenderingSuppressionTimeout preference.

        * UIProcess/API/C/WKPreferences.cpp:
        (WKPreferencesSetIncrementalRenderingSuppressionTimeout): Added.
        (WKPreferencesGetIncrementalRenderingSuppressionTimeout): Added.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.h:
        (WebKit::WebFrameLoaderClient::forcePageTransitionIfNeeded): Added.
        Call didCompletePageTransition, which un-freezes the layer tree.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::didCompletePageTransition):
        Fix some indentation.

        (WebKit::WebPage::updatePreferences):
        Forward the timeout value through to WebCore.

2013-05-29  Simon Fraser  <simon.fraser@apple.com>

        Fix paint-related milestones to not fire when the layer tree is frozen
        https://bugs.webkit.org/show_bug.cgi?id=117012

        Reviewed by Tim Horton.
        
        Implement ChromeClient::layerTreeStateIsFrozen() to return
        the frozen state of the drawing area.

        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::layerTreeStateIsFrozen):
        * WebProcess/WebCoreSupport/WebChromeClient.h:
        (WebChromeClient):

2013-05-29  Anders Carlsson  <andersca@apple.com>

        WebKit should expose HSTS APIs to determine whether a host is in the HSTS cache and to reset HSTS policies
        https://bugs.webkit.org/show_bug.cgi?id=117010
        <rdar://problem/13689666>

        Reviewed by Tim Horton.

        * UIProcess/API/C/mac/WKContextPrivateMac.h:
        * UIProcess/API/C/mac/WKContextPrivateMac.mm:
        * UIProcess/API/C/mac/WKPagePrivateMac.cpp:
        * UIProcess/API/C/mac/WKPagePrivateMac.h:
        * UIProcess/WebContext.h:
        (WebContext):
        * UIProcess/mac/WebContextMac.mm:
        (WebKit):
        (WebKit::privateBrowsingSession):
        (WebKit::WebContext::isURLKnownHSTSHost):
        (WebKit::WebContext::resetHSTSHosts):

2013-05-29  Tim Horton  <timothy_horton@apple.com>

        WKViews using shouldClipToVisibleRect=YES should respect prepareContentInRect: if called
        https://bugs.webkit.org/show_bug.cgi?id=116989
        <rdar://problem/14007440>

        Reviewed by Anders Carlsson.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView prepareContentInRect:]):
        If prepareContentInRect: is called, save the rect and set a flag so we know we should use it.

        (-[WKView _updateViewExposedRect]):
        Give the WebPage (and later the DrawingArea) the union of the rect handed to prepareContentInRect:
        and the WKView's visibleRect, if we're in that mode, so that applications that do their own scrolling
        can cause tiles to be created in currently offscreen views (for overdraw).

        (-[WKView setFrameSize:]):
        (-[WKView _updateWindowAndViewFrames]):
        (-[WKView initWithFrame:contextRef:pageGroupRef:relatedToPage:]):
        (-[WKView enableFrameSizeUpdates]):
        (-[WKView setShouldClipToVisibleRect:]):
        (-[WKView forceAsyncDrawingAreaSizeUpdate:]):
        Use [_updateViewExposedRect].

2013-05-28  Oliver Hunt  <oliver@apple.com>

        Add more accurate activity state tracking
        https://bugs.webkit.org/show_bug.cgi?id=116893

        Reviewed by Gavin Barraclough.

        This extends the logic in WebCore from a Page to Process
        granularity, so we will avoid lowering the child process
        priority if there is active content.  This also plumbs in
        the logic to allow plugins to report that they have done
        something "interesting".  Currently this is somewhat conservative
        but even this is sufficient to fix some stuttering issues
        that we've seen.

        * Shared/ChildProcess.cpp:
        (WebKit::ChildProcess::ChildProcess):
        * Shared/ChildProcess.h:
        (ChildProcess):
        (WebKit::ChildProcess::processSuppressionEnabled):
        (WebKit::ChildProcess::incrementActiveTaskCount):
        (WebKit::ChildProcess::decrementActiveTaskCount):
        * Shared/mac/ChildProcessMac.mm:
        (WebKit):
        (WebKit::ChildProcess::setProcessSuppressionEnabledInternal):
        (WebKit::ChildProcess::setProcessSuppressionEnabled):
        (WebKit::ChildProcess::incrementActiveTaskCount):
        (WebKit::ChildProcess::decrementActiveTaskCount):
        (WebKit::ChildProcess::suspensionHysteresisTimerFired):
        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.cpp:
        (WebKit::NPRuntimeObjectMap::NPRuntimeObjectMap):
        (WebKit::NPRuntimeObjectMap::evaluate):
        * WebProcess/Plugins/Netscape/NPRuntimeObjectMap.h:
        (WebCore):
        (NPRuntimeObjectMap):
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::PluginView):
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::incrementActivePageCount):
        (WebKit):
        (WebKit::WebChromeClient::decrementActivePageCount):
        * WebProcess/WebCoreSupport/WebChromeClient.h:
        (WebChromeClient):

2013-05-29  Anders Carlsson  <andersca@apple.com>

        Return earlier if there's no session storage namespace
        https://bugs.webkit.org/show_bug.cgi?id=116984
        <rdar://problem/13976781>

        Reviewed by Tim Horton.

        If we can't find a session storage namespace, return before creating an entry in the m_storageAreasByConnection
        hash map since then we'll crash trying to remove it later.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::createSessionStorageMap):

2013-05-29  Martin Robinson  <mrobinson@igalia.com>

        Fix more CMake GTK+ build issues after r150336

        * CMakeLists.txt: We need to allow for setting the WebProcess output name, since
        WebKitGTK+ expects it to be called WebKitWebProcess.
        * PlatformGTK.cmake: No longer set WebProcess_EXECUTABLE_NAME as it's been replaced
        by WebKit2_WebProcess_OUTPUT_NAME.

2013-05-29  Marcelo Lira  <marcelo.lira@openbossa.org>

        [WK2][CoordinatedGraphics][EFL] WKViewUserViewportToContents() function doesn't do what it says
        https://bugs.webkit.org/show_bug.cgi?id=116683

        Reviewed by Noam Rosenthal.

        WKViewUserViewportToContents now converts WebView coordinates to
        page contents coordinates, taking into account factors as content
        scale and scroll, and also device scale.

        The function WKViewUserViewportToScene was added to convert WebView
        coordinates to the coordinates of the canvas/scene where the view
        is drawn, and EwkView was fixed to use it, instead of
        WKViewUserViewportToContents.

        * UIProcess/API/C/CoordinatedGraphics/WKView.cpp:
        (WKViewUserViewportToScene):
        * UIProcess/API/C/CoordinatedGraphics/WKView.h:
        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::createGLSurface):
        * UIProcess/CoordinatedGraphics/WebView.cpp:
        (WebKit::WebView::userViewportToContents):
        (WebKit):
        (WebKit::WebView::userViewportToScene):
        (WebKit::WebView::transformToScene):
        * UIProcess/CoordinatedGraphics/WebView.h:
        (WebView):

2013-05-29  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix make distcheck.

        * GNUmakefile.am: Add WebCoreLayerGtk2.a to DISTCLEANFILES.

2013-05-29  Seokju Kwon  <seokju.kwon@gmail.com>

        [GTK] Clean up WebKit2 GNUmakefile.am
        https://bugs.webkit.org/show_bug.cgi?id=116907

        Reviewed by Martin Robinson.

        Removed WebNotificationManagerProxy.messages.in after r150785.

        * GNUmakefile.am:

2013-05-28  Alexey Proskuryakov  <ap@apple.com>

        Freeze when loading a particular page on washingtonpost.com with NetworkProcess enabled
        https://bugs.webkit.org/show_bug.cgi?id=116887
        <rdar://problem/12965959>

        Reviewed by Darin Adler.

        * Shared/cf/ArgumentCodersCF.cpp:
        (CoreIPC::encode):
        (CoreIPC::decode):
        Fix for the bug: use good shared WebCore code to manipulate CFURLs. Also, added
        a FIXME about empty URLs.

        * Shared/API/c/cf/WKURLCF.cpp: (WKURLCreateWithCFURL): Fixed to not use
        CFURLGetString, as that could prevent loading certain resources, like ones with
        curly braces in resource specifiers. We want KURL normalization, not CFURL one.

2013-05-28  Tim Horton  <timothy_horton@apple.com>

        Rendering suppression extension tokens shouldn't be 0, should handle overflow
        https://bugs.webkit.org/show_bug.cgi?id=116886
        <rdar://problem/14004474>

        Reviewed by Darin Adler.

        Don't use invalid HashSet values as tokens, and ensure that
        we're not already using a token before returning it.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::extendIncrementalRenderingSuppression):

2013-05-28  Lauro Neto <lauro.neto@openbossa.org>

        [GTK] Connection issues in repeated WebProcess crash/reloads.
        https://bugs.webkit.org/show_bug.cgi?id=115880

        Reviewed by Anders Carlsson.

        When stressing the WebProcess creation/destruction, WebKitGTK can
        often run into socket issues like bad file descriptor errors or
        polling a socket indefinitely.

        Currently WebKitGTK has three places where a socket can be
        closed.

        - childFinishedFunction (in ProcessLauncherGtk.cpp)
        - Connection::platformInvalidate (in ConnectionUnix.cpp)
        - WorkQueue EventSource destruction (in WorkQueueGtk.cpp)

        To avoid these race conditions, socket closing will be handled
        by the event source callback in WorkQueueGtk.cpp.

        * Platform/CoreIPC/unix/ConnectionUnix.cpp:
        (CoreIPC::Connection::platformInvalidate): Do not close the socket
        when the connection is invalidated, the socket event source is
        unregistered in this method and the socket is closed when the
        GSocket associated to the event source is destroyed.
        * UIProcess/Launcher/gtk/ProcessLauncherGtk.cpp:
        (WebKit::ProcessLauncher::launchProcess): Do not monitor child
        process to close the connection on termination. This was needed in
        the past when we used DGRAM sockets, we currently use always
        connection oriented sockets, so that when the other end closes
        the connection we are notified and the connection is invalidated.

2013-05-28  Martin Robinson  <mrobinson@igalia.com>

        Fix GTK+ CMake build

        * PlatformGTK.cmake: After r150336, the name of the WebKit2
        library target is simply "WebKit2."

2013-05-28  Marcelo Lira  <marcelo.lira@openbossa.org>

        [WK2][CoordinatedGraphics] DrawingArea's visible content area must be updated when contents size changes
        https://bugs.webkit.org/show_bug.cgi?id=116845

        Reviewed by Noam Rosenthal.

        * UIProcess/CoordinatedGraphics/WebView.cpp:
        (WebKit::WebView::didChangeContentsSize):

2013-05-28  Noam Rosenthal  <noam@webkit.org>

        [Qt] REGRESSION(r149292): broke scrolling in Qt WK2 desktop mode
        https://bugs.webkit.org/show_bug.cgi?id=116597

        ScrollingCoordinatorCoordinatedGraphics is tailored specifically for
        fixedLayout mode. When fixedLayout is not set, it should be turned off.

        Reviewed by Allan Sandfeld Jensen.

        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::CoordinatedLayerTreeHost):

2013-05-28  Andreas Kling  <akling@apple.com>

        Document::setFocusedNode() should be setFocusedElement().
        <http://webkit.org/b/116857>

        Reviewed by Antti Koivisto.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::focusPluginElement):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::focusedPluginViewForFrame):
        (WebKit::WebPage::setInitialFocus):

2013-05-28  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        [EFL][WK2] Clean up duplicated include files.
        https://bugs.webkit.org/show_bug.cgi?id=116851

        Reviewed by Christophe Dumez.

        Remove some of duplicated include file in ewk files.

        * UIProcess/API/efl/EwkView.h:
        * UIProcess/API/efl/ewk_color_picker.cpp:
        * UIProcess/API/efl/ewk_context_menu.cpp:
        * UIProcess/API/efl/ewk_security_origin_private.h:

2013-05-28  Ryuan Choi  <ryuan.choi@samsung.com>

        [EFL] pc files should have harfbuzz dependency.
        https://bugs.webkit.org/show_bug.cgi?id=116852

        Reviewed by Gyuyoung Kim.

        * efl/ewebkit2.pc.in: Added harfbuzz as Required package.

2013-05-27  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        [EFL][WK2] Remove unneeded WebCore namespace use in ewk
        https://bugs.webkit.org/show_bug.cgi?id=116707

        Reviewed by Christophe Dumez.

        * UIProcess/API/efl/ewk_security_origin.cpp: Remove "using namespace WebCore".
        * UIProcess/API/efl/ewk_text_checker.cpp: ditto.

2013-05-26  Jon Lee  <jonlee@apple.com>

        [WK2] Notifications clobber each other with multiple processes
        https://bugs.webkit.org/show_bug.cgi?id=116428
        <rdar://problem/13935191>

        Reviewed by Darin Adler.

        With multiple processes, the notification IDs, when passed up to the UI process, can clobber
        each other. To fix this, we need to maintain a global map of notification IDs. This map is
        keyed by its own unique notification ID, and maps to a pair containing the web page ID and that
        web page's ID for the notification.

        Now that we maintain groups of notifications based on the web page, we no longer send IPC messages
        from WebNotificationManager to WebNotificationManagerProxy; instead we send messages to the
        WebPageProxy. This removes the need for WebNotificationManagerProxy to be a message receiver.

        When a page closes, all of the web notifications are cleared out. However, by the time the
        WebPage::close() is called, the connection between WebPage and WebPageProxy is destroyed. Since
        the WebPage is told to close from the UI process anyway, we clear out the notifications separately,
        instead of waiting for a message from the WebPage.

        * UIProcess/Notifications/WebNotificationManagerProxy.h: Update to take into account the
        notification's web page. Remove inheritance of CoreIPC::MessageReceiver. Expose the original message
        handlers as public functions, since they will be called from WebPageProxy. Add a new map that
        associates a global ID with a notification ID that came from a web page.
            There are now two flavors of clearNotifications(). One clears out all notifications associated
        with a web page. This is called when the page is closed. The other clears out a subset of
        notifications associated with a web page. This is called when notifications associated with a sub-frame
        is closed.
        * UIProcess/Notifications/WebNotificationManagerProxy.messages.in: Removed. All messages from
        the web process go to WebPageProxy now.

        * UIProcess/Notifications/WebNotificationManagerProxy.cpp: Update to take into account the
        notification's web page.

        (WebKit::generateGlobalNotificationID): The manager proxy now maintains its own global notification
        ID generator.
        (WebKit::WebNotificationManagerProxy::WebNotificationManagerProxy): The proxy is no longer a
        message receiver. Remove code that registers it as such.

        (WebKit::WebNotificationManagerProxy::show): Refactor to differentiate between the notification ID
        that came from the web process, and the global notification ID the proxy maintains. Add the mapping
        from the global ID to the (web page ID, notification ID) pair.
        (WebKit::WebNotificationManagerProxy::cancel): Refactor to take into consideration the web page.
        (WebKit::WebNotificationManagerProxy::didDestroyNotification): Refactor to take into consideration
        the web page. Fixes a leak where we did not remove the item from the maps. This function is called
        from the web process, when the ScriptExecutionContext is destroyed, so we remove it from our maps
        before we pass the message along to the provider.

        Helper functions that evaluate when a given notification in the map matches the desired parameters.
        (WebKit::pageIDsMatch): The notification is associated with the provided page.
        (WebKit::pageAndNotificationIDsMatch): The notification is associated with the provided page and is
        contained within the list of provided notifications.

        (WebKit::WebNotificationManagerProxy::clearNotifications): Changed to only remove notifications
        associated with the provided web page, and could include a specific list of notifications. This latter
        situation occurs if notifications were associated with an iframe, and that iframe was removed.
        There is an O(n) walk that could be make more efficient using another hash map, but that's overhead
        for a map that should be small in size anyway.

        (WebKit::WebNotificationManagerProxy::providerDidShowNotification): Refactor to take into
        consideration the web page.
        (WebKit::WebNotificationManagerProxy::providerDidClickNotification): Refactor to take into
        consideration the web page.
        (WebKit::WebNotificationManagerProxy::providerDidCloseNotifications): Now we need to comb through
        the list of global IDs and put them in buckets based on the notification's web pages. After that
        is done we can send the DidCloseNotifications() to those pages' processes. There is a possible
        extra optimization here where we group based on the page's process instead, to reduce the number
        of messages sent to processes.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::close): When a web page is closed, we clear the notifications associated
        with the page.
        (WebKit::WebPageProxy::cancelNotification): Forward call to WebNotificationManagerProxy.
        (WebKit::WebPageProxy::clearNotifications): Ditto.
        (WebKit::WebPageProxy::didDestroyNotification): Ditto.
        * UIProcess/WebPageProxy.h:
        * UIProcess/WebPageProxy.messages.in:

        * WebProcess/Notifications/NotificationPermissionRequestManager.cpp:
        * WebProcess/Notifications/WebNotificationManager.cpp:
        (WebKit::WebNotificationManager::cancel):
        (WebKit::WebNotificationManager::clearNotifications):
        (WebKit::WebNotificationManager::didDestroyNotification):
        * WebProcess/Notifications/NotificationPermissionRequestManager.cpp: Remove extraneous include.

        * CMakeLists.txt: Remove WebNotificationManagerProxy.messages.in and related files.
        * DerivedSources.pri: Ditto.
        * DerivedSources.make: Ditto.
        * GNUmakefile.list.am: Ditto.
        * WebKit2.xcodeproj/project.pbxproj: Ditto.

2013-05-27  Tim Horton  <timothy_horton@apple.com>

        Unreviewed build fix take 2.

        * WebProcess/Plugins/PDF/PDFPlugin.mm:

2013-05-27  Tim Horton  <timothy_horton@apple.com>

        Unreviewed build fix.

        * WebProcess/Plugins/PDF/PDFPlugin.mm:

2013-05-27  Tim Horton  <timothy_horton@apple.com>

        PDFPlugin: Main-frame PDFPlugin Accessibility
        https://bugs.webkit.org/show_bug.cgi?id=116563
        <rdar://problem/13458534>

        Reviewed by Sam Weinig.

        * WebProcess/Plugins/PDF/PDFLayerControllerDetails.h:
        Forward-declare a variety of accessibility methods.

        * WebProcess/Plugins/PDF/PDFPlugin.h:
        Add convertFromPDFViewToScreen, boundsOnScreen, accessibilityObject, and
        storage for our accessibility wrapper.
        * WebProcess/Plugins/PDF/PDFPlugin.mm:
        Add WKPDFPluginAccessibilityObject.

        (-[WKPDFPluginAccessibilityObject accessibilityIsIgnored]):
        We want to be included in the accessibility tree.

        (-[WKPDFPluginAccessibilityObject accessibilityAttributeValue:]):
        (-[WKPDFPluginAccessibilityObject accessibilityAttributeValue:forParameter:]):
        Grab values for accessibility attributes from the relevant sources
        (mostly from PDFLayerController).

        (-[WKPDFPluginAccessibilityObject readingModel]): Ditto.
        (-[WKPDFPluginAccessibilityObject accessibilityAttributeNames]):
        (-[WKPDFPluginAccessibilityObject accessibilityParameterizedAttributeNames]):
        (-[WKPDFPluginAccessibilityObject accessibilityActionNames]):
        Return the set of accessibility attributes, actions, and parameterized
        attributes that we support.

        (-[WKPDFPluginAccessibilityObject accessibilityIsAttributeSettable:]):
        (-[WKPDFPluginAccessibilityObject accessibilitySetValue:forAttribute:]):
        Forward some other accessibility methods to PDFLayerController.

        (-[WKPDFPluginAccessibilityObject accessibilityFocusedUIElement]):
        (-[WKPDFPluginAccessibilityObject accessibilityHitTest:]):
        We have no children, so if a hit test makes it to us, it's ours.

        (WebKit::PDFPlugin::PDFPlugin):
        Make a WKPDFPluginAccessibilityObject and hook it up.
        [FIXME: this could use some de-crapifying]

        (WebKit::PDFPlugin::convertFromPluginToPDFView):
        Transform a point from plugin space to PDFLayerController space.

        (WebKit::PDFPlugin::convertFromPDFViewToRootView):
        (WebKit::PDFPlugin::convertFromPDFViewToScreen): Added.
        (WebKit::PDFPlugin::boundsOnScreen):
        Return the PDFPlugin's frame in screen coordinates.

        (WebKit::PDFPlugin::accessibilityObject):
        Return our accessibility wrapper.

        * WebProcess/Plugins/PDF/SimplePDFPlugin.h:
        * WebProcess/Plugins/Plugin.h:
        (WebKit::Plugin::accessibilityObject):
        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::accessibilityObject):
        * WebProcess/Plugins/PluginView.h:
        Add accessibilityObject(), to acquire accessibility wrappers from plugins.

        * WebProcess/WebPage/WebPage.h:
        (WebPage): Add accessibilityObjectForMainFramePlugin();
        * WebProcess/WebPage/mac/WKAccessibilityWebPageObject.mm:
        (-[WKAccessibilityWebPageObject accessibilityRootObjectWrapper]):
        If the main frame has a PluginDocument that has an accessibilityObject,
        use that one instead of the WebPage's.

        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::accessibilityObjectForMainFramePlugin):
        Return the accessibilityObject from the main-frame PluginDocument, if
        there is one.

2013-05-27  Marcelo Lira  <marcelo.lira@openbossa.org>

        [WK2][CoordinatedGraphics] Misuse of DrawingAreaProxy::setVisibleContentsRect() in WebView::updateViewportSize()
        https://bugs.webkit.org/show_bug.cgi?id=116688

        Reviewed by Noam Rosenthal.

        Visible contents area passed to DrawingAreaProxy::setVisibleContentsRect()
        must be calculated including the page scale factor and avoid crossing the
        boundaries of the page contents size. In other words the DrawingArea
        must know the actual dimensions of what it being drawn. If the
        DrawingArea thinks the visible rectangle is bigger than it is, the
        contents will be drawn pixelated and blurry.

        * UIProcess/CoordinatedGraphics/WebView.cpp:
        (WebKit::WebView::didChangeContentsSize):
        (WebKit::WebView::updateViewportSize):
        (WebKit::WebView::visibleContentsSize):
        (WebKit):
        * UIProcess/CoordinatedGraphics/WebView.h:
        (WebKit::WebView::contentsSize):
        (WebView):

2013-05-27  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] WebKitWebView child widgets are not rendered with recent GTK+
        https://bugs.webkit.org/show_bug.cgi?id=116794

        Reviewed by Xan Lopez.

        Since rev d22fd7223c75f4720ddb982c659efb0d8d7543c4 of GTK+ expose
        events are not propagated to child GdkWindows anymore, and child
        widgets are rendered via gtk_container_propagate_draw(). Since all
        our children have its own GdkWindow (auth widget, inspector view
        and windowed plugins) we don't propagate the draw signal making
        them invisible with current GTK+.

        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkitWebViewBaseDraw): Chain up to the parent draw(), so it's
        propagated to the children. This shouldn't have any effect in
        previous versions of GTK+ because gtk_container_propagate_draw()
        returned early when the child widget had its own GdkWindow.

2013-05-27  Xan Lopez  <xlopez@igalia.com>

        Reset all clients on WebPage close
        https://bugs.webkit.org/show_bug.cgi?id=112334

        Reviewed by Anders Carlsson.

        We do not reset the clients on WebPage::close(), so there's a
        small chance that someone will try to access them after that. This
        won't work and will generally cause runtime warnings, crashes or
        other issues. Reset them all to null to prevent this situation.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::close):

2013-05-27  Manuel Rego Casasnovas  <rego@igalia.com>

        [GTK] Notify WebProcess in WebKitURISchemeRequest when we fail to read the user InputStream
        https://bugs.webkit.org/show_bug.cgi?id=114347

        Reviewed by Carlos Garcia Campos.

        While processing a WebKitURISchemeRequest if there is any error reading
        the InputStream provided by the user (for example the stream is already
        closed) we have to notify the WebProcess that the request has failed.

        * UIProcess/API/gtk/WebKitURISchemeRequest.cpp:
        (webkitURISchemeRequestReadCallback): Get the error from
        g_input_stream_read_finish() and use it to call
        webkit_uri_scheme_request_finish_error() in order to finish the failing
        WebKitURISchemeRequest properly.
        * UIProcess/API/gtk/tests/TestWebKitWebContext.cpp:
        (testWebContextURIScheme): Modify test to check the new situation using
        an already closed InputStream.

2013-05-27  Carlos Garcia Campos  <cgarcia@igalia.com>

        Unreviewed. Fix make distcheck.

        * GNUmakefile.list.am: Add missing header file.

2013-05-26  Changhun Kang  <temoochin@company100.net>

        The public WK header file should not include WKAPICast.h
        https://bugs.webkit.org/show_bug.cgi?id=115230

        Reviewed by Darin Adler.

        Otherwise, WebKit internal headers are exposed.
        No new tests. No change in behavior.
        * UIProcess/API/C/soup/WKSoupRequestManager.h:
        * UIProcess/soup/WebSoupRequestManagerClient.h:

2013-05-26  Andreas Kling  <akling@apple.com>

        FocusController::setFocusedNode() should be setFocusedElement().
        <http://webkit.org/b/116780>

        Reviewed by Antti Koivisto.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::focusPluginElement):

2013-05-25  Andreas Kling  <akling@apple.com>

        PluginDocument::pluginNode() should be pluginElement() instead.
        <http://webkit.org/b/116774>

        Reviewed by Anders Carlsson.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::focusedPluginViewForFrame):

2013-05-25  Simon Fraser  <simon.fraser@apple.com>

        Unprefix Page Visibility API
        https://bugs.webkit.org/show_bug.cgi?id=102340

        Reviewed by Tim Horton.
        
        Renaming of the "preview" state to "unloaded".

        * Shared/API/c/WKPageVisibilityTypes.h:
        * Shared/API/c/WKSharedAPICast.h:
        (WebKit::toPageVisibilityState):

2013-05-25  Andreas Kling  <akling@apple.com>

        Move Node::isMouseFocusable() to Element.
        <http://webkit.org/b/116762>

        Reviewed by Anders Carlsson.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::highlightPotentialActivation):

            Check that the potentially activated Node is an Element before asking if it's mouse-focusable.

2013-05-25  Andreas Kling  <akling@apple.com>

        REGRESSION: WebProcess is terminated when all Safari windows are closed.
        <rdar://problem/13990901>
        <http://webkit.org/b/116766>

        Reviewed by Alexey Proskuryakov.

        When closing the last page, only disconnect the web process if we're using a network process.
        Otherwise there might be session state in the web process getting lost.

        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::removeWebPage):

2013-05-25  Santosh Mahto  <santosh.ma@samsung.com>

        WebFrameProxy::didFailLoad clears frame title for no apparent reason
        https://bugs.webkit.org/show_bug.cgi?id=116655

        Reviewed by Alexey Proskuryakov.

        * UIProcess/WebFrameProxy.cpp:
        (WebKit::WebFrameProxy::didFailLoad):

2013-05-24  Seokju Kwon  <seokju.kwon@gmail.com>

        [Qt][GTK] Build fix after r150669
        https://bugs.webkit.org/show_bug.cgi?id=116751

        Reviewed by Christophe Dumez.

        * GNUmakefile.list.am:
        * Target.pri:
        * WebProcess/WebCoreSupport/gtk/WebEditorClientGtk.cpp:
        (WebKit::WebEditorClient::getEditorCommandsForKeyEvent):

2013-05-24  Seokju Kwon  <seokju.kwon@gmail.com>

        [EFL] Build fix after r150669
        https://bugs.webkit.org/show_bug.cgi?id=116750

        Reviewed by Anders Carlsson.

        * CMakeLists.txt:
        * WebProcess/Battery/WebBatteryManager.cpp:
        (WebKit::WebBatteryManager::registerWebPage):
        (WebKit::WebBatteryManager::unregisterWebPage):
        * WebProcess/NetworkInfo/WebNetworkInfoManager.cpp:
        (WebKit::WebNetworkInfoManager::registerWebPage):
        (WebKit::WebNetworkInfoManager::unregisterWebPage):
        (WebKit::WebNetworkInfoManager::bandwidth):
        (WebKit::WebNetworkInfoManager::metered):
        * WebProcess/WebCoreSupport/WebVibrationClient.cpp:
        (WebKit::WebVibrationClient::vibrate):
        (WebKit::WebVibrationClient::cancelVibration):
        * WebProcess/soup/WebSoupRequestManager.cpp:
        (WebKit::WebSoupRequestManager::didReceiveURIRequestData):
        (WebKit::WebSoupRequestManager::send):

2013-05-24  Anders Carlsson  <andersca@apple.com>

        MessageSender shouldn't be a class template
        https://bugs.webkit.org/show_bug.cgi?id=116743

        Reviewed by Andreas Kling.

        Change MessageSender to be a proper abstract base class. Subclasses of MessageSender must
        implement messageSenderConnection() as well as messageSenderDestinationID().

        This reduces code size and will allow us to be more flexible with MessageSender in the future.

        * NetworkProcess/NetworkResourceLoader.cpp:
        (WebKit::NetworkResourceLoader::sendAbortingOnFailure):
        (WebKit::NetworkResourceLoader::messageSenderConnection):
        (WebKit):
        (WebKit::NetworkResourceLoader::messageSenderDestinationID):
        * NetworkProcess/NetworkResourceLoader.h:
        (NetworkResourceLoader):
        * NetworkProcess/mac/DiskCacheMonitor.h:
        (DiskCacheMonitor):
        * NetworkProcess/mac/DiskCacheMonitor.mm:
        (WebKit::DiskCacheMonitor::messageSenderConnection):
        (WebKit::DiskCacheMonitor::messageSenderDestinationID):
        (WebKit):
        * Platform/CoreIPC/MessageSender.h:
        (CoreIPC):
        (MessageSender):
        (CoreIPC::MessageSender::send):
        (CoreIPC::MessageSender::sendSync):
        * Shared/ChildProcess.cpp:
        (WebKit::ChildProcess::messageSenderConnection):
        (WebKit):
        (WebKit::ChildProcess::messageSenderDestinationID):
        * Shared/ChildProcess.h:
        (ChildProcess):
        * Shared/Downloads/Download.cpp:
        (WebKit::Download::messageSenderConnection):
        (WebKit):
        (WebKit::Download::messageSenderDestinationID):
        * Shared/Downloads/Download.h:
        (Download):
        * Shared/Network/CustomProtocols/mac/CustomProtocolManagerMac.mm:
        (WebKit::CustomProtocolManager::initialize):
        * Shared/WebConnection.h:
        (WebConnection):
        * Shared/mac/SecItemShim.cpp:
        (WebKit::sendSecItemRequest):
        * UIProcess/WebConnectionToWebProcess.cpp:
        (WebKit::WebConnectionToWebProcess::hasValidConnection):
        (WebKit::WebConnectionToWebProcess::messageSenderConnection):
        (WebKit::WebConnectionToWebProcess::messageSenderDestinationID):
        * UIProcess/WebConnectionToWebProcess.h:
        (WebConnectionToWebProcess):
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/Geolocation/WebGeolocationManager.cpp:
        (WebKit::WebGeolocationManager::registerWebPage):
        (WebKit::WebGeolocationManager::unregisterWebPage):
        * WebProcess/IconDatabase/WebIconDatabaseProxy.cpp:
        (WebKit::WebIconDatabaseProxy::retainIconForPageURL):
        (WebKit::WebIconDatabaseProxy::releaseIconForPageURL):
        (WebKit::WebIconDatabaseProxy::synchronousIconForPageURL):
        (WebKit::WebIconDatabaseProxy::loadDecisionForIconURL):
        (WebKit::WebIconDatabaseProxy::setIconURLForPageURL):
        (WebKit::WebIconDatabaseProxy::setIconDataForIconURL):
        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::postMessage):
        (WebKit::InjectedBundle::postSynchronousMessage):
        * WebProcess/Network/WebResourceLoader.cpp:
        (WebKit::WebResourceLoader::messageSenderConnection):
        (WebKit::WebResourceLoader::messageSenderDestinationID):
        * WebProcess/Network/WebResourceLoader.h:
        (WebResourceLoader):
        * WebProcess/Notifications/WebNotificationManager.cpp:
        (WebKit::WebNotificationManager::show):
        (WebKit::WebNotificationManager::cancel):
        (WebKit::WebNotificationManager::clearNotifications):
        (WebKit::WebNotificationManager::didDestroyNotification):
        * WebProcess/Plugins/PDF/PDFPlugin.mm:
        (WebKit::PDFPlugin::writeItemsToPasteboard):
        * WebProcess/Plugins/PluginProcessConnectionManager.cpp:
        (WebKit::PluginProcessConnectionManager::getPluginProcessConnection):
        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::StorageAreaMap::StorageAreaMap):
        (WebKit::StorageAreaMap::~StorageAreaMap):
        (WebKit::StorageAreaMap::setItem):
        (WebKit::StorageAreaMap::removeItem):
        (WebKit::StorageAreaMap::clear):
        (WebKit::StorageAreaMap::loadValuesIfNeeded):
        * WebProcess/WebConnectionToUIProcess.cpp:
        (WebKit::WebConnectionToUIProcess::hasValidConnection):
        (WebKit::WebConnectionToUIProcess::messageSenderConnection):
        (WebKit::WebConnectionToUIProcess::messageSenderDestinationID):
        * WebProcess/WebConnectionToUIProcess.h:
        (WebConnectionToUIProcess):
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::windowRect):
        (WebKit::WebChromeClient::focusedFrameChanged):
        (WebKit::WebChromeClient::createWindow):
        (WebKit::WebChromeClient::toolbarsVisible):
        (WebKit::WebChromeClient::statusbarVisible):
        (WebKit::WebChromeClient::menubarVisible):
        (WebKit::WebChromeClient::runBeforeUnloadConfirmPanel):
        (WebKit::WebChromeClient::runJavaScriptAlert):
        (WebKit::WebChromeClient::runJavaScriptConfirm):
        (WebKit::WebChromeClient::runJavaScriptPrompt):
        (WebKit::WebChromeClient::shouldInterruptJavaScript):
        (WebKit::WebChromeClient::exceededDatabaseQuota):
        * WebProcess/WebCoreSupport/WebColorChooser.cpp:
        (WebKit::WebColorChooser::WebColorChooser):
        (WebKit::WebColorChooser::setSelectedColor):
        (WebKit::WebColorChooser::endChooser):
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::dispatchDidReceiveIcon):
        (WebKit::WebFrameLoaderClient::updateGlobalHistory):
        (WebKit::WebFrameLoaderClient::updateGlobalHistoryRedirectLinks):
        (WebKit::WebFrameLoaderClient::setTitle):
        * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
        (WebKit::WebPlatformStrategies::populatePluginCache):
        (WebKit::WebPlatformStrategies::getTypes):
        (WebKit::WebPlatformStrategies::bufferForType):
        (WebKit::WebPlatformStrategies::getPathnamesForType):
        (WebKit::WebPlatformStrategies::stringForType):
        (WebKit::WebPlatformStrategies::copy):
        (WebKit::WebPlatformStrategies::changeCount):
        (WebKit::WebPlatformStrategies::uniqueName):
        (WebKit::WebPlatformStrategies::color):
        (WebKit::WebPlatformStrategies::url):
        (WebKit::WebPlatformStrategies::addTypes):
        (WebKit::WebPlatformStrategies::setTypes):
        (WebKit::WebPlatformStrategies::setBufferForType):
        (WebKit::WebPlatformStrategies::setPathnamesForType):
        (WebKit::WebPlatformStrategies::setStringForType):
        * WebProcess/WebCoreSupport/WebPopupMenu.cpp:
        (WebKit::WebPopupMenu::show):
        (WebKit::WebPopupMenu::hide):
        * WebProcess/WebCoreSupport/WebSearchPopupMenu.cpp:
        (WebKit::WebSearchPopupMenu::saveRecentSearches):
        (WebKit::WebSearchPopupMenu::loadRecentSearches):
        * WebProcess/WebPage/EventDispatcher.cpp:
        (WebKit::EventDispatcher::sendDidReceiveEvent):
        * WebProcess/WebPage/WebBackForwardListProxy.cpp:
        (WebKit::updateBackForwardItem):
        (WebKit::WebBackForwardListProxy::itemAtIndex):
        (WebKit::WebBackForwardListProxy::backListCount):
        (WebKit::WebBackForwardListProxy::forwardListCount):
        * WebProcess/WebPage/WebInspector.cpp:
        (WebKit::WebInspector::createInspectorPage):
        (WebKit::WebInspector::didClose):
        (WebKit::WebInspector::bringToFront):
        (WebKit::WebInspector::inspectedURLChanged):
        (WebKit::WebInspector::save):
        (WebKit::WebInspector::append):
        (WebKit::WebInspector::attachBottom):
        (WebKit::WebInspector::attachRight):
        (WebKit::WebInspector::detach):
        (WebKit::WebInspector::setAttachedWindowHeight):
        (WebKit::WebInspector::setAttachedWindowWidth):
        (WebKit::WebInspector::setToolbarHeight):
        (WebKit::WebInspector::updateDockingAvailability):
        (WebKit::WebInspector::sendMessageToRemoteFrontend):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::messageSenderConnection):
        (WebKit):
        (WebKit::WebPage::messageSenderDestinationID):
        * WebProcess/WebPage/WebPage.h:
        (WebPage):
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::executeKeypressCommandsInternal):
        (WebKit::WebPage::handleEditingKeyboardEvent):
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::ensureNetworkProcessConnection):
        (WebKit::WebProcess::shouldTerminate):

2013-05-24  Tim Horton  <timothy_horton@apple.com>

        Animated GIFs don't repaint after TiledCoreAnimationDrawingArea un-suspends painting
        https://bugs.webkit.org/show_bug.cgi?id=116744
        <rdar://problem/13973514>

        Reviewed by Simon Fraser.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::resumePainting):
        Force WebCore to repaint animated images when painting is resumed.

2013-05-24  Christophe Dumez  <ch.dumez@sisa.samsung.com>

        Remove custom code for webkitAudioContext global constructor getter
        https://bugs.webkit.org/show_bug.cgi?id=116530

        Reviewed by Geoffrey Garen.

        Use RuntimeEnabledFeatures instead of WebCore Settings to toggle Web Audio support.

        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::overrideBoolPreferenceForTestRunner):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::updatePreferences):

2013-05-24  Thomas Deniau  <deniau@apple.com>

        Add more lines to the context during Dictionary lookups
        https://bugs.webkit.org/show_bug.cgi?id=115256

        Reviewed by Ryosuke Niwa.

        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::performDictionaryLookupAtLocation):
        Instead of using the current paragraph as the context (which stops at
        line breaks), get a few lines before and after the point, so that the
        context contains at least four lines in each direction.
        This way the Dictionary will be able to look up things that extend past
        the current line.

2013-05-24  Anders Carlsson  <andersca@apple.com>

        Intermittent crash when typing in Address Bar
        https://bugs.webkit.org/show_bug.cgi?id=116728
        <rdar://problem/13976781>

        Reviewed by Sam Weinig.

        If a web process connection has been removed from the storage manager because we disconnected it
        since there were no more active pages associated with the web process, we'll fail to find it here
        so just return early instead of crashing.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::destroyStorageMap):

2013-05-24  Andreas Kling  <akling@apple.com>

        Typing in Safari's unified field causes unnecessary web content repaints.
        <http://webkit.org/b/116703>

        Reviewed by Andy Estes.

        * WebProcess/WebPage/FindController.cpp:
        (WebKit::FindController::countStringMatches):

            Call WebCore::Page::countMatchesForText() instead of markAllMatchesForText(). If the search string
            is found inside the page content, the renderer containing that text will no longer be repainted.

2013-05-23  Ryuan Choi  <ryuan.choi@samsung.com>

        [WK2][EFL][QT] Build break after r150610
        https://bugs.webkit.org/show_bug.cgi?id=116699

        Reviewed by Csaba Osztrogonác.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::findPlugin): Initialized pluginProcessSandboxPolicy.

2013-05-23  Anders Carlsson  <andersca@apple.com>

        Shim Flash plug-in to allow its updater to run
        https://bugs.webkit.org/show_bug.cgi?id=116692
        <rdar://problem/13938510>

        Reviewed by Sam Weinig.

        * PluginProcess/PluginProcess.h:
        * PluginProcess/mac/PluginProcessMac.mm:
        (WebKit::replacedNSConcreteTask_launch):
        (WebKit::initializeCocoaOverrides):
        Patch -[NSConcreteTask launch] to call PluginProcess::launchProcess.

        (WebKit::PluginProcess::launchProcess):
        Send a LaunchProcess message to the UI process.

        * UIProcess/Plugins/PluginProcessProxy.cpp:
        * UIProcess/Plugins/PluginProcessProxy.h:
        Remove PluginProcessProxy::didReceiveMessage.

        (PluginProcessProxy):
        * UIProcess/Plugins/PluginProcessProxy.messages.in:
        Add LaunchProcess message and remove LegacyReceiver attribute.

        * UIProcess/Plugins/mac/PluginProcessProxyMac.mm:
        (WebKit::isFlashUpdater):
        Helper function to determine whether the process is the flash updater.

        (WebKit::shouldLaunchProcess):
        Return whether we should launch this process.

        (WebKit::PluginProcessProxy::launchProcess):
        Determine if we should launch this process and then do so.

2013-05-23  Anders Carlsson  <andersca@apple.com>

        Don't run all plug-ins unsandboxed
        https://bugs.webkit.org/show_bug.cgi?id=116690
        <rdar://problem/13975569>

        Reviewed by Jessie Berlin.

        Remove debugging code.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::findPlugin):

2013-05-23  Anders Carlsson  <andersca@apple.com>

        Crash in convertMainResourceLoadToDownload when downloading file by option-return
        https://bugs.webkit.org/show_bug.cgi?id=116451

        Reviewed by Andreas Kling.

        If the main resource loader is null, create a new download instead since there's no existing loader to convert.

        * NetworkProcess/NetworkConnectionToWebProcess.cpp:
        (WebKit::NetworkConnectionToWebProcess::convertMainResourceLoadToDownload):
        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::convertMainResourceLoadToDownload):

2013-05-22  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13849260> Sandbox violations reading .CFUserTextEncoding

        Reviewed by Dan Bernstein.

        * WebProcess/com.apple.WebProcess.sb.in: Allow this.

2013-05-23  Gavin Barraclough  <barraclough@apple.com>

        Move posix_spawn onto a zero delay timer
        https://bugs.webkit.org/show_bug.cgi?id=116682

        Reviewed by Anders Carlson.

        <rdar://problem/13973468>

        * Shared/EntryPointUtilities/mac/XPCService/XPCServiceMain.Development.mm:
        (ReexecInfo):
            - struct to hold info from the XPC message.
        (WebKit::reexec):
            - moved call to posix_spawn out to this helper.
        (WebKit::reexecCallBack):
            - calls reexec.
        (WebKit::XPCServiceEventHandler):
            - removed call to posix_spawn; schedule a call to reexecCallBack.

2013-05-23  Csaba Osztrogonác  <ossy@webkit.org>

        [cmake] Fix generating-forwarding-headers rule after r150460
        https://bugs.webkit.org/show_bug.cgi?id=116659

        Reviewed by Christophe Dumez.

        * CMakeLists.txt: Typo fix.

2013-05-23  Anton Obzhirov  <a.obzhirov@samsung.com>

        [GTK] Remote Web Inspector sometimes won't serve any content
        https://bugs.webkit.org/show_bug.cgi?id=116225

        Reviewed by Gustavo Noronha Silva.

        Added an option to use environment variable to set up path to
        inspector server files. Implementation is similar to InspectorClientGtk
        implementation.

        * UIProcess/InspectorServer/WebInspectorServer.h:
        (WebInspectorServer):
        * UIProcess/InspectorServer/gtk/WebInspectorServerGtk.cpp:
        (WebKit::WebInspectorServer::platformResourceForPath):
        (WebKit::WebInspectorServer::inspectorServerFilesPath):
        (WebKit):

2013-05-23  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        [EFL][WK2] Use WK2 C API in ewk_view_pagination_mode_set|get
        https://bugs.webkit.org/show_bug.cgi?id=116657

        Reviewed by Christophe Dumez.

        WKPageGet|SetPaginationMode APIs is present in WK2 C APIs. So, we need to use them for
        ewk_view_pagination_mode_set|get.

        Besides we don't need to use WebCore namespace anymore.

        * UIProcess/API/efl/ewk_view.cpp:
        (ewk_view_pagination_mode_set):
        (ewk_view_pagination_mode_get):

2013-05-23  Roland Takacs  <rtakacs@inf.u-szeged.hu>

        Support frame instrumentation for coordinated graphics
        https://bugs.webkit.org/show_bug.cgi?id=115260

        Reviewed by Andreas Kling.

        Enabled supportsFrameInstrumentation on ports that use coordinated graphics
        by calling didBeginFrame().

        * WebProcess/WebCoreSupport/WebInspectorClient.cpp:
        (WebKit::WebInspectorClient::supportsFrameInstrumentation):
        (WebKit):
        * WebProcess/WebCoreSupport/WebInspectorClient.h:
        (WebInspectorClient):
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::syncDisplayState):

2013-05-22  Dean Jackson  <dino@apple.com>

        Don't snapshot plugins that can't be snapshotted
        https://bugs.webkit.org/show_bug.cgi?id=116490

        Reviewed by Tim Horton.

        Some plugins, such as QuickTime, don't support snapshotting. We're
        planning on another way to capture snapshots, but in the meantime make
        sure that they don't fail to initialise because they were told to
        not use accelerated rendering.

        Expose a new message on the plugins so that they can tell the PluginView
        if they support snapshotting or not.

        * PluginProcess/PluginControllerProxy.cpp:
        (WebKit::PluginControllerProxy::supportsSnapshotting): New method.
        * PluginProcess/PluginControllerProxy.h: Ditto.
        * PluginProcess/PluginControllerProxy.messages.in: Message signature.

        * WebProcess/Plugins/Netscape/NetscapePlugin.h: Add supportsSnapshotting.
        * WebProcess/Plugins/PDF/SimplePDFPlugin.h: Ditto.
        * WebProcess/Plugins/Plugin.h: Ditto - pure virtual here.

        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::supportsSnapshotting): Send the message to the plugin process and return the results.
        * WebProcess/Plugins/PluginProxy.h:

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::didInitializePlugin): If the snapshotting plugin has a layer, make
            sure to add it to the tree.
        (WebKit::PluginView::isAcceleratedCompositingEnabled): Snapshotting plugins can use
            accelerated compositing, just like normal plugins.
        (WebKit::PluginView::pluginSnapshotTimerFired): If the plugin doesn't allow snapshotting,
            immediately restart it.

2013-05-22  Anders Carlsson  <andersca@apple.com>

        Fix crash when closing a page that's trying to access session storage
        https://bugs.webkit.org/show_bug.cgi?id=116634
        <rdar://problem/13904054>

        Reviewed by Geoffrey Garen.

        It is possible for the StorageManager to get messages from a web page that has already been closed by the UI process.
        If that happens, just ignore the messages.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::createSessionStorageMap):
        (WebKit::StorageManager::getValues):
        (WebKit::StorageManager::setItem):
        (WebKit::StorageManager::removeItem):
        (WebKit::StorageManager::clear):
        (WebKit::StorageManager::destroySessionStorageNamespaceInternal):

2013-05-22  Alexey Proskuryakov  <ap@apple.com>

        Crashes in NetworkProcess due to incorrect private browsing session tracking
        https://bugs.webkit.org/show_bug.cgi?id=116628

        Reviewed by Brady Eidson.

        The current API for private browsing makes it extremely difficult to track sessions.
        Private browsing is enabled via WKPreferences, but the session is shared, so it
        has to be maintained while there is any chance that any page group anywhere still
        needs it.

        This patch fixes some of the issues, but ultimately, I think that we'll just need
        to deprecate and replace the API.

        * NetworkProcess/NetworkConnectionToWebProcess.cpp: (WebKit::storageSession):
        There are valid scenarios where privateBrowsingEnabled is true, but there is no
        private browsing session. Handle that without crashing, although this unfortunately
        means that it will be harder to spot logic errors when using a wrong session.
        (WebKit::NetworkConnectionToWebProcess::registerBlobURL): Removed an obsolete FIXME.

        * NetworkProcess/mac/RemoteNetworkingContext.h: Changed privateBrowsingSession()
        to return a pointer, as no caller could know when it was safe to call it.

        * NetworkProcess/mac/RemoteNetworkingContext.mm:
        (WebKit::RemoteNetworkingContext::storageSession): Handle the case where private
        browsing session is unexpectedly missing without crashing.
        (WebKit::RemoteNetworkingContext::privateBrowsingSession): Changed to return a pointer.

        * UIProcess/WebContext.cpp: (WebKit::WebContext::ensureNetworkProcess):
        Actually initialize privateBrowsingEnabled creation parameter. It would be very
        difficult to figure out 100% reliably whether NetworkProcess needs a private browsing
        session with the current API, but for existing clients, looking at
        m_privateBrowsingEnterCount is good enough. Certainly better than not initializing.

        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::setPrivateBrowsingEnabled): Added a FIXME.

2013-05-22  Tim Horton  <timothy_horton@apple.com>

        [wk2] Should be able to make tiled WKViews clip to the view's exposed rect without using autolayout
        https://bugs.webkit.org/show_bug.cgi?id=116625
        <rdar://problem/13962816>

        Reviewed by Anders Carlsson.

        The two modes are not dependent; it should be possible to enable
        clips-to-exposed-rect without using autolayout. This enables apps to
        make very large tiled WKViews that don't create tiles for the whole
        area of the view (and also disables scrolling, since that is currently
        incompatible with clipping to the exposed rect).

        * UIProcess/API/mac/WKView.mm:
        (-[WKView setFrameSize:]):
        (-[WKView _updateWindowAndViewFrames]):
        (-[WKView initWithFrame:contextRef:pageGroupRef:relatedToPage:]):
        (-[WKView enableFrameSizeUpdates]):
        (-[WKView forceAsyncDrawingAreaSizeUpdate:]):
        Rename _expandsToFitContentViaAutoLayout to _clipsToVisibleRect for accuracy.

        (-[WKView setMinimumWidthForAutoLayout:]):
        Factor clips-to-sisible-rect toggle out into setShouldClipToVisibleRect.

        (-[WKView shouldClipToVisibleRect]):
        (-[WKView setShouldClipToVisibleRect:]):
        Allow setting clips-to-visible-rect without autolayout.

        * UIProcess/API/mac/WKViewPrivate.h:
        Add shouldClipToVisibleRect property.

2013-05-22  Alexey Proskuryakov  <ap@apple.com>

        Remove unused private browsing override support
        <rdar://problem/11969491>

        Rubber-stamped by Sam Weinig.

        Private browsing override is unused, and it complicates tracking of private
        browsing sessions in UI process (in fact, it doesn't plug into this tracking at all,
        so we would just assert if we used the API).

        * Shared/WebPageCreationParameters.cpp:
        (WebKit::WebPageCreationParameters::encode):
        (WebKit::WebPageCreationParameters::decode):
        * Shared/WebPageCreationParameters.h:
        * UIProcess/API/C/WKPage.cpp:
        * UIProcess/API/C/WKPagePrivate.h:
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::WebPageProxy):
        (WebKit::WebPageProxy::creationParameters):
        * UIProcess/WebPageProxy.h:
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::WebPage):
        (WebKit::WebPage::updatePreferences):
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/WebPage.messages.in:

2013-05-22  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [EFL][WK2] Change Ewk_Context_Menu_Item's parent menu to raw pointer
        https://bugs.webkit.org/show_bug.cgi?id=116549

        Reviewed by Christophe Dumez.

        A context menu item should have only a pointer to parent menu instead
        of owning parent menu.

        * UIProcess/API/efl/ewk_context_menu_item.cpp:
        (EwkContextMenuItem::EwkContextMenuItem):
        * UIProcess/API/efl/ewk_context_menu_item_private.h:
        (EwkContextMenuItem::create):
        (EwkContextMenuItem::parentMenu):
        (EwkContextMenuItem):

2013-05-22  Csaba Osztrogonác  <ossy@webkit.org>

        [Qt][WK2] Unreviewed buildfix after r150484.

        * UIProcess/Plugins/qt/PluginProcessProxyQt.cpp:
        (WebKit::PluginProcessProxy::platformGetLaunchOptions):

2013-05-21  Andreas Kling  <akling@apple.com>

        REGRESSION(r150491): WebKit2.CloseThenTerminate asserting below WebContext::disconnectProcess().
        <http://webkit.org/b/116588>

        Reviewed by Sam Weinig.

        Do an early return from WebProcessProxy::requestTermination() if there is no child process
        connection to terminate.

        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::requestTermination):

2013-05-21  Mark Rowe  <mrowe@apple.com>

        <rdar://problem/13915556> Sluggish scrolling in web content

        Reviewed by Gavin Barraclough.

        * Shared/mac/ChildProcessMac.mm:
        (WebKit::ChildProcess::setProcessSuppressionEnabled): When process suppression is disabled, low latency is important.

2013-05-21  Gyuyoung Kim  <gyuyoung.kim@samsung.com>

        Fix build break after r150484

        Unreviewed, fix build break on EFL, GTK.

        * UIProcess/Plugins/PluginInfoStore.cpp:
        (WebKit::PluginInfoStore::defaultLoadPolicyForPlugin):
        * UIProcess/Plugins/unix/PluginProcessProxyUnix.cpp:
        (WebKit::PluginProcessProxy::platformGetLaunchOptions):

2013-05-21  Andreas Kling  <akling@apple.com>

        PPT: Closing tab that is hung or chewing 100% CPU leaves abandoned WebProcess.
        <http://webkit.org/b/116464>
        <rdar://problem/10103795>

        Reviewed by Anders Carlsson.

        Simplify the web process sacrifice ritual. Instead of murderizing the process when its last tab closes,
        just shut down the CoreIPC connection from the UI process. The web process, upon noticing this,
        will start a 10 second watchdog timer, and if it hasn't shut down by the time it fires, well, it'll shut down.

        (WebKit::WebProcessProxy::removeWebPage):

            When the last page is removed from a WebProcessProxy, disconnect the process so that it'll die off
            eventually, even if the WebPage::Close message never gets properly handled.

        * Shared/ChildProcessProxy.h:
        * Shared/ChildProcessProxy.cpp:
        (WebKit::ChildProcessProxy::abortProcessLaunchIfNeeded):

            Added a helper to abort any in-progress launch of a new web process. Otherwise we'll have a race
            where the exiting web process may get re-used for a new tab.

        * UIProcess/WebProcessProxy.h:
        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::WebProcessProxy):
        (WebKit::WebProcessProxy::enableSuddenTermination):
        (WebKit::WebProcessProxy::disableSuddenTermination):

            Remove WebProcessProxy's sudden termination counter. The web process will do what it needs in
            response to the WebPage::Close message. We still forward these calls to NSProcessInfo on Mac though.

2013-05-21  Anders Carlsson  <andersca@apple.com>

        Fix build.

        * WebProcess/Plugins/PluginProcessConnectionManager.cpp:
        (WebKit::PluginProcessConnectionManager::getPluginProcessConnection):
        Stop using lambdas :(

2013-05-21  Anders Carlsson  <andersca@apple.com>

        Provide an API to run sandboxed plug-ins outside of their sandbox
        https://bugs.webkit.org/show_bug.cgi?id=116578

        Reviewed by Andreas Kling.

        * Platform/CoreIPC/HandleMessage.h:
        (CoreIPC::callMemberFunction):
        Add new overload.

        * PluginProcess/EntryPoint/mac/LegacyProcess/PluginProcessMain.mm:
        (WebKit::PluginProcessMainDelegate::getExtraInitializationData):
        Handle "disable-sandbox".

        * PluginProcess/EntryPoint/mac/XPCService/PluginServiceEntryPoint.mm:
        (WebKit::PluginServiceInitializerDelegate::getExtraInitializationData):
        Handle "disable-sandbox".
        
        * PluginProcess/PluginProcess.h:
        Move Type to PluginProcessAttributes and remove hash traits for type.
        
        * PluginProcess/mac/PluginProcessMac.mm:
        (WebKit::PluginProcess::platformInitializePluginProcess):
        Update for new type name.

        (WebKit::PluginProcess::initializeSandbox):
        Return early if the sandbox is disabled.

        * Shared/Plugins/Netscape/PluginInformation.cpp:
        (WebKit::getPluginModuleInformation):
        PluginInfoStore::policyForPlugin has been renamed to PluginInfoStore::defaultLoadPolicyForPlugin.

        * Shared/Plugins/PluginModuleInfo.h:
        Add PluginModuleLoadUnsandboxed.

        * Shared/Plugins/PluginProcessAttributes.h: Added.
        Add new header with various plug-in process attributes.

        * Shared/Plugins/PluginProcessCreationParameters.h:
        Change type enum.

        * UIProcess/API/C/WKAPICast.h:
        (WebKit::toWKPluginLoadPolicy):
        (WebKit::toPluginModuleLoadPolicy):
        Handle the unsandboxed enum.

        * UIProcess/API/C/WKPage.h:
        Add kWKPluginLoadPolicyLoadUnsandboxed.

        * UIProcess/Plugins/PluginInfoStore.h:
        Rename policyForPlugin to defaultLoadPolicyForPlugin.

        * UIProcess/Plugins/PluginProcessManager.cpp:
        (WebKit::PluginProcessManager::pluginProcessToken):
        Add new helper function for getting a token given plug-in attributes.

        (WebKit::PluginProcessManager::getPluginProcessConnection):
        This now takes a pluginProcessToken.

        (WebKit::PluginProcessManager::getSitesWithData):
        Make sure to call pluginProcessToken.

        (WebKit::PluginProcessManager::clearSiteData):
        Ditto.

        (WebKit::PluginProcessManager::getOrCreatePluginProcess):
        This now takes a token.

        * UIProcess/Plugins/PluginProcessProxy.cpp:
        (WebKit::PluginProcessProxy::create):
        (WebKit::PluginProcessProxy::PluginProcessProxy):
        Pass the PluginProcessAttributes as well as the plug-in process token.

        (WebKit::PluginProcessProxy::getLaunchOptions):
        Pass the plug-in process attributes to platformGetLaunchOptions.

        (WebKit::PluginProcessProxy::didClose):
        Pass the token to PluginProcessCrashed.

        (WebKit::PluginProcessProxy::didFinishLaunching):
        Update for type change.

        * UIProcess/Plugins/mac/PluginInfoStoreMac.mm:
        (WebKit::shouldBlockPlugin):
        (WebKit::PluginInfoStore::defaultLoadPolicyForPlugin):
        Rename policyForPlugin to defaultLoadPolicyForPlugin.

        * UIProcess/Plugins/mac/PluginProcessProxyMac.mm:
        (WebKit::PluginProcessProxy::platformGetLaunchOptions):
        Set the "disable-sandbox" data if needed.

        (WebKit::PluginProcessProxy::platformInitializePluginProcess):
        (WebKit::PluginProcessProxy::openPluginPreferencePane):
        Get the module info from m_pluginProcessAttributes.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::findPlugin):
        This now returns a token.

        * UIProcess/WebPageProxy.messages.in:
        FindPlugin now returns a token instead of the path.

        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::getPluginProcessConnection):
        Pass the token to the plug-in process manager.

        * UIProcess/WebProcessProxy.messages.in:
        This now takes a token.

        * WebKit2.xcodeproj/project.pbxproj:
        Add new files.

        * WebProcess/Plugins/PluginProcessConnection.cpp:
        (WebKit::PluginProcessConnection::PluginProcessConnection):
        This now takes a token.

        * WebProcess/Plugins/PluginProcessConnection.h:
        (WebKit::PluginProcessConnection::create):
        (WebKit::PluginProcessConnection::pluginProcessToken):
        Create this with a token instead of a path and process type.

        * WebProcess/Plugins/PluginProcessConnectionManager.cpp:
        (WebKit::PluginProcessConnectionManager::getPluginProcessConnection):
        This now takes a token.

        (WebKit::PluginProcessConnectionManager::pluginProcessCrashed):
        Ditto.

        * WebProcess/Plugins/PluginProcessConnectionManager.messages.in:
        PluginProcessCrashed now takes a token.

        * WebProcess/Plugins/PluginProxy.cpp:
        (WebKit::PluginProxy::create):
        (WebKit::PluginProxy::PluginProxy):
        These now take tokens.

        (WebKit::PluginProxy::initialize):
        Pass the token when getting the connection.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::createPlugin):
        Get the token from the UI process and pass it to the PluginProxy.

        (WebKit::WebPage::canPluginHandleResponse):
        Update now that FindPlugin returns a token.

2013-05-21  Martin Robinson  <mrobinson@igalia.com>

        [GTK] [CMake] Add support for building WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=116372

        Reviewed by Gustavo Noronha Silva.

        * CMakeLists.txt: Add common directories to the common include list and remove UIProcess/PageViewportController.cpp
        from the source list since it should only be compiled for WebKitEFL. Instead of taking explicit forwarding-header
        dependencies accept a list of "tacked-on" dependencies for WebKit2. This allows GTK+ to specify its extra fake
        installed header step.
        * PlatformEfl.cmake: Remove common include directories and add UIProcess/PageViewportController.cpp to the source
        list. Fix up forwarding header dependencies now.
        * PlatformGTK.cmake: Added.
        * config.h: First check whether this is a CMake build and then fall back to the autotools header.

2013-05-21  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Compile everything in C++11 mode
        https://bugs.webkit.org/show_bug.cgi?id=116452

        Reviewed by Anders Carlsson.

        * GNUmakefile.am: Remove the -std=c++11 flags from the various CPPFLAGS lists, the mode is now specified
        by default for all the C++ source code in SetupCompilerFlags.m4.

2013-05-21  Jessie Berlin  <jberlin@apple.com>

        Expose a way to know when forms are added to a page or when form controls are added to a form
        in the injected bundle
        https://bugs.webkit.org/show_bug.cgi?id=116334

        Reviewed by Alexey Proskuryakov.

        Add shouldNotifyOnFormChanges and didAssociateFormControls to the WKBundlePageFormClient.

        * WebProcess/InjectedBundle/API/c/WKBundlePage.h:
        Add the new callbacks as part of version 2 of the WKBundlePageFormClient.

        * WebProcess/InjectedBundle/InjectedBundlePageFormClient.cpp:
        (WebKit::InjectedBundlePageFormClient::didAssociateFormControls):
        Pass the message along to the client if the client has a handler.
        (WebKit::InjectedBundlePageFormClient::shouldNotifyOnFormChanges):
        Ditto.
        * WebProcess/InjectedBundle/InjectedBundlePageFormClient.h:

        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::didAssociateFormControls):
        Tell the injected bundle form client for the page.
        (WebKit::WebChromeClient::shouldNotifyOnFormChanges):
        Ditto.
        * WebProcess/WebCoreSupport/WebChromeClient.h:

2013-05-21  Michael Brüning  <michael.bruning@digia.com>

        [Qt][WK2] Fix Mountain Lion builds after r150277.
        https://bugs.webkit.org/show_bug.cgi?id=116467

        Reviewed by Jocelyn Turcotte.

        * Shared/API/c/WKBase.h:

2013-05-20  Lucas Forschler  <lforschler@apple.com>

    Rollout r150398.

2013-05-20  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Fix concatenations of string literals that are not C++11-compliant
        https://bugs.webkit.org/show_bug.cgi?id=116449

        Reviewed by Martin Robinson.

        Fix the problematic concatenations of string literals so they are compilable under the C++11 standard. This
        is simply a matter of separating the string and the string literal that are being concatenated with a space.

        * UIProcess/API/gtk/tests/TestPrinting.cpp:
        (testPrintOperationPrint):
        * UIProcess/API/gtk/tests/WebExtensionTest.cpp:
        (methodCallCallback):

2013-05-20  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r150384.
        http://trac.webkit.org/changeset/150384
        https://bugs.webkit.org/show_bug.cgi?id=116513

        Not ready for primetime. (Requested by kling on #webkit).

        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::WebProcessProxy):
        (WebKit::WebProcessProxy::removeWebPage):
        * UIProcess/WebProcessProxy.h:
        (WebProcessProxy):

2013-05-20  Martin Robinson  <mrobinson@igalia.com>

        Remove SharedMemoryGtk.cpp
        https://bugs.webkit.org/show_bug.cgi?id=116457

        Reviewed by Andreas Kling.

        * Platform/gtk/SharedMemoryGtk.cpp: Removed.

2013-05-20  Jessie Berlin  <jberlin@apple.com>

        Expose a way to know when forms are added to a page or when form controls are added to a form
        in the injected bundle
        https://bugs.webkit.org/show_bug.cgi?id=116334

        Reviewed by Alexey Proskuryakov.

        Add shouldNotifyOnFormChanges and didAssociateFormControls to the WKBundlePageFormClient.

        * WebProcess/InjectedBundle/API/c/WKBundlePage.h:
        Add the new callbacks as part of version 2 of the WKBundlePageFormClient.

        * WebProcess/InjectedBundle/InjectedBundlePageFormClient.cpp:
        (WebKit::InjectedBundlePageFormClient::didAssociateFormControls):
        Pass the message along to the client if the client has a handler.
        (WebKit::InjectedBundlePageFormClient::shouldNotifyOnFormChanges):
        Ditto.
        * WebProcess/InjectedBundle/InjectedBundlePageFormClient.h:

        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::didAssociateFormControls):
        Tell the injected bundle form client for the page.
        (WebKit::WebChromeClient::shouldNotifyOnFormChanges):
        Ditto.
        * WebProcess/WebCoreSupport/WebChromeClient.h:

2013-05-20  Tim Horton  <timothy_horton@apple.com>

        Clients should have a way to extend rendering suppression
        https://bugs.webkit.org/show_bug.cgi?id=116463
        <rdar://problem/13738496>

        Reviewed by Andy Estes.

        * WebProcess/InjectedBundle/API/c/WKBundlePage.cpp:
        (WKBundlePageExtendIncrementalRenderingSuppression): Added.
        (WKBundlePageStopExtendingIncrementalRenderingSuppression): Added.
        * WebProcess/InjectedBundle/API/c/WKBundlePagePrivate.h:
        These only have any effect if SuppressesIncrementalRendering is also enabled.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::transitionToCommittedForNewPage):
        Inform the FrameView if there are any outstanding rendering suppression tokens.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::WebPage):
        (WebKit::WebPage::extendIncrementalRenderingSuppression):
        Return the next available rendering suppression token.
        Add it to the list of active tokens.
        Inform the FrameView that we want to suppress rendering.

        (WebKit::WebPage::stopExtendingIncrementalRenderingSuppression):
        Remove the given token from the list of active tokens.
        Un-suppress rendering if appropriate.

        * WebProcess/WebPage/WebPage.h:
        (WebKit::WebPage::shouldExtendIncrementalRenderingSuppression):
        Return if there are any active rendering suppression tokens.

2013-05-20  Andreas Kling  <akling@apple.com>

        PPT: Closing tab that is hung or chewing 100% CPU leaves abandoned WebProcess.
        <http://webkit.org/b/116464>
        <rdar://problem/10103795>

        Reviewed by Anders Carlsson.

        Give the web process a 10 second chance to exit nicely after closing the last tab belonging to it.
        This code only runs if there was something on the page (e.g an unload/beforeunload event handler)
        preventing the UI process from killing it right away.

        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::WebProcessProxy):
        (WebKit::WebProcessProxy::removeWebPage):
        (WebKit::WebProcessProxy::forcefulTerminationTimerFired):
        * UIProcess/WebProcessProxy.h:
        (WebProcessProxy):

2013-05-20  Anders Carlsson  <andersca@apple.com>

        Add helper function for converting a KeyedCodingValue to a CFTypeRef
        https://bugs.webkit.org/show_bug.cgi?id=116461

        Reviewed by Tim Horton.

        * Shared/cf/KeyedCodingValueCF.cpp: Added.
        * Shared/cf/KeyedCodingValueCF.h: Added.

        * WebKit2.xcodeproj/project.pbxproj:

2013-05-20  Anders Carlsson  <andersca@apple.com>

        Begin stubbing out a new KeyedEncoder class
        https://bugs.webkit.org/show_bug.cgi?id=116456

        Reviewed by Sam Weinig.

        This class (and it's coming counterpart, KeyedDecoder) will be used for serializing
        object graphs to a tree-like structure of dictionaries. It is up to individual ports to
        serialize them further (for example, on Mac they could be serialized to CFPropertyList objects).
        
        This will be used for serializing session storage state but I hope that it can be used for serializing
        back forward state in the future as our current implementation of back forward state serialization
        is fragile and depends on our IPC layer's binary encoding(!).
        
        * Shared/KeyedCodingValue.h: Added.
        * Shared/KeyedEncoder.cpp: Added.
        * Shared/KeyedEncoder.h: Added.

        * WebKit2.xcodeproj/project.pbxproj:

2013-05-19  Sam Weinig  <sam@webkit.org>

        Bump WKBundlePageLoaderClient version number so as not to break some clients
        https://bugs.webkit.org/show_bug.cgi?id=116426

        Reviewed by Anders Carlsson.

        * Shared/APIClientTraits.cpp:
        (WebKit):
        * Shared/APIClientTraits.h:
        * WebProcess/InjectedBundle/API/c/WKBundlePage.h:

2013-05-19  Anders Carlsson  <andersca@apple.com>

        Remove link prerendering code
        https://bugs.webkit.org/show_bug.cgi?id=116415

        Reviewed by Darin Adler.

        This code was only used by Chromium and is dead now.

        * Configurations/FeatureDefines.xcconfig:

2013-05-18  Anders Carlsson  <andersca@apple.com>

        Simplify the StorageArea setter functions
        https://bugs.webkit.org/show_bug.cgi?id=116402

        Reviewed by Sam Weinig.

        Remove security checking code that lives in Storage now.

        * WebProcess/Storage/StorageAreaImpl.cpp:
        (WebKit::StorageAreaImpl::setItem):
        (WebKit::StorageAreaImpl::removeItem):
        (WebKit::StorageAreaImpl::clear):
        * WebProcess/Storage/StorageAreaImpl.h:

2013-05-18  Sam Weinig  <sam@webkit.org>

        Fix some builds.

        * UIProcess/API/mac/WKTypeRefWrapper.mm:

2013-05-18  Carlos Garcia Campos  <cgarcia@igalia.com>

        REGRESSION(r150305): WebKit2 build broken with INDEXED_DATABASE enabled
        https://bugs.webkit.org/show_bug.cgi?id=116389

        Reviewed by Martin Robinson.

        There's no longer WebKeyValueStorageManager in the web process
        after r150305.

        * WebProcess/WebPage/WebPageGroupProxy.cpp:
        (WebKit::WebPageGroupProxy::WebPageGroupProxy):

2013-05-17  Sam Weinig  <sam@webkit.org>

        Add a way to pass WebKit2 WKTypeRefs in Objective-C style user data messages
        https://bugs.webkit.org/show_bug.cgi?id=116345

        Reviewed by Anders Carlsson.

        In order to efficiently send a WKImageRef to another process when using the
        Objective-C WKConnection (or other user data messages), we need a way to encode
        WKTypeRefs in the objective-c object graph. Thus was born WKTypeRefWrapper.

        * Shared/mac/ObjCObjectGraphCoders.mm:
        (WebKit::typeFromObject):
        (WebKit::WebContextObjCObjectGraphEncoderImpl::encode):
        (WebKit::WebContextObjCObjectGraphDecoderImpl::decode):
        (WebKit::InjectedBundleObjCObjectGraphEncoderImpl::encode):
        (WebKit::InjectedBundleObjCObjectGraphDecoderImpl::decode):
        * UIProcess/API/mac/WKTypeRefWrapper.h: Added.
        * UIProcess/API/mac/WKTypeRefWrapper.mm: Added.
        (-[WKTypeRefWrapper initWithObject:]):
        (-[WKTypeRefWrapper object]):
        * WebKit2.xcodeproj/project.pbxproj:

2013-05-18  Anders Carlsson  <andersca@apple.com>

        Simplify StorageArea getter functions
        https://bugs.webkit.org/show_bug.cgi?id=116399

        Reviewed by Sam Weinig.

        Remove security and private browsing checks.

        * WebProcess/Storage/StorageAreaImpl.cpp:
        (WebKit::StorageAreaImpl::key):
        (WebKit::StorageAreaImpl::item):
        (WebKit::StorageAreaImpl::contains):
        * WebProcess/Storage/StorageAreaImpl.h:

2013-05-18  Patrick Gansterer  <paroga@webkit.org>

        [CMake] Replace *_LIBRARY_NAME with *_OUTPUT_NAME
        https://bugs.webkit.org/show_bug.cgi?id=114554

        Reviewed by Gyuyoung Kim.

        Using variables as target names is very uncommon in CMake.
        The usual way to specify the name of the resulting binary
        is to set the OUTPUT_NAME target property.

        * CMakeLists.txt:
        * PlatformEfl.cmake:
        * efl/ewebkit2.pc.in:

2013-05-18  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Move GTK port off legacy clipboard
        https://bugs.webkit.org/show_bug.cgi?id=116221

        Reviewed by Martin Robinson.

        * UIProcess/API/gtk/WebKitWebViewBase.cpp: Remove ClipboardGtk.h
        include.
        * WebProcess/WebCoreSupport/gtk/WebDragClientGtk.cpp:
        (WebKit::WebDragClient::startDrag): Get the DataObjectGtk from the
        Pasteboard associated to the given Clipboard.

2013-05-18  Jinwoo Song  <jinwoo7.song@samsung.com>

        [EFL][WK2] Refactor ewk_view_custom_encoding_set/get API
        https://bugs.webkit.org/show_bug.cgi?id=116386

        Reviewed by Christophe Dumez.

        Refactor the API to handle 'const char*' parameter in right way and
        enable the unit test which was disabled in r136230 as there is no assertion now.

        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::setCustomTextEncodingName):
        * UIProcess/API/efl/EwkView.h:
        (EwkView::customTextEncodingName):
        (EwkView):
        * UIProcess/API/efl/ewk_view.cpp:
        (ewk_view_custom_encoding_set):
        * UIProcess/API/efl/tests/test_ewk2_view.cpp:
        (TEST_F):

2013-05-18  Csaba Osztrogonác  <ossy@webkit.org>

        [CMake] Unreviewed speculative build fix after r150305 and r150306.

        * CMakeLists.txt:

2013-05-18  Csaba Osztrogonác  <ossy@webkit.org>

        [Qt][WK2] Unreviewed build fix after r150305 and r150306.

        * DerivedSources.pri:
        * Target.pri:

2013-05-18  Zan Dobersek  <zdobersek@igalia.com>

        Unreviewed build fix for the GTK port after r150305 and r150306.

        * GNUmakefile.list.am:

2013-05-17  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13819878> Disable SharedWorker when in multiple web process model
        https://bugs.webkit.org/show_bug.cgi?id=116359

        The condition was accidentally negated, fixing.

        * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
        (WebKit::WebPlatformStrategies::isAvailable):

2013-05-17  Gavin Barraclough  <barraclough@apple.com>

        Only allow 1 WebProcess to hold a PageCache
        https://bugs.webkit.org/show_bug.cgi?id=116368
        <rdar://problem/13392600>

        Reviewed by Geoff Garen & Anders Carlson.

        * UIProcess/WebContext.cpp:
        (WebKit::WebContext::WebContext):
        (WebKit::WebContext::processDidSaveToPageCache):
        (WebKit):
        (WebKit::WebContext::disconnectProcess):
        * UIProcess/WebContext.h:
            - Added m_processWithPageCache, only allow one process to keep a PageCache.
        (WebContext):
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::didSaveToPageCache):
        (WebKit):
        * UIProcess/WebPageProxy.h:
        (WebPageProxy):
        * UIProcess/WebPageProxy.messages.in:
            - Forward didSaveToPageCache to the WebProcessProxy.
        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::addBackForwardItem):
        (WebKit::WebProcessProxy::didSaveToPageCache):
        (WebKit):
        (WebKit::WebProcessProxy::releasePageCache):
            - Forward releasePageCache to the WebProcess.
            - Forward didSaveToPageCache to the WebContext.
        * UIProcess/WebProcessProxy.h:
        (WebProcessProxy):
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::didSaveToPageCache):
            - Forward didSaveToPageCache to the WebPageProxy.
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::releasePageCache):
        (WebKit):
        * WebProcess/WebProcess.h:
        (WebProcess):
        * WebProcess/WebProcess.messages.in:
            - Added 'ReleasePageCache' to instruct a web process to drop any cached pages.

2013-05-17  Anders Carlsson  <andersca@apple.com>

        Share code between WebKit1 and WebKit2 StorageArea subclasses
        https://bugs.webkit.org/show_bug.cgi?id=116367

        Reviewed by Andreas Kling.

        * WebProcess/Storage/StorageAreaImpl.cpp:
        (WebKit::StorageAreaImpl::length):
        Remove code that's now in Storage::length.

        (WebKit::StorageAreaImpl::storageType):
        Make this a virtual member function.

        * WebProcess/Storage/StorageAreaImpl.h:

2013-05-17  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13819878> Disable SharedWorker when in multiple web process model
        https://bugs.webkit.org/show_bug.cgi?id=116359

        Reviewed by Anders Carlsson.

        Implement SharedWorkerStrategy::isAvailable.

        * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
        (WebKit::WebPlatformStrategies::isAvailable):
        * WebProcess/WebCoreSupport/WebPlatformStrategies.h:

2013-05-17  Beth Dakin  <bdakin@apple.com>

        Headers and footers will sometimes disappear and re-appear during page loads
        https://bugs.webkit.org/show_bug.cgi?id=116336
        -and corresponding-
        <rdar://problem/13886753>

        Reviewed by Simon Fraser.

        This patch changes the WebCore-level API that WebKit uses to create a banner. 
        Specifically this patch removes FrameView::setWantsLayerForHeader(), which created 
        and returned a layer. Instead, WK2 will call Page::addHeaderWithHeight(). When the 
        layer has been created, it will call back into WK2 via ChromeClient. This will 
        allow WebCore to re-create the header/footer layers as needed whenever the 
        FrameView/RenderLayerCompositor have been destroyed and recreated.

        Send the layers over to PageBanner.
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::didAddHeaderLayer):
        (WebKit::WebChromeClient::didAddFooterLayer):
        * WebProcess/WebCoreSupport/WebChromeClient.h:
        (WebChromeClient):

        PageBanner::addToPage() now does much less work since it can’t get the parent 
        layer right away. The work that is used to do once it had the parent layer is now 
        performed in didAddParentLayer()
        * WebProcess/WebPage/PageBanner.cpp:
        (WebKit::PageBanner::didAddParentLayer):
        * WebProcess/WebPage/PageBanner.h:
        * WebProcess/WebPage/mac/PageBannerMac.mm:
        (WebKit::PageBanner::addToPage):
        (WebKit::PageBanner::didAddParentLayer):

2013-05-17  Anders Carlsson  <andersca@apple.com>

        Rename WebKeyValueStorageManagerProxy to WebKeyValueStorageManager
        https://bugs.webkit.org/show_bug.cgi?id=116361

        Reviewed by Andreas Kling.

        There's nothing proxy about this class anymore!

        * UIProcess/API/C/WKAPICast.h:
        * UIProcess/API/C/WKContext.cpp:
        * UIProcess/API/C/WKKeyValueStorageManager.cpp:
        * UIProcess/WebKeyValueStorageManager.cpp: Renamed from Source/WebKit2/UIProcess/WebKeyValueStorageManagerProxy.cpp.
        * UIProcess/WebKeyValueStorageManager.h: Renamed from Source/WebKit2/UIProcess/WebKeyValueStorageManagerProxy.h.
        * WebKit2.xcodeproj/project.pbxproj:

2013-05-17  Anders Carlsson  <andersca@apple.com>

        Remove dead local storage code
        https://bugs.webkit.org/show_bug.cgi?id=116360

        Reviewed by Beth Dakin.

        Storage is all handled in the UI process now so we no longer need a WebKeyValueStorageManager in the web process.

        * DerivedSources.make:
        * UIProcess/WebKeyValueStorageManagerProxy.cpp:
        (WebKit::WebKeyValueStorageManagerProxy::WebKeyValueStorageManagerProxy):
        (WebKit):
        (WebKit::didGetKeyValueStorageOrigins):
        (WebKit::WebKeyValueStorageManagerProxy::getKeyValueStorageOrigins):
        * UIProcess/WebKeyValueStorageManagerProxy.h:
        (WebKeyValueStorageManagerProxy):
        * UIProcess/WebKeyValueStorageManagerProxy.messages.in: Removed.
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/Storage/WebKeyValueStorageManager.cpp: Removed.
        * WebProcess/Storage/WebKeyValueStorageManager.h: Removed.
        * WebProcess/Storage/WebKeyValueStorageManager.messages.in: Removed.
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::updatePreferences):
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::WebProcess):

2013-05-17  Anders Carlsson  <andersca@apple.com>

        Use the UI process storage manager for deleting local storage data
        https://bugs.webkit.org/show_bug.cgi?id=116358
        <rdar://problem/13852829>

        Reviewed by Andreas Kling.

        * Shared/WebSecurityOrigin.h:
        (WebKit::WebSecurityOrigin::protocol):
        (WebKit::WebSecurityOrigin::host):
        (WebKit::WebSecurityOrigin::databaseIdentifier):
        (WebKit::WebSecurityOrigin::toString):
        Remove unneeded consts.

        (WebKit::WebSecurityOrigin::securityOrigin):
        Add getter.

        * UIProcess/Storage/LocalStorageDatabase.cpp:
        (WebKit::LocalStorageDatabase::close):
        deleteEmptyDatabaseWithOrigin has been renamed to deleteDatabaseWithOrigin.

        * UIProcess/Storage/LocalStorageDatabaseTracker.cpp:
        (WebKit::LocalStorageDatabaseTracker::deleteDatabaseWithOrigin):
        Rename since this is no longer used only for empty databases.

        (WebKit::LocalStorageDatabaseTracker::deleteAllDatabases):
        Loop over the tracker database and delete all database files.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::StorageArea::clear):
        Clear the map, close the database and tell all event listeners to reset their caches.

        (WebKit::StorageManager::LocalStorageNamespace::clearStorageAreasMatchingOrigin):
        Loop over all storage areas and call clear on those matching the security origin.

        (WebKit::StorageManager::LocalStorageNamespace::clearAllStorageAreas):
        Loop over all storage areas and call clear on them.
        
        (WebKit::StorageManager::deleteEntriesForOrigin):
        Dispatch deleteEntriesForOriginInternal on the work queue.

        (WebKit::StorageManager::deleteAllEntries):
        Dispatch deleteAllEntriesInternal on the work queue.

        (WebKit::StorageManager::deleteEntriesForOriginInternal):
        Call clearStorageAreasMatchingOrigin on all local storage namespaces and then delete the database.

        (WebKit::StorageManager::deleteAllEntriesInternal):
        Call clearAllStorageAreas on all local storage namespaces and then delete all databases.

        * UIProcess/WebKeyValueStorageManagerProxy.cpp:
        (WebKit::WebKeyValueStorageManagerProxy::deleteEntriesForOrigin):
        Call out to the storage manager.

        (WebKit::WebKeyValueStorageManagerProxy::deleteAllEntries):
        Ditto.

        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::StorageAreaMap::clearCache):
        Call resetValues which will null out the storage map.

        * WebProcess/Storage/StorageAreaMap.messages.in:
        Add ClearCache message.

2013-05-17  Anders Carlsson  <andersca@apple.com>

        Only import local storage items from the database once
        https://bugs.webkit.org/show_bug.cgi?id=116354

        Reviewed by Andreas Kling.

        We import items from the database over and over, when we only want to do it once. Use a 
        boolean flag to guard against doing it more than once. 
        
        Also, rename importItemsFromDatabase to openDatabaseAndImportItemsIfNeeded since it now
        also opens the database (even if it doesn't need to import anything). This is preparation for an
        upcoming patch where the database will be closed when it's cleared.

        * UIProcess/Storage/StorageManager.cpp:
        (StorageManager::StorageArea):
        (WebKit::StorageManager::StorageArea::StorageArea):
        (WebKit::StorageManager::StorageArea::setItem):
        (WebKit::StorageManager::StorageArea::removeItem):
        (WebKit::StorageManager::StorageArea::clear):
        (WebKit::StorageManager::StorageArea::items):
        (WebKit::StorageManager::StorageArea::openDatabaseAndImportItemsIfNeeded):

2013-05-17  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13869765> Lion: Crashes in islcCanLoadInputMethodFromBundleID.

        Reviewed by Anders Carlsson.

        * WebProcess/com.apple.WebProcess.sb.in: Allow text input directories.

2013-05-17  Anders Carlsson  <andersca@apple.com>

        WKKeyValueStorageManagerGetKeyValueStorageOrigins should get origins from the UI process
        https://bugs.webkit.org/show_bug.cgi?id=116346
        <rdar://problem/13852829>

        Reviewed by Andreas Kling.

        * UIProcess/Storage/LocalStorageDatabaseTracker.cpp:
        (WebKit::LocalStorageDatabaseTracker::origins):
        New helper function to return all the tracked origins.

        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::StorageManager):
        Initialize the UTF-8 encoding.

        (WebKit::StorageManager::getOrigins):
        Call getOriginsInternal on our queue.

        (WebKit::callCallbackFunction):
        Helper function for calling the callback function.

        (WebKit::StorageManager::getOriginsInternal):
        Get the origins and make sure we call the callback with the given function dispatcher.

        * UIProcess/WebKeyValueStorageManagerProxy.cpp:
        (WebKit::didGetKeyValueStorageOriginsCallback):
        Construct the array of WebSecurityOrigin objects and call the callback.

        (WebKit::WebKeyValueStorageManagerProxy::getKeyValueStorageOrigins):
        Call StorageManager::getOrigins.

2013-05-16  Alexey Proskuryakov  <ap@apple.com>

        Text input is largely broken when there are subframes loading
        http://bugs.webkit.org/show_bug.cgi?id=59121
        <rdar://problem/9320468>

        Reviewed by Darin Adler.

        * UIProcess/PageClient.h:
        * UIProcess/API/mac/PageClientImpl.h:
        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::updateSecureInputState): Separated secure input state
        updating into a separate function. Removed updateTextInputState, we don't need
        to go through PageClient to implement its behavior at all.
        (WebKit::PageClientImpl::dismissDictionaryLookupPanel): Added a FIXME.

        * UIProcess/API/mac/WKView.mm:
        * UIProcess/API/mac/WKViewInternal.h:
        Removed _updateTextInputStateIncludingSecureInputState.

        * UIProcess/WebPageProxy.h: Added m_temporarilyClosedComposition, which helps
        to figure out that WebCore decided to close a composition. The issue is that WebCore
        would first send an EditorState with hasComposition set to false, and with
        shouldIgnoreCompositionSelectionChange set to true, at which time we forget the
        previous m_editorState, but can't make any decisions based on this transient state.
        We should find a way to simplify this (maybe not send these updates with
        shouldIgnoreCompositionSelectionChange at all?)

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::WebPageProxy): Initialize m_temporarilyClosedComposition.
        (WebKit::WebPageProxy::didCommitLoadForFrame): Removed the code to kill a composition
        when any frame commits a load, which made no sense (along with surrounding code,
        which will unfortunately survive longer).
        (WebKit::WebPageProxy::editorStateChanged): Implemented state updating here,
        we don't need to go to WKView.mm to implement this logic. Figure out when WebCore
        discards a composition, and notify input methods about this.
        (WebKit::WebPageProxy::resetStateAfterProcessExited): Reset m_temporarilyClosedComposition.
        Added some FIXMEs.

2013-05-17  Manuel Rego Casasnovas  <rego@igalia.com>

        [WK2] Add support for selectTrailingWhitespaceEnabled setting
        https://bugs.webkit.org/show_bug.cgi?id=112426

        Reviewed by Ryosuke Niwa.

        * Shared/WebPreferencesStore.h:
        (WebKit): Add macro for selectTrailingWhitespaceEnabled.
        * UIProcess/API/C/WKPreferences.cpp:
        (WKPreferencesSetSelectTrailingWhitespaceEnabled):
        (WKPreferencesGetSelectTrailingWhitespaceEnabled): Implement methods
        using the new setting.
        * UIProcess/API/C/WKPreferencesPrivate.h: Add new methods headers.
        * WebProcess/WebCoreSupport/WebEditorClient.cpp:
        (WebKit::WebEditorClient::isSelectTrailingWhitespaceEnabled): Implement
        method delegating in WebPage.
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::updatePreferences): Set
        selectTrailingWhitespaceEnabled setting.
        (WebKit::WebPage::setSmartInsertDeleteEnabled): Set
        selectTrailingWhitespaceEnabled as they are mutually exclusive.
        (WebKit):
        (WebKit::WebPage::isSelectTrailingWhitespaceEnabled): Implement method
        using settings.
        (WebKit::WebPage::setSelectTrailingWhitespaceEnabled): Implement method
        using settings and set smartInsertDeleteEnabled as they are mutually
        exclusive.
        * WebProcess/WebPage/WebPage.h:
        (WebPage): Add new methods headers.

2013-05-17  Brady Eidson  <beidson@apple.com>

        Fix crash introduced by http://trac.webkit.org/changeset/150282
        Followup to https://bugs.webkit.org/show_bug.cgi?id=116253

        Reviewed by Andreas Kling.

        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::focusedFrameChanged): Frame might be null.

2013-05-17  Brady Eidson  <beidson@apple.com>

        Replace WebFrameLoaderClient static_casts with a function that might return null.
        https://bugs.webkit.org/show_bug.cgi?id=116253

        The general approach here is:
        1 - Introduce a toWebFrameLoaderClient() function to convert FrameLoaderClients, and that may return null.
        2 - Adopt toWebFrameLoaderClient() everywhere we used to do a direct static_cast<WebFrameLoaderClient*>
        3 - In functions that already support a "return 0" scenario, a failed cast results in a return 0.
        4 - In other functions that assume no failure to get the WebFrameLoaderClient, add an ASSERT.

        Reviewed by Alexey Proskuryakov.

        Add the utility function to cast:
        * WebProcess/WebCoreSupport/WebFrameLoaderClient.h:
        (WebKit::toWebFrameLoaderClient):

        Adopt it everywhere:
        * WebProcess/Geolocation/GeolocationPermissionRequestManager.cpp:
        (WebKit::GeolocationPermissionRequestManager::startRequestForGeolocation):

        * WebProcess/InjectedBundle/DOM/InjectedBundleNodeHandle.cpp:
        (WebKit::InjectedBundleNodeHandle::documentFrame):
        (WebKit::InjectedBundleNodeHandle::htmlFrameElementContentFrame):
        (WebKit::InjectedBundleNodeHandle::htmlIFrameElementContentFrame):

        * WebProcess/InjectedBundle/InjectedBundle.cpp:
        (WebKit::InjectedBundle::overrideBoolPreferenceForTestRunner):

        * WebProcess/InjectedBundle/InjectedBundleDOMWindowExtension.cpp:
        (WebKit::InjectedBundleDOMWindowExtension::frame):

        * WebProcess/InjectedBundle/InjectedBundleHitTestResult.cpp:
        (WebKit::InjectedBundleHitTestResult::frame):
        (WebKit::InjectedBundleHitTestResult::targetFrame):

        * WebProcess/Network/WebResourceLoadScheduler.cpp:
        (WebKit::WebResourceLoadScheduler::scheduleLoad):

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::webPage):
        (WebKit::PluginView::performFrameLoadURLRequest):

        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::focusedNodeChanged):
        (WebKit::WebChromeClient::focusedFrameChanged):
        (WebKit::WebChromeClient::runBeforeUnloadConfirmPanel):
        (WebKit::WebChromeClient::runJavaScriptAlert):
        (WebKit::WebChromeClient::runJavaScriptConfirm):
        (WebKit::WebChromeClient::runJavaScriptPrompt):
        (WebKit::WebChromeClient::print):
        (WebKit::WebChromeClient::exceededDatabaseQuota):
        (WebKit::WebChromeClient::runOpenPanel):

        * WebProcess/WebCoreSupport/WebEditorClient.cpp:
        (WebKit::WebEditorClient::textFieldDidBeginEditing):
        (WebKit::WebEditorClient::textFieldDidEndEditing):
        (WebKit::WebEditorClient::textDidChangeInTextField):
        (WebKit::WebEditorClient::textDidChangeInTextArea):
        (WebKit::WebEditorClient::doTextFieldCommandFromEvent):
        (WebKit::WebEditorClient::textWillBeDeletedInTextField):

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::dispatchWillSendSubmitEvent):
        (WebKit::WebFrameLoaderClient::dispatchWillSubmitForm):

        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::contentsAsString):
        (WebKit::WebFrame::parentFrame):
        (WebKit::WebFrame::childFrames):
        (WebKit::WebFrame::frameForContext):
        (WebKit::WebFrameFilter::shouldIncludeSubframe):

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::mainFrameHasCustomRepresentation):

2013-05-17  Sam Weinig  <sam@webkit.org>

        Expose new load-with-userData API to Objective-C
        https://bugs.webkit.org/show_bug.cgi?id=116335

        Reviewed by Anders Carlsson.

        - Adds loadRequest:userData:, loadFileURL:restrictToFilesWithin:userData:, loadHTMLString:baseURL:userData:
          loadData:MIMEType:textEncodingName:baseURL:, and loadData:MIMEType:textEncodingName:baseURL:userData.
        - Adds a WKObjCTypeWrapperRef (which is a ObjCObjectGraph under the covers) to allow the userData to be unwrapped
          in the injected bundles willLoadURLRequest and willLoadDataRequest C-SPI callbacks.

        * Shared/API/c/WKBase.h:
        * Shared/API/c/WKSharedAPICast.h:
        * Shared/API/c/mac/WKBaseMac.h: Added.
        * Shared/API/c/mac/WKObjCTypeWrapperRef.h: Added.
        * Shared/API/c/mac/WKObjCTypeWrapperRef.mm: Added.
        (WKObjCTypeWrapperGetTypeID):
        (WKObjCTypeWrapperCreate):
        (WKObjCTypeWrapperGetObject):
        * UIProcess/API/mac/WKBrowsingContextController.h:
        * UIProcess/API/mac/WKBrowsingContextController.mm:
        (+[WKBrowsingContextController registerSchemeForCustomProtocol:]):
        (+[WKBrowsingContextController unregisterSchemeForCustomProtocol:]):
        (-[WKBrowsingContextController loadRequest:]):
        (-[WKBrowsingContextController loadRequest:userData:]):
        (-[WKBrowsingContextController loadFileURL:restrictToFilesWithin:]):
        (-[WKBrowsingContextController loadFileURL:restrictToFilesWithin:userData:]):
        (-[WKBrowsingContextController loadHTMLString:baseURL:]):
        (-[WKBrowsingContextController loadHTMLString:baseURL:userData:]):
        (-[WKBrowsingContextController loadData:MIMEType:textEncodingName:baseURL:]):
        (-[WKBrowsingContextController loadData:MIMEType:textEncodingName:baseURL:userData:]):
        * WebKit2.xcodeproj/project.pbxproj:

2013-05-17  Sam Weinig  <sam@webkit.org>

        Add WKPageLoadData and WKPageLoadDataWithUserData SPI to support loading arbitrary data blobs
        https://bugs.webkit.org/show_bug.cgi?id=116325

        Reviewed by Simon Fraser.

        * UIProcess/API/C/WKPage.cpp:
        (WKPageLoadData):
        (WKPageLoadDataWithUserData):
        Add new SPI.

        * UIProcess/API/C/WKPage.h:
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::loadData):
        * UIProcess/WebPageProxy.h:
        Pipe through to the WebProcess.

        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/WebPage.messages.in:
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::loadDataImpl):
        (WebKit::WebPage::loadData):
        (WebKit::WebPage::loadHTMLString):
        (WebKit::WebPage::loadAlternateHTMLString):
        (WebKit::WebPage::loadPlainTextString):
        (WebKit::WebPage::loadWebArchiveData):
        Rename existing loadData function to loadDataImpl (I hate it) to avoid overload conflict
        from IPC magic.


2013-05-17  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [EFL][WK2] Fix sub menu initialization in ewk_context_menu_item
        https://bugs.webkit.org/show_bug.cgi?id=116321

        Reviewed by Christophe Dumez.

        During sub menu creation, after initializing m_parentMenu, parentMenu
        pointer became null which may cause segfaults. This patch fixes it by
        using m_parentMenu.

        * UIProcess/API/efl/ewk_context_menu_item.cpp:
        (EwkContextMenuItem::EwkContextMenuItem):

2013-05-17  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [EFL][WK2] Support sub menu in ewk context menus
        https://bugs.webkit.org/show_bug.cgi?id=114729

        Reviewed by Christophe Dumez.

        Added submenu support in EwkContextMenu and an API function to receive
        Ewk_Context_Menu from submenu context menu item. A test case was added
        for new API function.
        EwkContextMenu is now an EwkObject allowing multiple instances of submenu
        to be used in different submenu type context menu items.

        * UIProcess/API/efl/ewk_context_menu_item.cpp:
        (EwkContextMenuItem::EwkContextMenuItem):
        (ewk_context_menu_item_new):
        (ewk_context_menu_item_parent_menu_get):
        (ewk_context_menu_item_submenu_get):
        * UIProcess/API/efl/ewk_context_menu_item.h:
        * UIProcess/API/efl/ewk_context_menu_item_private.h:
        (EwkContextMenuItem::create):
        (EwkContextMenuItem::parentMenu):
        (EwkContextMenuItem::subMenu):
        (EwkContextMenuItem):
        * UIProcess/API/efl/ewk_context_menu_private.h:
        (EwkContextMenu::ewkView):
        (EwkContextMenu):
        * UIProcess/API/efl/tests/test_ewk2_context_menu.cpp:
        (showContextMenu):

2013-05-17  Zoltan Arvai  <zarvai@inf.u-szeged.hu>, Ádám Kallai  <kadam@inf.u-szeged.hu>

        [Qt] Unreviewed build fix.

        Add missing Qt specific initializer for willLoadURLRequest and willLoadDataRequest.

        * WebProcess/qt/QtBuiltinBundlePage.cpp:
        (WebKit::QtBuiltinBundlePage::QtBuiltinBundlePage):

2013-05-16  Beth Dakin  <bdakin@apple.com>

        Remove WKBundlePageGetHeaderLayer/Footer SPI
        https://bugs.webkit.org/show_bug.cgi?id=116254

        Reviewed by Benjamin Poulain.

        We should remove the Remove WKBundlePageGetHeaderLayer/Footer SPI. It was only 
        recently added and have been replaced by WKBundlePageSetHeaderBanner/Footer.

        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/InjectedBundle/API/c/mac/WKBundlePagePrivateMac.h: Removed.
        * WebProcess/InjectedBundle/API/c/mac/WKBundlePagePrivateMac.mm: Removed.
        * WebProcess/WebPage/WebPage.h:
        (WebPage):
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit):
        (WebKit::WebPage::updateHeaderAndFooterLayersForDeviceScaleChange):

2013-05-14  Sam Weinig  <sam@webkit.org>

        Add variants of the loading APIs that take user data and a way for the injected bundle to find out about them
        https://bugs.webkit.org/show_bug.cgi?id=116132

        Reviewed by Anders Carlsson.

        Adds "WithUserData" versions of all the load APIs and two new WKBundlePageLoaderClient functions,
        willLoadURLRequest and willLoadDataRequest to let the bundle access them.

        Adds WebKit2WillLoadTest.* API tests.

        * UIProcess/API/C/WKPage.cpp:
        (WKPageLoadURLWithUserData):
        (WKPageLoadURLRequestWithUserData):
        (WKPageLoadFile):
        (WKPageLoadFileWithUserData):
        (WKPageLoadHTMLStringWithUserData):
        (WKPageLoadAlternateHTMLStringWithUserData):
        (WKPageLoadPlainTextStringWithUserData):
        (WKPageLoadWebArchiveDataWithUserData):
        * UIProcess/API/C/WKPage.h:
        * UIProcess/WebPageProxy.cpp:
        * UIProcess/WebPageProxy.h:
        (WebPageProxy):
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/InjectedBundle/API/c/WKBundlePage.h:
        * WebProcess/InjectedBundle/InjectedBundlePageLoaderClient.cpp:
        (WebKit::InjectedBundlePageLoaderClient::willLoadURLRequest):
        (WebKit::InjectedBundlePageLoaderClient::willLoadDataRequest):
        * WebProcess/InjectedBundle/InjectedBundlePageLoaderClient.h:
        (WebCore):
        (InjectedBundlePageLoaderClient):
        * WebProcess/WebPage/WebPage.cpp:
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/WebPage.messages.in:

2013-05-16  Manuel Rego Casasnovas  <rego@igalia.com>

        [GTK] Fix memory leak in WebKitBackForwardList
        https://bugs.webkit.org/show_bug.cgi?id=116222

        Reviewed by Carlos Garcia Campos.

        Due to the use of leakRef() the ImmutableArray is not being released
        automatically. Adding a local variable in the methods to make sure that
        the ImmutableArray is freed.

        * UIProcess/API/gtk/WebKitBackForwardList.cpp:
        (webkit_back_forward_list_get_back_list_with_limit): Add local variable
        RefPtr and pass the ImmutableArray to
        WebKitBackForwardList::webkitBackForwardListCreateList() using
        RefPtr::get().
        (webkit_back_forward_list_get_forward_list_with_limit): Ditto.

2013-05-16  Commit Queue  <commit-queue@webkit.org>

        Unreviewed, rolling out r150034.
        http://trac.webkit.org/changeset/150034
        https://bugs.webkit.org/show_bug.cgi?id=116257

        This work around doesn't work due to another bug NSUndoManager
        has (Requested by rniwa on #webkit).

        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::registerEditCommand):

2013-05-16  Tim Horton  <timothy_horton@apple.com>

        PDFPlugins don't load when plugins are disabled, but they should
        https://bugs.webkit.org/show_bug.cgi?id=75790
        <rdar://problem/11650197>

        Reviewed by Anders Carlsson.

        Support loading "application" plug-ins even if plug-ins are explicitly disabled.

        Make PDFPlugin and SimplePDFPlugin "application" plug-ins, so they can
        be loaded even if plug-ins are disabled.

        * Platform/CoreIPC/HandleMessage.h:
        (CoreIPC::callMemberFunction):
        Add a 5-argument, 3-reply version of callMemberFunction.

        * Shared/Plugins/Netscape/mac/NetscapePluginModuleMac.mm:
        (WebKit::NetscapePluginModule::getPluginInfo):
        NPAPI plug-ins are not application plug-ins.

        * Shared/WebCoreArgumentCoders.cpp:
        (CoreIPC::::encode):
        (CoreIPC::::decode):
        Encode/decode the new isApplicationPlugin field on PluginInfo.

        * UIProcess/Plugins/PluginInfoStore.cpp:
        (WebKit::PluginInfoStore::findPluginForMIMEType):
        (WebKit::PluginInfoStore::findPluginForExtension):
        (WebKit::PluginInfoStore::findPlugin):
        * UIProcess/Plugins/PluginInfoStore.h:
        (PluginInfoStore):
        Give PluginInfoStore's findPlugin method and its private helper
        methods an argument allowing them to only match application plug-ins.

        (WebKit::WebPageProxy::findPlugin):
        * UIProcess/WebPageProxy.h:
        (WebPageProxy):
        * UIProcess/WebPageProxy.messages.in:
        Add an argument allowing findPlugin to restrict its search to only application plug-ins.

        * WebProcess/WebCoreSupport/WebFrameLoaderClient.cpp:
        (WebKit::WebFrameLoaderClient::objectContentType):
        Previously, this caller depended on pluginData() returning null if
        plug-ins were disabled. Since that is no longer the case, we have to
        check if we can use plug-ins, and otherwise ignore non-application-plug-ins.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::createPlugin):
        When going to search for a plug-in, ask subframeLoader whether or not
        it's OK to use ordinary non-application plug-ins, and pass that information
        on to the UIProcess when performing the search.

        (WebKit::WebPage::canPluginHandleResponse): Ditto.
        (WebKit::WebPage::canShowMIMEType):
        Ensure that canShowMIMEType returns true if we have an application plug-in
        that can display a particular MIME type, even if we're not allowed to load plug-ins.

2013-05-16  Michał Pakuła vel Rutka  <m.pakula@samsung.com>

        [EFL][WK2] Make Ewk_Context_Menu Ewk_Object
        https://bugs.webkit.org/show_bug.cgi?id=116097

        Reviewed by Gyuyoung Kim.

        Changed Ewk_Context_Menu to be an Ewk_Object so pointer to menu
        object can be shared between different modules.

        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::showContextMenu):
        * UIProcess/API/efl/EwkView.h:
        (EwkView):
        * UIProcess/API/efl/ewk_context_menu.cpp:
        (EwkContextMenu::appendItem):
        (EwkContextMenu::removeItem):
        (ewk_context_menu_new):
        (ewk_context_menu_new_with_items):
        (ewk_context_menu_item_append):
        (ewk_context_menu_item_remove):
        (ewk_context_menu_hide):
        (ewk_context_menu_items_get):
        (ewk_context_menu_item_select):
        * UIProcess/API/efl/ewk_context_menu_item.cpp:
        (EwkContextMenuItem::EwkContextMenuItem):
        (ewk_context_menu_item_new_with_submenu):
        * UIProcess/API/efl/ewk_context_menu_item_private.h:
        (EwkContextMenuItem):
        * UIProcess/API/efl/ewk_context_menu_private.h:
        (EwkContextMenu):
        (EwkContextMenu::create):
        * UIProcess/API/efl/ewk_defines.h:

2013-05-16  Andreas Kling  <akling@apple.com>

        Page::chrome() should return a reference.
        <http://webkit.org/b/116185>

        Reviewed by Anders Carlsson.

2013-05-16  Brady Eidson  <beidson@apple.com>

        svg/as-image/img-zoom-svg-stylesheet.html crashes with NetworkProcess enabled.
        <rdar://problem/13837408> and https://bugs.webkit.org/show_bug.cgi?id=115917

        Reviewed by Sam Weinig.

        * NetworkProcess/SchedulableLoader.cpp:
        (WebKit::SchedulableLoader::SchedulableLoader): ASSERT that either there’s a frame and page ID, or
          that the client cannot be asked for credentials.

        * WebProcess/Network/WebResourceLoadScheduler.cpp:
        (WebKit::WebResourceLoadScheduler::scheduleLoad): Only cast the FrameLoaderClient and get WebFrame/WebPage
          if that is actually possible. Set the clientCredentialPolicy based on whether or not WebFrame/WebPage are
          available since they are needed to ask the UIProcess for credentials. ASSERT that either there’s both
          a frame and page ID or that the client won’t be asked for credentials.

2013-05-16  Timothy Hatcher  <timothy@apple.com>

        Make the Find Banner in Safari work again with the docked Web Inspector.

        https://webkit.org/b/116182
        rdar://problem/13857423

        Reviewed by Benjamin Poulain.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::inspectedViewFrameDidChange):
        (WebKit::WebInspectorProxy::platformDetach):
        Preserve the top position of the inspected view so banners in Safari still work.

2013-05-16  Tim Horton  <timothy_horton@apple.com>

        [wk2] didGetImageForFindMatch can return a null image
        https://bugs.webkit.org/show_bug.cgi?id=116251
        <rdar://problem/13277246>

        Reviewed by Simon Fraser.

        Don't send didGetImageForFindMatch if we didn't get an image for
        the find match, which can happen if the selection is not visible.

        * WebProcess/WebPage/FindController.cpp:
        (WebKit::FindController::getImageForFindMatch):

2013-05-16  Tim Horton  <timothy_horton@apple.com>

        [wk2] Minimum layout width is lost if the WebProcess crashes
        https://bugs.webkit.org/show_bug.cgi?id=116202
        <rdar://problem/13202320>

        Reviewed by Darin Adler.

        Send the minimum layout width to the WebProcess upon initialization,
        so that crashed-and-restarted WebProcesses have the correct width.

        * Shared/WebPageCreationParameters.cpp:
        (WebKit::WebPageCreationParameters::encode):
        (WebKit::WebPageCreationParameters::decode):
        * Shared/WebPageCreationParameters.h:
        (WebPageCreationParameters):
        Add minimumLayoutWidth WebPage creation parameter.

        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::creationParameters):
        Send the current minimumLayoutWidth to the WebPage when it's created.

        (WebKit::WebPageProxy::setMinimumLayoutWidth):
        Store minimumLayoutWidth changes that come in while the WebProcess is
        not valid, so that the correct width is sent once it is restarted.

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::WebPage):
        Set minimumLayoutWidth to the value provided by our creation parameters.

2013-05-16  Zoltan Arvai  <zarvai@inf.u-szeged.hu>

        [Win] Unreviewed buildfix after r150161.

        'Unknown' in HTTPRequest.cpp is ambiguous symbol with MSVC,
        because it is also defined in MS SDK 7.1 winioctl.h.

        * UIProcess/InspectorServer/HTTPRequest.cpp:
        (WebKit::HTTPRequest::HTTPRequest):

2013-05-16  Andras Becsi  <andras.becsi@digia.com>

        [WK2] PluginInformation.cpp fails to build because of missing ENABLE(NETSCAPE_PLUGIN_API) guard
        https://bugs.webkit.org/show_bug.cgi?id=116018

        Rubber-stamped by Jocelyn Turcotte.

        * Shared/Plugins/Netscape/PluginInformation.cpp:
        (WebKit::getPluginModuleInformation):

2013-05-15  Simon Cooper  <scooper@apple.com>

        Enable printing in plugins
        https://bugs.webkit.org/show_bug.cgi?id=116201
        <rdar://problem/12347902>

        Reviewed by Alexey Proskuryakov.

        Add the printing entitlement so that legacy printing drivers can
        customize the print panel. Update the printing rules and enable them
        for the plugins.

        * Configurations/PluginService.entitlements:
        * Resources/PlugInSandboxProfiles/com.apple.WebKit.plugin-common.sb:
        * Resources/PlugInSandboxProfiles/com.macromedia.Flash Player.plugin.sb:
        * Resources/PlugInSandboxProfiles/com.microsoft.SilverlightPlugin.sb:
        * Resources/PlugInSandboxProfiles/com.oracle.java.JavaAppletPlugin.sb:

2013-05-15  Anders Carlsson  <andersca@apple.com>

        Move HTTPRequest class to WebKit2
        https://bugs.webkit.org/show_bug.cgi?id=116192

        Reviewed by Darin Adler.

        Move HTTPRequest to WebKit2 and put it in the WebKit namespace.

        * CMakeLists.txt:
        * GNUmakefile.list.am:
        * Target.pri:
        * UIProcess/InspectorServer/HTTPRequest.cpp: Renamed from Source/WebCore/platform/network/HTTPRequest.cpp.
        * UIProcess/InspectorServer/HTTPRequest.h: Renamed from Source/WebCore/platform/network/HTTPRequest.h.
        * UIProcess/InspectorServer/WebInspectorServer.cpp:
        * UIProcess/InspectorServer/WebInspectorServer.h:
        (WebInspectorServer):
        * UIProcess/InspectorServer/WebSocketServerClient.h:
        (WebKit::WebSocketServerClient::didReceiveUnrecognizedHTTPRequest):
        (WebKit::WebSocketServerClient::didReceiveWebSocketUpgradeHTTPRequest):
        (WebKit::WebSocketServerClient::didEstablishWebSocketConnection):
        * UIProcess/InspectorServer/WebSocketServerConnection.cpp:
        * UIProcess/InspectorServer/WebSocketServerConnection.h:
        (WebKit):
        (WebSocketServerConnection):

2013-05-15  Arnaud Renevier  <a.renevier@sisa.samsung.com>

        [GTK] [WebKit2] enable displaying console.log messages to system console
        https://bugs.webkit.org/show_bug.cgi?id=115578

        Reviewed by Martin Robinson.

        Add a setting to enable/disable displaying of page messages to system
        console. Property is called enable-write-console-messages-to-stdout.
        Getter API function is
        webkit_settings_get_enable_write_console_messages_to_stdout
        Setter API function is
        webkit_settings_set_enable_write_console_messages_to_stdout

        * UIProcess/API/gtk/WebKitSettings.cpp:
        (webKitSettingsSetProperty):
        (webKitSettingsGetProperty):
        (webkit_settings_class_init):
        (webkit_settings_get_enable_write_console_messages_to_stdout):
        (webkit_settings_set_enable_write_console_messages_to_stdout):
        * UIProcess/API/gtk/WebKitSettings.h:
        * UIProcess/API/gtk/docs/webkit2gtk-sections.txt:
        * UIProcess/API/gtk/tests/TestWebKitSettings.cpp:
        (testWebKitSettings):

2013-05-08  Gavin Barraclough  <barraclough@apple.com>

        Process suppression should throttle scripted animations
        https://bugs.webkit.org/show_bug.cgi?id=115812

        Reviewed by Simon Fraser.

        <rdar://problem/13799726>

        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::setThrottled):
        (WebKit):
        * WebProcess/WebPage/WebPage.h:
        (WebPage):
            - Added setThrottled, forwards to WebCore::Page.
        * WebProcess/WebProcess.cpp:
        (WebKit):
        (WebKit::WebProcess::setProcessSuppressionEnabled):
        * WebProcess/WebProcess.h:
        (WebProcess):
            - Intercept calls to setProcessSuppressionEnabled, also mark all pages as being throttled.

2013-05-15  Anders Carlsson  <andersca@apple.com>

        WKPageGetPluginInformationDisplayNameKey doesn't return the right key
        https://bugs.webkit.org/show_bug.cgi?id=116188

        Reviewed by Andreas Kling.

        * UIProcess/API/C/WKPage.cpp:
        (WKPageGetPluginInformationDisplayNameKey):

2013-05-15  Alexey Proskuryakov  <ap@apple.com>

        More fixing after WebProcessShim renaming in r149074.

        * WebProcess/EntryPoint/mac/XPCService/WebContentServiceEntryPoint.mm:
        (WebContentServiceInitializer): Updated a comment to mention the shim by its new name.

2013-05-15  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13902706> Lion: com.apple.tsm.uiserver sandbox error in Console when
        launching Safari

        Reviewed by Anders Carlsson.

        * WebProcess/com.apple.WebProcess.sb.in: Silence the violation.

2013-05-13  Anders Carlsson  <andersca@apple.com>

        Frame::editor() should return a reference
        https://bugs.webkit.org/show_bug.cgi?id=116037

        Reviewed by Darin Adler.

        * WebProcess/WebCoreSupport/WebContextMenuClient.cpp:
        (WebKit::WebContextMenuClient::searchWithGoogle):
        * WebProcess/WebCoreSupport/WebEditorClient.cpp:
        (WebKit::WebEditorClient::updateGlobalSelection):
        * WebProcess/WebCoreSupport/efl/WebEditorClientEfl.cpp:
        (WebKit::WebEditorClient::handleInputMethodKeydown):
        * WebProcess/WebCoreSupport/gtk/WebEditorClientGtk.cpp:
        (WebKit::WebEditorClient::executePendingEditorCommands):
        (WebKit::WebEditorClient::handleKeyboardEvent):
        * WebProcess/WebCoreSupport/mac/WebContextMenuClientMac.mm:
        (WebKit::WebContextMenuClient::searchWithGoogle):
        (WebKit::WebContextMenuClient::searchWithSpotlight):
        * WebProcess/WebCoreSupport/mac/WebEditorClientMac.mm:
        (WebKit::changeWordCase):
        * WebProcess/WebPage/WebFrame.cpp:
        (WebKit::WebFrame::selectionAsString):
        (WebKit::WebFrame::setTextDirection):
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::editorState):
        (WebKit::WebPage::executeEditingCommand):
        (WebKit::WebPage::isEditingCommandEnabled):
        (WebKit::WebPage::validateCommand):
        (WebKit::WebPage::handleEditingKeyboardEvent):
        (WebKit::WebPage::advanceToNextMisspelling):
        (WebKit::WebPage::uppercaseWord):
        (WebKit::WebPage::lowercaseWord):
        (WebKit::WebPage::capitalizeWord):
        (WebKit::WebPage::replaceSelectionWithText):
        (WebKit::WebPage::handleAlternativeTextUIResult):
        (WebKit::WebPage::setCompositionForTesting):
        (WebKit::WebPage::hasCompositionForTesting):
        (WebKit::WebPage::confirmCompositionForTesting):
        (WebKit::WebPage::setComposition):
        (WebKit::WebPage::cancelComposition):
        * WebProcess/WebPage/efl/WebPageEfl.cpp:
        (WebKit::WebPage::confirmComposition):
        (WebKit::WebPage::setComposition):
        (WebKit::WebPage::cancelComposition):
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::executeKeypressCommandsInternal):
        (WebKit::WebPage::handleEditingKeyboardEvent):
        (WebKit::WebPage::setComposition):
        (WebKit::WebPage::confirmComposition):
        (WebKit::WebPage::cancelComposition):
        (WebKit::WebPage::insertText):
        (WebKit::WebPage::insertDictatedText):
        (WebKit::WebPage::getMarkedRange):
        (WebKit::WebPage::firstRectForCharacterRange):
        (WebKit::WebPage::readSelectionFromPasteboard):
        (WebKit::WebPage::getStringSelectionForPasteboard):
        (WebKit::WebPage::getDataSelectionForPasteboard):

2013-05-15  Anders Carlsson  <andersca@apple.com>

        Need a way for NPAPI plug-ins to open preference panes
        https://bugs.webkit.org/show_bug.cgi?id=116173
        <rdar://problem/13503848>

        Reviewed by Sam Weinig.

        * PluginProcess/PluginControllerProxy.h:
        Add openPluginPreferencePane().

        * PluginProcess/mac/PluginControllerProxyMac.mm:
        (WebKit::PluginControllerProxy::openPluginPreferencePane):
        Send OpenPluginPreferencePane to the UI process.

        * Shared/Plugins/Netscape/mac/NetscapePluginModuleMac.mm:
        (WebKit::NetscapePluginModule::getPluginInfo):
        Get the preference pane path.
        
        * Shared/Plugins/PluginModuleInfo.h:
        Add preferencePanePath member variable.

        * UIProcess/Plugins/PluginProcessProxy.h:
        Add openPluginPreferencePane message handler.

        * UIProcess/Plugins/PluginProcessProxy.messages.in:
        ADd OpenPluginPreferencePane message.

        * UIProcess/Plugins/mac/PluginProcessProxyMac.mm:
        (WebKit::PluginProcessProxy::openPluginPreferencePane):
        Get the path to the preference pane and use LS to open it.

        * WebKit2.xcodeproj/project.pbxproj:
        Add new files.

        * WebProcess/Plugins/Netscape/NetscapeBrowserFuncs.cpp:
        (WebKit::NPN_GetValue):
        Handle WKNVPlugInContainer.

        * WebProcess/Plugins/Netscape/NetscapePlugin.h:
        Add WKNVPlugInContainer member variable.

        * WebProcess/Plugins/Netscape/mac/NetscapePluginMac.mm:
        (WebKit::NetscapePlugin::openPluginPreferencePane):
        Call through to the plug-in controller.

        (WebKit::NetscapePlugin::plugInContainer):
        Create a WKNPAPIPlugInContainer object if necessary.

        (WebKit::NetscapePlugin::platformDestroy):
        Invalidate the WKNPAPIPlugInContainer object.

        * WebProcess/Plugins/Netscape/mac/WKNPAPIPlugInContainer.h:
        New file with the protocol definition.

        * WebProcess/Plugins/Netscape/mac/WKNPAPIPlugInContainer.mm:
        (-[WKNPAPIPlugInContainer dealloc]):
        Assert that the plug-in is null (that we've been invalidated).

        (-[WKNPAPIPlugInContainer _invalidate]):
        Set the plug-in to null.

        (-[WKNPAPIPlugInContainer openPlugInPreferencePane]):
        Call through to the plug-in.

        * WebProcess/Plugins/Netscape/mac/WKNPAPIPlugInContainerInternal.h:
        New file with the interface declaration for the object that implements the protocol.

        * WebProcess/Plugins/PluginController.h:
        Add openPluginPreferencePane member function.

        * WebProcess/Plugins/PluginView.cpp:
        (WebKit::PluginView::openPluginPreferencePane):
        Add stub; this should never be called since we always go through the UI process.

2013-05-15  Alexey Proskuryakov  <ap@apple.com>

        [WK2][Mac] Split resetTextInputState into two functions
        https://bugs.webkit.org/show_bug.cgi?id=116174

        Reviewed by Anders Carlsson.

        Splitting resetTextInputState into resetSecureInputState and
        notifyInputContextAboutDiscardedComposition, paving the way for a fix where these
        won't be happening simultaneously.

        * UIProcess/API/mac/PageClientImpl.h:
        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::resetSecureInputState):
        (WebKit::PageClientImpl::notifyInputContextAboutDiscardedComposition):
        * UIProcess/API/mac/WKView.mm:
        (-[WKView resignFirstResponder]):
        (-[WKView _resetSecureInputState]):
        (-[WKView _notifyInputContextAboutDiscardedComposition]):
        * UIProcess/API/mac/WKViewInternal.h:
        * UIProcess/PageClient.h:
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::didCommitLoadForFrame):

2013-05-15  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Add padding to all public class structs for future expansion without breaking ABI
        https://bugs.webkit.org/show_bug.cgi?id=112565

        Reviewed by Anders Carlsson.

        Use 4 pointers for most of the classes that are unlikely to grow
        and 8 for WebKitWebView and WebKitWebContext.

        * UIProcess/API/gtk/WebKitBackForwardList.h:
        (_WebKitBackForwardListClass):
        * UIProcess/API/gtk/WebKitBackForwardListItem.h:
        (_WebKitBackForwardListItemClass):
        * UIProcess/API/gtk/WebKitContextMenu.h:
        (_WebKitContextMenuClass):
        * UIProcess/API/gtk/WebKitContextMenuItem.h:
        (_WebKitContextMenuItemClass):
        * UIProcess/API/gtk/WebKitCookieManager.h:
        (_WebKitCookieManagerClass):
        * UIProcess/API/gtk/WebKitDownload.h:
        (_WebKitDownloadClass):
        * UIProcess/API/gtk/WebKitFaviconDatabase.h:
        (_WebKitFaviconDatabaseClass):
        * UIProcess/API/gtk/WebKitFileChooserRequest.h:
        (_WebKitFileChooserRequestClass):
        * UIProcess/API/gtk/WebKitFindController.h:
        (_WebKitFindControllerClass):
        * UIProcess/API/gtk/WebKitFormSubmissionRequest.h:
        (_WebKitFormSubmissionRequestClass):
        * UIProcess/API/gtk/WebKitGeolocationPermissionRequest.h:
        (_WebKitGeolocationPermissionRequestClass):
        * UIProcess/API/gtk/WebKitHitTestResult.h:
        (_WebKitHitTestResultClass):
        * UIProcess/API/gtk/WebKitNavigationPolicyDecision.h:
        (_WebKitNavigationPolicyDecisionClass):
        * UIProcess/API/gtk/WebKitPlugin.h:
        (_WebKitPluginClass):
        * UIProcess/API/gtk/WebKitPolicyDecision.h:
        (_WebKitPolicyDecisionClass):
        * UIProcess/API/gtk/WebKitPrintOperation.h:
        (_WebKitPrintOperationClass):
        * UIProcess/API/gtk/WebKitResponsePolicyDecision.h:
        (_WebKitResponsePolicyDecisionClass):
        * UIProcess/API/gtk/WebKitSecurityManager.h:
        (_WebKitSecurityManagerClass):
        * UIProcess/API/gtk/WebKitSettings.h:
        (_WebKitSettingsClass):
        * UIProcess/API/gtk/WebKitURIRequest.h:
        (_WebKitURIRequestClass):
        * UIProcess/API/gtk/WebKitURIResponse.h:
        (_WebKitURIResponseClass):
        * UIProcess/API/gtk/WebKitURISchemeRequest.h:
        (_WebKitURISchemeRequestClass):
        * UIProcess/API/gtk/WebKitWebContext.h:
        (_WebKitWebContextClass):
        * UIProcess/API/gtk/WebKitWebInspector.h:
        (_WebKitWebInspectorClass):
        * UIProcess/API/gtk/WebKitWebResource.h:
        (_WebKitWebResourceClass):
        * UIProcess/API/gtk/WebKitWebView.h:
        (_WebKitWebViewClass):
        * UIProcess/API/gtk/WebKitWebViewBase.h:
        (_WebKitWebViewBaseClass):
        * UIProcess/API/gtk/WebKitWebViewGroup.h:
        (_WebKitWebViewGroupClass):
        * UIProcess/API/gtk/WebKitWindowProperties.h:
        (_WebKitWindowPropertiesClass):

2013-05-14  Carlos Garcia Campos  <cgarcia@igalia.com>

        Remove WTF_USE_PLATFORM_STRATEGIES
        https://bugs.webkit.org/show_bug.cgi?id=114431

        Reviewed by Darin Adler.

        * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
        * WebProcess/WebCoreSupport/WebPlatformStrategies.h:
        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::WebProcess):

2013-05-14  Simon Cooper  <scooper@apple.com>

        Add a preference that can disable the fake SYSV SHM shim
        https://bugs.webkit.org/show_bug.cgi?id=116127
        <rdar://problem/13810524>

        Reviewed by Alexey Proskuryakov.

        * PluginProcess/mac/PluginProcessShim.mm:
        (WebKit::shim_disabled):
        (WebKit::shim_shmdt):
        (WebKit::shim_shmat):
        (WebKit::shim_shmget):
        (WebKit::shim_shmctl):

2013-05-14  Tim Horton  <timothy_horton@apple.com>

        [wk2] Not updating tiled backing coverage when main frame scrollability changes
        https://bugs.webkit.org/show_bug.cgi?id=116123
        <rdar://problem/13836559>

        Reviewed by Simon Fraser.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.h:
        (TiledCoreAnimationDrawingArea):
        Add updateMainFrameClipsToExposedRect.

        * WebProcess/WebPage/mac/TiledCoreAnimationDrawingArea.mm:
        (WebKit::TiledCoreAnimationDrawingArea::TiledCoreAnimationDrawingArea):
        (WebKit::TiledCoreAnimationDrawingArea::flushLayers):
        Remove m_clipsToExposedRect. We don't actually need it.

        (WebKit::TiledCoreAnimationDrawingArea::mainFrameScrollabilityChanged):
        Call updateMainFrameClipsToExposedRect so that we can always update
        tiled backing coverage and can factor out our calls to setClipsToExposedRect.

        (WebKit::TiledCoreAnimationDrawingArea::updateMainFrameClipsToExposedRect):
        Factor out setClipsToExposedRect calls to here, and also call
        FrameView::adjustTiledBackingCoverage so that the FrameView's tiled
        backing is informed to allow overdraw in the UI-process-scrolling case.

        (WebKit::TiledCoreAnimationDrawingArea::setRootCompositingLayer):
        Use updateMainFrameClipsToExposedRect.

2013-05-14  Alexey Proskuryakov  <ap@apple.com>

        [Mac] Add a testing shim for secure event input functions
        https://bugs.webkit.org/show_bug.cgi?id=116122

        Reviewed by Mark Rowe.

        Moved DyldInterpose.h to WebCore, as we now use it there too.

        * PluginProcess/mac/PluginProcessShim.mm:
        * Shared/mac/CookieStorageShimLibrary.cpp:
        * Shared/mac/DyldInterpose.h: Removed.
        * WebKit2.xcodeproj/project.pbxproj:
        * WebProcess/mac/SecItemShimLibrary.mm:

2013-05-14  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        [Win] REGRESSION(r149944): mmap is not available on Windows
        https://bugs.webkit.org/show_bug.cgi?id=116015

        Reviewed by Anders Carlsson.

        Use fastAlloc/fastFree for platforms other than OS(DARWIN) where
        using mmap is not necessary and maybe not available.

        * Platform/CoreIPC/ArgumentEncoder.cpp:
        (CoreIPC::allocBuffer):
        (CoreIPC::freeBuffer):
        (CoreIPC::ArgumentEncoder::~ArgumentEncoder):
        (CoreIPC::ArgumentEncoder::grow):

2013-05-14  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Move generated ColorData.cpp, WebKitFontFamilyNames.(cpp|h) build targets into libPlatform
        https://bugs.webkit.org/show_bug.cgi?id=115921

        Reviewed by Gustavo Noronha Silva.

        * GNUmakefile.am: Add platform_cppflags to the list of libwebkit2gtk CPPFLAGS.

2013-05-14  Jocelyn Turcotte  <jocelyn.turcotte@digia.com>

        [WK2][Win] Fix ASSERT(DeleteTimerQueueTimer...)
        https://bugs.webkit.org/show_bug.cgi?id=116039

        Reviewed by Benjamin Poulain.

        According to the documentation, DeleteTimerQueueTimer can be expected to return
        false with an ERROR_IO_PENDING error when called from the timer's callback.

        * Platform/win/WorkQueueWin.cpp:
        (WorkQueue::timerCallback):

2013-05-14  Alexey Proskuryakov  <ap@apple.com>

        Remove unused "type" field from DictionaryPopupInfo
        https://bugs.webkit.org/show_bug.cgi?id=116011

        Reviewed by Darin Adler.

        It is unused, and furthermore, PDFPlugin sets it incorrectly anyway.

        * Shared/DictionaryPopupInfo.cpp:
        (WebKit::DictionaryPopupInfo::encode):
        (WebKit::DictionaryPopupInfo::decode):
        * Shared/DictionaryPopupInfo.h:
        * WebProcess/Plugins/PDF/PDFPlugin.mm:
        (WebKit::PDFPlugin::showDefinitionForAttributedString):
        * WebProcess/WebCoreSupport/mac/WebContextMenuClientMac.mm:
        (WebKit::WebContextMenuClient::lookUpInDictionary):
        * WebProcess/WebPage/WebPage.h:
        * WebProcess/WebPage/mac/WebPageMac.mm:
        (WebKit::WebPage::performDictionaryLookupAtLocation):
        (WebKit::WebPage::performDictionaryLookupForSelection):
        (WebKit::WebPage::performDictionaryLookupForRange):

2013-05-14  Michael Brüning  <michael.bruning@digia.com>

        [WK2] Make WebPageProxy use deviceScaleFactor() in creationParameters().
        https://bugs.webkit.org/show_bug.cgi?id=110218

        Reviewed by Darin Adler.

        Make the WebPageProxy::creationParameters use the accessor
        deviceScaleFactor() instead of using m_intrinsicDeviceScaleFactor
        directly. This will restore the custom device scale factor when
        reattaching to the WebProcess after a crash.

        Moreover, it will enable the Qt and ELF ports to use the
        existing C API for overriding the device scale factor instead
        of using the WebPageProxy directly or adding new C API to set
        the intrinsic device scale factor.

        * UIProcess/API/efl/EwkView.cpp:
        (EwkView::setDeviceScaleFactor):
        * UIProcess/API/qt/qquickwebpage.cpp:
        (QQuickWebPage::updatePaintNode):
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::creationParameters):

2013-05-13  Alex Christensen  <achristensen@apple.com>

        Added testRunner.setPrinting.
        https://bugs.webkit.org/show_bug.cgi?id=42693
        rdar://problem/8213845

        Reviewed by Darin Adler.

        * WebProcess/InjectedBundle/API/c/WKBundlePage.cpp:
        (WKBundlePageCopyRenderTreeExternalRepresentationForPrinting): Added.
        * WebProcess/InjectedBundle/API/c/WKBundlePagePrivate.h:
        Added WKBundlePageCopyRenderTreeExternalRepresentationForPrinting declaration.
        * WebProcess/WebPage/WebPage.cpp:
        (WebKit::WebPage::renderTreeExternalRepresentationForPrinting): Added.
        * WebProcess/WebPage/WebPage.h:
        Added renderTreeExternalRepresentationForPrinting declaration.

2013-05-13  Timothy Hatcher  <timothy@apple.com>

        Add support for updating the Web Inspector toolbar height.

        https://bugs.webkit.org/show_bug.cgi?id=115996

        Reviewed by Joseph Pecoraro and Benjamin Poulain.

        * UIProcess/WebInspectorProxy.h:
        (WebKit::WebInspectorProxy::setToolbarHeight):
        (WebInspectorProxy):
        * UIProcess/WebInspectorProxy.messages.in:
        * UIProcess/efl/WebInspectorProxyEfl.cpp:
        (WebKit::WebInspectorProxy::platformSetToolbarHeight):
        * UIProcess/gtk/WebInspectorProxyGtk.cpp:
        (WebKit::WebInspectorProxy::platformSetToolbarHeight):
        (WebKit):
        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::platformSetToolbarHeight):
        * UIProcess/qt/WebInspectorProxyQt.cpp:
        (WebKit::WebInspectorProxy::platformSetToolbarHeight):
        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.cpp:
        (WebKit::WebInspectorFrontendClient::setToolbarHeight):
        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.h:
        (WebInspectorFrontendClient):
        * WebProcess/WebPage/WebInspector.cpp:
        (WebKit::WebInspector::setToolbarHeight):
        * WebProcess/WebPage/WebInspector.h:

2013-05-13  Ryosuke Niwa  <rniwa@webkit.org>

        Sometimes NSUndoManager can get into an inconsistent state
        https://bugs.webkit.org/show_bug.cgi?id=116050

        Reviewed by Enrica Casucci.

        Always group undo items to work around a bug in NSUndoManager that manifests
        when we call removeAllActionsWithTarget.

        * UIProcess/API/mac/PageClientImpl.mm:
        (WebKit::PageClientImpl::registerEditCommand):

2013-05-13  Anders Carlsson  <andersca@apple.com>

        [WK2] Crash in WebKit::StorageAreaMap::didSetItem()
        https://bugs.webkit.org/show_bug.cgi?id=116026

        Reviewed by Andreas Kling.

        Make sure that we ignore any leftover messages from the UI process after we've reset
        the storage map. Achieve this by keeping a seed count in the StorageAreaMap object that's incremented
        everytime the map is reset. Associate every storage area change with the seed and ignore any incoming 
        notification messages from the UI process if the seeds are different.

        * Platform/CoreIPC/HandleMessage.h:
        (CoreIPC):
        (CoreIPC::callMemberFunction):
        * UIProcess/Storage/StorageManager.cpp:
        (WebKit::StorageManager::getValues):
        (WebKit::StorageManager::setItem):
        (WebKit::StorageManager::removeItem):
        (WebKit::StorageManager::clear):
        * UIProcess/Storage/StorageManager.h:
        (StorageManager):
        * UIProcess/Storage/StorageManager.messages.in:
        * WebProcess/Storage/StorageAreaMap.cpp:
        (WebKit::StorageAreaMap::StorageAreaMap):
        (WebKit::StorageAreaMap::setItem):
        (WebKit::StorageAreaMap::removeItem):
        (WebKit::StorageAreaMap::clear):
        (WebKit::StorageAreaMap::resetValues):
        (WebKit::StorageAreaMap::loadValuesIfNeeded):
        (WebKit::StorageAreaMap::didGetValues):
        (WebKit::StorageAreaMap::didSetItem):
        (WebKit::StorageAreaMap::didRemoveItem):
        (WebKit::StorageAreaMap::didClear):
        (WebKit::StorageAreaMap::applyChange):
        * WebProcess/Storage/StorageAreaMap.h:
        (StorageAreaMap):
        * WebProcess/Storage/StorageAreaMap.messages.in:

2013-05-13  Jesus Sanchez-Palencia  <jesus.palencia@openbossa.org>

        [WK2][CoordinatedGraphics] Avoid dispensable calls to WebView::updateViewportSize()
        https://bugs.webkit.org/show_bug.cgi?id=116045

        Reviewed by Darin Adler.

        * UIProcess/CoordinatedGraphics/WebView.cpp:
        (WebKit::WebView::setSize):

2013-05-13  Jon Lee  <jonlee@apple.com>

        [WK2] Notification manager removal should not be tied to termination of web processes
        https://bugs.webkit.org/show_bug.cgi?id=116038
        <rdar://problem/10968680>

        Reviewed by Ryosuke Niwa.

        WebNotificationManagerProxy incorrectly removes the manager when web processes close.
        Since it is a supplemental on the web context, the manager should only be removed
        when the context is destroyed.

        * UIProcess/Notifications/WebNotificationManagerProxy.cpp:
        * UIProcess/Notifications/WebNotificationManagerProxy.h: Remove implementation of
        processDidClose().

2013-05-13  Martin Robinson  <mrobinson@igalia.com>

        [GTK] [WebKit2] Use a template file for generated GObject enum files
        https://bugs.webkit.org/show_bug.cgi?id=115867

        Reviewed by Carlos Garcia Campos.

        * GNUmakefile.am: Use a template file instead of specifying portions of the file on the command-line.
        * UIProcess/API/gtk/WebKitEnumTypes.cpp.template: Added.
        * UIProcess/API/gtk/WebKitEnumTypes.h.template: Added.
        * UIProcess/API/gtk/WebKitFindController.cpp: We can no longer rely on WebKitEnumTypes.h to pull in WebKitWebView.h.

2013-05-13  Noam Rosenthal  <noam@webkit.org>

        [CoordGfx] requestAnimationFrame performance issues
        https://bugs.webkit.org/show_bug.cgi?id=112345

        Reviewed by Jocelyn Turcotte.

        Changed the logic of requestAnimationFrame in Coordinated Graphics.
        We don't send any IPC messages for requestAnimationFrame. Instead, we do one of two things:
        - If there is already a frame pending in the UI process, do nothing, as the animations would
          be serviced when the frame is returned to the web process.
        - If there is no frame pending, we schedule a flush, making sure that that flush occurs at 
          least 1/60 seconds after the last animation service, so that we don't get an infinite loop
          of flushes.

        * UIProcess/CoordinatedGraphics/CoordinatedLayerTreeHostProxy.cpp:
        (WebKit::CoordinatedLayerTreeHostProxy::requestAnimationFrame):
        * UIProcess/CoordinatedGraphics/CoordinatedLayerTreeHostProxy.h:
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.cpp:
        (WebKit::CoordinatedLayerTreeHost::CoordinatedLayerTreeHost):
        (WebKit::CoordinatedLayerTreeHost::flushPendingLayerChanges):
        (WebKit::CoordinatedLayerTreeHost::scheduleAnimation):
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.h:
        * WebProcess/WebPage/CoordinatedGraphics/CoordinatedLayerTreeHost.messages.in:

2013-05-13  Jesus Sanchez-Palencia  <jesus.palencia@openbossa.org>

        [WK2][CoordinatedGraphics] WKView needs API for handling opacity
        https://bugs.webkit.org/show_bug.cgi?id=116032

        Reviewed by Kenneth Rohde Christiansen.

        Add WKViewSetOpacity and WKViewOpacity APIs and use them in
        WebView.cpp.

        * UIProcess/API/C/CoordinatedGraphics/WKView.cpp:
        (WKViewSetOpacity):
        (WKViewOpacity):
        * UIProcess/API/C/CoordinatedGraphics/WKView.h:
        * UIProcess/CoordinatedGraphics/WebView.cpp:
        (WebKit::WebView::WebView):
        (WebKit::WebView::paintToCurrentGLContext):
        * UIProcess/CoordinatedGraphics/WebView.h:
        (WebKit::WebView::setOpacity):
        (WebKit::WebView::opacity):
        (WebView):

2013-05-13  Zan Dobersek  <zdobersek@igalia.com>

        [GTK] Use WebCore layer archives for TestWebCore, WebKitPluginProcess
        https://bugs.webkit.org/show_bug.cgi?id=115918

        Reviewed by Gustavo Noronha Silva.

        Due to layer violations and circular dependencies the WebKitPluginProcess requires for the
        libraries containing the built code of the intertwining Platform and WebCore layers to be
        specified multiple times when linking. This can be avoided by packing the two layers' archives
        into one big archive, named after the WebCore layer due to no clear boundary between it and the
        Platform layer. The big archive can then be specified only once when linking, simplifying the code
        and suppressing all the layering violations so they do not cause build problems.

        First the libtool libraries that the WebCore layer (as required by the WebKitPluginProcess) depends on
        are specified. These are then used as dependencies for the archive creation rule as well as the list
        from which the archive file paths are constructed and then used to dump the member files from these archives.
        The member files are then added to the big archive. The latter is added to the list of libraries the
        WebKitPluginProcess requires to successfully link.

        * GNUmakefile.am:

2013-05-13  Zalan Bujtas  <zalan@apple.com>

        WebProcess consuming very high CPU on linkedin.com
        https://bugs.webkit.org/show_bug.cgi?id=115601

        Reviewed by Andreas Kling.

        Disable WEB_TIMING_MINIMAL.
        Turn off window.performance and performance.now(). Some JS frameworks expect
        additional Web Timing APIs, when performance.now() is available.

        * Configurations/FeatureDefines.xcconfig:

2013-05-12  Anders Carlsson  <andersca@apple.com>

        Stop including UnusedParam.h
        https://bugs.webkit.org/show_bug.cgi?id=116003

        Reviewed by Sam Weinig.

        UnusedParam.h is empty now so there's no need to include it anymore.

        * UIProcess/API/C/WKContext.cpp:
        * UIProcess/API/C/WKInspector.cpp:
        * UIProcess/API/C/WKPage.cpp:
        * UIProcess/API/efl/ewk_text_checker.cpp:
        * UIProcess/API/efl/ewk_view.cpp:
        * UIProcess/API/efl/tests/UnitTestUtils/EWK2UnitTestBase.cpp:
        * UIProcess/API/efl/tests/test_ewk2_view.cpp:
        * UIProcess/mac/WKFullScreenWindowController.mm:
        * WebProcess/InjectedBundle/API/c/WKBundlePage.cpp:
        * WebProcess/ResourceCache/WebResourceCacheManager.cpp:

2013-05-12  Andreas Kling  <akling@apple.com>

        Unload event listeners should prevent Safari from insta-killing the web process on last tab close.
        <http://webkit.org/b/115988>
        <rdar://problem/13870943>

        Reviewed by Anders Carlsson.

        Let WebCore control the UI process's suppression of the sudden termination mechanism.
        This is implemented by having WebChromeClient push Enable/DisableSuddenTermination messages
        over to the UI process where the appropriate NSProcessInfo calls are made.

        We also use this information when deciding whether to insta-kill a web process when its last
        page is closed. This mechanism is re-usable in WebCore to protect against sudden termination
        by the UI process.

        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::WebProcessProxy):
        (WebKit::WebProcessProxy::removeWebPage):
        (WebKit::WebProcessProxy::enableSuddenTermination):
        (WebKit::WebProcessProxy::disableSuddenTermination):
        * UIProcess/WebProcessProxy.h:
        (WebProcessProxy):
        * UIProcess/WebProcessProxy.messages.in:
        * WebProcess/WebCoreSupport/WebChromeClient.cpp:
        (WebKit::WebChromeClient::enableSuddenTermination):
        (WebKit::WebChromeClient::disableSuddenTermination):
        * WebProcess/WebCoreSupport/WebChromeClient.h:
        (WebChromeClient):

2013-05-12  Alexey Proskuryakov  <ap@apple.com>

        <rdar://problem/13402976> Sandbox violations in com.nvidia.OpenGL on Lion.

        Reviewed by Dan Bernstein.

        * WebProcess/com.apple.WebProcess.sb.in: Silence the violations (on Lion only).

2013-05-12  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Remove unnecessary GTK_CHECK_VERSION #ifdefs
        https://bugs.webkit.org/show_bug.cgi?id=115914

        Reviewed by Martin Robinson.

        * UIProcess/API/gtk/WebKitWebViewBase.cpp:
        (webkitWebViewBaseRealize):

2013-05-12  Raphael Kubo da Costa  <raphael.kubo.da.costa@intel.com>

        Unreviewed build fix after r149944.

        * Platform/CoreIPC/ArgumentEncoder.cpp: Include <sys/mman.h> for mmap(2).

2013-05-11  Anders Carlsson  <andersca@apple.com>

        Don't pass malloced pointers as out-of-line data when sending Mach messages
        https://bugs.webkit.org/show_bug.cgi?id=115970
        <rdar://problem/13144680>

        Reviewed by Sam Weinig.

        Give ArgumentEncoder an inline buffer of 512 bytes. If we need more than that, use mmap to allocate data
        since that gives us fresh zero-filled memory that we can safely share.

        * Platform/CoreIPC/ArgumentEncoder.cpp:
        (CoreIPC::ArgumentEncoder::ArgumentEncoder):
        Set up the buffer pointers to point to the inline buffer.

        (CoreIPC::ArgumentEncoder::~ArgumentEncoder):
        Unmap the buffer if necessary.

        (CoreIPC::ArgumentEncoder::grow):
        Grow the allocation exponentially, rounded up to the nearest page. This is a simplification from the
        current strategy, but most messages are either tiny in which case they will fit inside the inline buffer,
        or big in which case we'll end up doing less allocations + memory copying.

        * Platform/CoreIPC/ArgumentEncoder.h:
        (ArgumentEncoder):

2013-05-11  Zan Dobersek  <zdobersek@igalia.com>

        Unreviewed GTK build fix after r149904.

        * GNUmakefile.list.am: Adding missing build targets.

2013-05-11  Christophe Dumez  <ch.dumez@sisa.samsung.com>

        Unreviewed, Fix WK2 EFL build after r149904.

        Add new PluginInformation.cpp file to CMake.

        * CMakeLists.txt:

2013-05-11  Christophe Dumez  <ch.dumez@sisa.samsung.com>

        Unreviewed, fix WK2 EFL build after r149904.

        Add new WKPluginInformation.cpp file to CMake.

        * CMakeLists.txt:

2013-05-11  Andreas Kling  <akling@apple.com>

        When possible, terminate web processes immediately when closing their last page.
        <http://webkit.org/b/115964>
        <rdar://problem/13869266>

        Reviewed by Geoffrey Garen.

        When we're using a network process, there's no need for the UI process to wait for web processes
        to clear resource caches and terminate nicely.

        We can just kill them off right away in WebProcessProxy::removeWebPage() when the last page is closed.

        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::removeWebPage):

            Terminate the child process immediately if possible.

        * UIProcess/WebProcessProxy.h:
        (WebKit::WebProcessProxy::canTerminateChildProcess):
        (WebKit::WebProcessProxy::shouldTerminate):

            Broke out the logic from the shouldTerminate() IPC message handler into a separate function
            so we can call it from removeWebPage().

2013-05-11  Anders Carlsson  <andersca@apple.com>

        Crash when terminating a process that has not been fully launched
        https://bugs.webkit.org/show_bug.cgi?id=115962
        <rdar://problem/13660916>

        Reviewed by Andreas Kling.

        Handle terminating a process that has not been fully launched.

        * UIProcess/Launcher/ProcessLauncher.cpp:
        (WebKit::ProcessLauncher::didFinishLaunchingProcess):
        If we have been invalidated, dispose the connection identifier.

        * UIProcess/Launcher/mac/ProcessLauncherMac.mm:
        (WebKit::ProcessLauncher::terminateProcess):
        If we're still launching the process, invalidate so the client won't get an unexpected
        didFinishLaunching callback.

        * UIProcess/WebProcessProxy.cpp:
        (WebKit::WebProcessProxy::requestTermination):
        Check if webConnection() is null before calling it. (It will be null if the process isn't fully launched).

2013-05-10  Brian J. Burg  <burg@cs.washington.edu>

        Web Inspector: Implement WK2 version of WebInspectorFrontendClient::save
        https://bugs.webkit.org/show_bug.cgi?id=115564

        Reviewed by Benjamin Poulain.

        Implement InspectorFrontendHost's save() and append() methods for
        Mac WebKit2. Add canSave() for all ports.

        * UIProcess/WebInspectorProxy.cpp:
        (WebKit::WebInspectorProxy::save):
        (WebKit):
        (WebKit::WebInspectorProxy::append):
        * UIProcess/WebInspectorProxy.h:
        (WebInspectorProxy):
        * UIProcess/WebInspectorProxy.messages.in:
        * UIProcess/efl/WebInspectorProxyEfl.cpp:
        (WebKit::WebInspectorProxy::platformSave):
        (WebKit):
        (WebKit::WebInspectorProxy::platformAppend):
        * UIProcess/gtk/WebInspectorProxyGtk.cpp:
        (WebKit::WebInspectorProxy::platformSave):
        (WebKit):
        (WebKit::WebInspectorProxy::platformAppend):
        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::WebInspectorProxy::platformSave):
        (WebKit):
        (WebKit::WebInspectorProxy::platformAppend):
        * UIProcess/qt/WebInspectorProxyQt.cpp:
        (WebKit::WebInspectorProxy::platformSave):
        (WebKit):
        (WebKit::WebInspectorProxy::platformAppend):
        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.cpp:
        (WebKit::WebInspectorFrontendClient::canSave):
        (WebKit):
        (WebKit::WebInspectorFrontendClient::save):
        (WebKit::WebInspectorFrontendClient::append):
        * WebProcess/WebCoreSupport/WebInspectorFrontendClient.h:
        (WebInspectorFrontendClient):
        * WebProcess/WebPage/WebInspector.cpp:
        (WebKit::WebInspector::save):
        (WebKit):
        (WebKit::WebInspector::append):
        (WebKit::WebInspector::didSave):
        (WebKit::WebInspector::didAppend):
        * WebProcess/WebPage/WebInspector.h:
        (WebInspector):
        * WebProcess/WebPage/WebInspector.messages.in:
        * WebProcess/WebPage/efl/WebInspectorEfl.cpp:
        (WebKit::WebInspector::canSave):
        (WebKit):
        * WebProcess/WebPage/gtk/WebInspectorGtk.cpp:
        (WebKit::WebInspector::canSave):
        (WebKit):
        * WebProcess/WebPage/mac/WebInspectorMac.mm:
        (WebKit::WebInspector::canSave):
        (WebKit):
        * WebProcess/WebPage/qt/WebInspectorQt.cpp:
        (WebKit::WebInspector::canSave):
        (WebKit):

2013-05-10  Remy Demarest  <rdemarest@apple.com>

        Copy WKPluginInformation.h header to the WebKit2 Framework private headers.
        https://bugs.webkit.org/show_bug.cgi?id=115940

        Reviewed by Darin Adler.

        * WebKit2.xcodeproj/project.pbxproj:
        Move WKPluginInformation.h file from the framework's Project Headers to
        Private Headers.

2013-05-10  Zoltan Arvai  <zarvai@inf.u-szeged.hu>

        [Qt][Mac] Unreviewed. Roll out the fix attempt in r149912.

        * Target.pri:

2013-05-10  Simon Cooper  <scooper@apple.com>

        Fix AppleConnect issues for WiFi interfaces
        <rdar://problem/13776227&13776240&13776281>
        https://bugs.webkit.org/show_bug.cgi?id=115932

        Reviewed by Alexey Proskuryakov.

        Add support for WiFi interfaces for the AppleConnect plugin.
        Remove the FIXME.

        * Resources/PlugInSandboxProfiles/com.apple.ist.ds.appleconnect.webplugin.sb:

2013-05-10  Zoltan Arvai  <zarvai@inf.u-szeged.hu>

        [Qt][Mac] Unreviewed speculative build fix after r149904.

        * Target.pri:

2013-05-10  Zoltan Arvai  <zarvai@inf.u-szeged.hu>

        [Qt] Unreviewed buildfix after r149904.

        * Target.pri:

2013-05-09  Sam Weinig  <sam@webkit.org>

        Unify plug-in information dictionaries
        <rdar://problem/13852080>
        https://bugs.webkit.org/show_bug.cgi?id=115891

        Reviewed by Anders Carlsson.

        This unifies the plug-in information dictionaries vended by WKContextCopyPlugInInfoForBundleIdentifier
        and WKContextGetInfoForInstalledPlugIns with those from the WKPageLoaderClient and WKPageUIClient.

        All the old keys will continue to work, but have been deprecated in favor of new keys defined in 
        WKPluginInformation.h

        * Shared/API/c/WKPluginInformation.cpp: Added.
        * Shared/API/c/WKPluginInformation.h: Added.
        Export new keys as SPI.

        * Shared/Plugins/Netscape/PluginInformation.h: Added.
        * Shared/Plugins/Netscape/PluginInformation.cpp: Added.
        (WebKit::pluginInformationBundleIdentifierKey):
        (WebKit::pluginInformationBundleVersionKey):
        (WebKit::pluginInformationPathKey):
        (WebKit::pluginInformationDisplayNameKey):
        (WebKit::pluginInformationDefaultLoadPolicyKey):
        (WebKit::pluginInformationUpdatePastLastBlockedVersionIsKnownAvailableKey):
        (WebKit::pluginInformationHasSandboxProfileKey):
        (WebKit::pluginInformationFrameURLKey):
        (WebKit::pluginInformationMIMETypeKey):
        (WebKit::pluginInformationPageURLKey):
        (WebKit::pluginInformationPluginspageAttributeURLKey):
        (WebKit::pluginInformationPluginURLKey):
        Add new keys.

        (WebKit::pluginModuleInformation):
        (WebKit::createPluginInformationDictionary):
        Add creation functions to simplify multiple sites.

        * Shared/Plugins/Netscape/mac/PluginInformationMac.mm: Added.
        (WebKit::platformPluginModuleInformation):
        Add platform specific data to the dictionary.

        * UIProcess/API/C/WKPage.cpp:
        (WKPageGetPluginInformationBundleIdentifierKey):
        (WKPageGetPluginInformationBundleVersionKey):
        (WKPageGetPluginInformationDisplayNameKey):
        (WKPageGetPluginInformationFrameURLKey):
        (WKPageGetPluginInformationMIMETypeKey):
        (WKPageGetPluginInformationPageURLKey):
        (WKPageGetPluginInformationPluginspageAttributeURLKey):
        (WKPageGetPluginInformationPluginURLKey):
        * UIProcess/API/C/WKPage.h:
        Deprecate the old keys.

        * UIProcess/API/C/mac/WKContextPrivateMac.h:
        * UIProcess/API/C/mac/WKContextPrivateMac.mm:
        (WKContextCopyPlugInInfoForBundleIdentifier):
        (WKContextGetInfoForInstalledPlugIns):
        Simplify by using the new createPluginInformationDictionary functions.

        (WKPlugInInfoPathKey):
        (WKPlugInInfoBundleIdentifierKey):
        (WKPlugInInfoVersionKey):
        (WKPlugInInfoLoadPolicyKey):
        (WKPlugInInfoUpdatePastLastBlockedVersionIsKnownAvailableKey):
        (WKPlugInInfoIsSandboxedKey):
        Deprecate the old keys.

        * UIProcess/WebLoaderClient.cpp:
        (WebKit::WebLoaderClient::didFailToInitializePlugin):
        (WebKit::WebLoaderClient::didBlockInsecurePluginVersion):
        (WebKit::WebLoaderClient::pluginLoadPolicy):
        * UIProcess/WebLoaderClient.h:
        * UIProcess/WebUIClient.cpp:
        (WebKit::WebUIClient::unavailablePluginButtonClicked):
        * UIProcess/WebUIClient.h:
        Optimize for the most recent callback type which takes a dictionary,
        and pull out the necessary bits from it for deprecated callbacks as necessary.

        * UIProcess/WebPageProxy.h:
        * UIProcess/WebPageProxy.cpp:
        (WebKit::WebPageProxy::findPlugin):
        (WebKit::WebPageProxy::unavailablePluginButtonClicked):
        (WebKit::WebPageProxy::didFailToInitializePlugin):
        (WebKit::WebPageProxy::didBlockInsecurePluginVersion):
        Use createPluginInformationDictionary() consistently, to get consistent results for callbacks.

        * WebKit2.xcodeproj/project.pbxproj:
        Add new files.

2013-05-10  Brian J. Burg  <burg@cs.washington.edu>

        Web Inspector: implement runOpenPanel callback for WebKit2 inspector
        https://bugs.webkit.org/show_bug.cgi?id=115865

        Reviewed by Sam Weinig.

        * UIProcess/WebInspectorProxy.h:
        (WebKit::WebInspectorProxy::inspectorWindow):
        Add an accessor for m_inspectorWindow.

        * UIProcess/mac/WebInspectorProxyMac.mm:
        (WebKit::runOpenPanel):
        Show the open panel dialog when requested.

        (WebKit::WebInspectorProxy::platformCreateInspectorPage):
        Register the callback when the inspector page is created.

2013-05-10  Jesus Sanchez-Palencia  <jesus.palencia@openbossa.org>

        [WK2][CoordinatedGraphics] WKViewSetThemePath is EFL specific
        https://bugs.webkit.org/show_bug.cgi?id=115928

        Reviewed by Kenneth Rohde Christiansen.

        WKViewSetThemePath was moved to WKViewEfl.h since it is EFL specific.

        * UIProcess/API/C/CoordinatedGraphics/WKView.cpp:
        * UIProcess/API/C/CoordinatedGraphics/WKView.h:
        * UIProcess/API/C/efl/WKViewEfl.cpp:
        (WKViewSetThemePath):
        * UIProcess/API/C/efl/WKViewEfl.h:
        * UIProcess/CoordinatedGraphics/WebView.cpp:
        * UIProcess/CoordinatedGraphics/WebView.h:
        (WebView):
        * UIProcess/efl/ViewClientEfl.cpp:
        * UIProcess/efl/WebInspectorProxyEfl.cpp:
        * UIProcess/efl/WebViewEfl.cpp:
        (WebKit::WebViewEfl::setThemePath):
        * UIProcess/efl/WebViewEfl.h:
        (WebViewEfl):

2013-05-10  Jer Noble  <jer.noble@apple.com>

        REGRESSION (r149439): Video turns blank upon entering full screen for the first time
        https://bugs.webkit.org/show_bug.cgi?id=115617

        Reviewed by Eric Carlson.

        Partially revert the change introduced in r149439 for OS X 10.8 and previous. On these
        platforms, create a window with a NSZeroSize initial frame, which fixes the "blank"
        first-full screen behavior.

        * UIProcess/API/mac/WKView.mm:
        (-[WKView createFullScreenWindow]):

2013-05-10  Zan Dobersek  <zdobersek@igalia.com>

        [WK2] Make the WebSoupRequestManager a supplement to the WebProcess
        https://bugs.webkit.org/show_bug.cgi?id=115717

        Reviewed by Andreas Kling.

        WebSoupRequestManager should inherit from WebProcessSupplement and should be used as such
        by the WebProcess. This removes the need for the m_soupRequestManager member variable in
        the WebProcess class and brings the WebSoupRequestManager in line with other manager classes
        of which instances are controlled by the WebProcess class.

        * WebProcess/WebProcess.cpp:
        (WebKit::WebProcess::WebProcess): Add  the WebSoupRequestManager as a supplement.
        * WebProcess/WebProcess.h:
        (WebProcess): Remove the m_soupRequestManager member variable and its getter method.
        * WebProcess/soup/WebKitSoupRequestGeneric.cpp:
        (webkitSoupRequestGenericSendAsync): Access the WebSoupRequestManager as a supplement.
        (webkitSoupRequestGenericSendFinish): Ditto.
        * WebProcess/soup/WebProcessSoup.cpp:
        (WebKit::WebProcess::platformInitializeWebProcess): Access the WebSoupRequestManager as a supplement.
        * WebProcess/soup/WebSoupRequestManager.cpp:
        (WebKit::WebSoupRequestManager::supplementName): Specify the supplement's name.
        * WebProcess/soup/WebSoupRequestManager.h:
        (WebSoupRequestManager): Inherit from the WebProcessSupplement interface.

2013-05-10  Carlos Garcia Campos  <cgarcia@igalia.com>

        [GTK] Remove unnecessary GLIB_CHECK_VERSION #ifdefs
        https://bugs.webkit.org/show_bug.cgi?id=115904

        Reviewed by Martin Robinson.

        * UIProcess/API/gtk/tests/TestInspectorServer.cpp:
        (startTestServerMonitor):
        * UIProcess/API/gtk/tests/TestWebKitAccessibility.cpp:
        (startTestServerMonitor):

2013-05-09  Anders Carlsson  <andersca@apple.com>

        Fix build.

        * WebProcess/InjectedBundle/API/mac/WKWebProcessPlugIn.mm:

2013-05-09  Anders Carlsson  <andersca@apple.com>

        Enable UI process storage
        https://bugs.webkit.org/show_bug.cgi?id=115879
        <rdar://problem/12239765>

        Reviewed by Beth Dakin.

        * WebProcess/WebCoreSupport/WebPlatformStrategies.cpp:
        Flip the switch.

2013-05-09  Anders Carlsson  <andersca@apple.com>

        Remove extra spaces between right angle brackets in template declarations
        https://bugs.webkit.org/show_bug.cgi?id=115877

        Reviewed by Beth Dakin.

        C++11 doesn't require spaces between right angle brackets so remove all of them.

        * NetworkProcess/FileAPI/NetworkBlobRegistry.cpp:
        (WebKit::NetworkBlobRegistry::registerBlobURL):
        (WebKit::NetworkBlobRegistry::sandboxExtensions):
        * NetworkProcess/FileAPI/NetworkBlobRegistry.h:
        (NetworkBlobRegistry):
        * NetworkProcess/HostRecord.h:
        (HostRecord):
        * NetworkProcess/NetworkConnectionToWebProcess.cpp:
        (WebKit::NetworkConnectionToWebProcess::didReceiveMessage):
        (WebKit::NetworkConnectionToWebProcess::didClose):
        (WebKit::NetworkConnectionToWebProcess::registerBlobURL):
        * NetworkProcess/NetworkConnectionToWebProcess.h:
        (NetworkConnectionToWebProcess):
        * NetworkProcess/NetworkProcess.h:
        (NetworkProcess):
        * NetworkProcess/NetworkResourceLoadScheduler.cpp:
        (WebKit::NetworkResourceLoadScheduler::servePendingRequests):
        (WebKit::NetworkResourceLoadScheduler::removeScheduledLoaders):
        * NetworkProcess/NetworkResourceLoadScheduler.h:
        * NetworkProcess/SchedulableLoader.cpp:
        (WebKit::SchedulableLoader::SchedulableLoader):
        * NetworkProcess/SchedulableLoader.h:
        (SchedulableLoader):
        * Platform/CoreIPC/ArgumentCoders.h:
        * Platform/CoreIPC/Connection.cpp:
        (Connection::SyncMessageState):
        (CoreIPC::Connection::waitForMessage):
        (CoreIPC::Connection::processIncomingMessage):
        * Platform/CoreIPC/Connection.h:
        (Connection):
        * Platform/WorkQueue.h:
        (WorkQueue):
        * PluginProcess/PluginProcess.h:
        (PluginProcess):
        * Scripts/webkit2/messages_unittest.py:
        (CoreIPC):
        * Shared/BlockingResponseMap.h:
